/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          pattern.cpp  -  description
                             -------------------
    begin                : ven jan 23 2004
    copyright            : (C) 2004 by avila
    email                : avila@deimos
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "pattern.h"
#include "math.h"

#include "iostream"
using namespace std;

/***********************
Pattern salle
*/

void
Generator::patternSallePre (GeneratorSalle * sub, ostream & os)
{
  ListIndex li = trouveLien (sub);

  switch (sub->environnement)
    {
    case ENV_MINE:
      switch (sub->type)
	{
	case SALLE_COULOIR:
	  patternMineCouloir (sub, os);
	case SALLE_EXTERIEUR:
	  patternMineSalleExterieur (sub, os);
	default:
	  patternMineSalle (sub, os);
	};
      break;
    }
};

void
Generator::patternSalleCompute (GeneratorSalle * sub, ostream & os)
{
}

void
Generator::patternSalleFinal (GeneratorSalle * sub, ostream & os)
{
  switch (sub->environnement)
    {
    case ENV_MINE:
      patternMineSalleFinal (sub, os);
      break;
    }
}

/***********************
Pattern lien
*/

void
Generator::patternLienPre (GeneratorLien * lien, ostream & os)
{
};

void
Generator::patternLienCompute (GeneratorLien * lien, ostream & os)
{
};

void
Generator::patternLienFinal (GeneratorLien * lien, ostream & os)
{
};

/***********************
Pattern objet
*/
#include "../src/script_nom.h"
#include "../src/script_nom.cpp"

void
Generator::patternObjetPre (GeneratorSalle * sub, ostream & os)
{
  switch (sub->type)
    {
    case SALLE_DEBUT:
      {
	position p =
	  sub->placementBloc.getMax () + sub->placementBloc.getMin () + position( 1, 1, 1);
	p = p * 0.5;
	p = p + position (0, 0, 0.5);
	os << "SpawnJoueur { Position {" << p.printString () << "} }" << endl;
      }
      break;
    case SALLE_FIN:
      {
	position diff =
	  sub->placementBloc.getMax () +
	  sub->placementBloc.getMin () * (-1);
	position p =
	  sub->placementBloc.getMin () + position (1, 1, 0);
	p=p+position(diff.coord[0] * 0.5 ,
		     diff.coord[1] * 0.5 ,
		     0);
	
	os << "Option { Sortie; Position {" << p.printString () << "} }" << endl;
      }
      break;
    default:
      {
	position p =
	  sub->placementBloc.getMax () + sub->placementBloc.getMin () +
	  position (1, 1, 0);
	p = p * 0.5;
	// Affichage des options, armes, munitions, ...
	for (int i = 0; i != MAX_ARME; i++)
	  {
	    //printf("ARME %i %i\n<BR>",i,sub->nbArme[i]);
	    for (int j = 0; j != sub->nbArme[i]; j++)
	      {
		position diff =
		  sub->placementBloc.getMax () +
		  sub->placementBloc.getMin () * (-1);
		position p =
		  sub->placementBloc.getMin () + position (1, 1, 0);
		p = p;		//+position(
		//random()%int(diff.coord[0]),
		//random()%int(diff.coord[1]),0);
		os <<
		  "Option { " <<
		  tableau_association[CONSTANTE_SCRIPT_ARME1 + i] <<
		  ";  Position {" << p.printString () << "} }" << endl;
	      }
	  }
	for (int i = 0; i != MAX_MUNITION; i++)
	  {
	    //printf("MUNITION %i %i\n<BR>",i,sub->nbMunition[i]);    
	    for (int j = 0; j != sub->nbMunition[i]; j++)
	      {
		position diff =
		  sub->placementBloc.getMax () +
		  sub->placementBloc.getMin () * (-1);
		position p =
		  sub->placementBloc.getMin () + position (1, 1, 1);
		p = p * 0.5;
		//p=p+position(
		//      random()%int(diff.coord[0]),
		//      random()%int(diff.coord[1]),0);
		os <<
		  "Option { " <<
		  tableau_association[CONSTANTE_SCRIPT_MUNITION1 + i] <<
		  ";  Position {" << p.printString () << "} }" << endl;
	      }
	  }
	for (int i = 0; i != MAX_NAIN; i++)
	  {
	    for (int j = 0; j != sub->nbNain[i]; j++)
	      {
		position diff =
		  sub->placementBloc.getMax () +
		  sub->placementBloc.getMin () * (-1);
		position p =
		  sub->placementBloc.getMin () + position (1, 1, 1);
		p=p+position(
			     random()%int(diff.coord[0]),
			     random()%int(diff.coord[1]),0);
		os <<
		  "NDJ { " <<
		    " Position {" << p.printString () << "} }" << endl;
	      }
	  }
      }
      break;
    }
};

void
Generator::patternObjetCompute (GeneratorSalle * sub, ostream & os)
{
}

void
Generator::patternObjetFinal (GeneratorSalle * sub, ostream & os)
{
}

/***************************************************************************
 *            MINE                                                         *
 ***************************************************************************/
  //vector<EnsemblePoint> listPoint;

RefPoint
PointSalle::ajoutePoint (position r, position normale, position prev,
			 position next, int indice)
{
  position orientation = (prev - r) + (next - r);
  RefPoint ret;
  int i;
  for (i = 0; i != listePoint.size (); i++)
    {
      if (listePoint[i].root == r)
	break;
    }
  if (i == listePoint.size ())
    {
      EnsemblePoint ep;
      ep.root = r;
      listePoint.insert (listePoint.end (), ep);
    }
  EnsemblePoint & ep = listePoint[i];
  ep.refFacette.insert (ep.refFacette.end (), indice);
  ret.point = i;
  for (i = 0; i != ep.attached.size (); i++)
    {
      if (ep.attached[i].normale == normale)
	break;
    }
  if (i == ep.attached.size ())
    {
      EnsembleNormale en;
      en.normale = normale;
      ep.attached.insert (ep.attached.end (), en);
    }
  EnsembleNormale & en = ep.attached[i];
  ret.normale = i;

  for (i = 0; i != en.orientation.size (); i++)
    {
      if (en.orientation[i].orientation == orientation)
	break;
    }
  if (i == en.orientation.size ())
    {
      EnsembleOrientation eo;
      eo.orientation = orientation;
      en.orientation.insert (en.orientation.end (), eo);
    }
  EnsembleOrientation & eo = en.orientation[i];
  ret.orientation = i;

  return ret;
};

void
PointSalle::calculFinal ()
{
  for (int i = 0; i != listePoint.size (); i++)
    {
      EnsemblePoint & ep = listePoint[i];
      for (int j = 0; j != ep.attached.size (); j++)
	{
	  EnsembleNormale & en = ep.attached[j];
	  // Raliser la somme des orientations pour une normale donne.
	  position somme;
	  for (int k = 0; k != en.orientation.size (); k++)
	    {
	      somme = somme + en.orientation[k].orientation;
	    }
	  en.balance = somme * (1.0 / float (en.orientation.size ()));
	  en.finale = ep.root + (en.normale) * (0.8)
	    + (en.balance) * (0.4)
	    + position (rand () * 20.0 / RAND_MAX - 10.0,
			rand () * 20.0 / RAND_MAX - 10.0,
			rand () * 20.0 / RAND_MAX - 10.0);
	  ;
	  /*
	     printf("root  finale normale\n");
	     ep.root.print();
	     en.finale.print();      
	     en.normale.print();
	   */
	}
    }
};

void
UniversPoint::insert (position p1, position p2, position p3, position p4,
		      TableauFacette & tf, string texture, position normale)
{
  p1 = p1 * 100;
  p2 = p2 * 100;
  p3 = p3 * 100;
  p4 = p4 * 100;
  position u = p2 - p1;
  position v = p3 - p1;

  position n ((u.coord[1] * v.coord[2] - u.coord[2] * v.coord[1]),
	      (u.coord[2] * v.coord[0] - u.coord[0] * v.coord[2]),
	      (u.coord[0] * v.coord[1] - u.coord[1] * v.coord[0]));

  float t = sqrt (float (float (n.coord[0]) * float (n.coord[0]) +
			 float (n.coord[1]) * float (n.coord[1]) +
			 float (n.coord[2]) * float (n.coord[2])));

  FacetteInt fi;
  int indice = tf.size ();
  fi.insert (fi.end (), ps.ajoutePoint (p1, normale, p2, p4, indice));
  fi.insert (fi.end (), ps.ajoutePoint (p2, normale, p1, p3, indice));
  fi.insert (fi.end (), ps.ajoutePoint (p3, normale, p2, p4, indice));
  fi.insert (fi.end (), ps.ajoutePoint (p4, normale, p3, p1, indice));
  fi.texture = texture;
  tf.insert (tf.end (), fi);
};

// pour raliser le trac final...

// une liste pour les bords dj tracs...
struct BordTrace
{
  int p0, p1;
};
typedef vector < BordTrace > ListeBordTrace;



void
UniversPoint::traceFinal (ostream & os, TableauFacette & tf, int start,
			  int end)
{
  // une liste pour les bords dj tracs...    
  ListeBordTrace lbt;

  // liste des noeuds de coin...
  vector < int >coin;

  string tex;
  for (int i = start; i != end; i++)
    {
      FacetteInt & fi = tf[i];
      if (tex != fi.texture)
	{
	  tex = fi.texture;
	  os << "Texture { Fichier=\"" << tex << "\"; }" << endl;
	}
      position p = ps.listePoint[fi[0].point].root;
      position p2 = ps.listePoint[fi[2].point].root;
      bool x = ((p.coord[0] - p2.coord[0]) != 0.0);
      bool y = ((p.coord[1] - p2.coord[1]) != 0.0);
      bool z = ((p.coord[2] - p2.coord[2]) != 0.0);
      for (int j = 0; j != fi.size () - 1; j++)
	{
	  os << "Facette {" << endl;
	  int p0 = fi[0].point;
	  int n0 = fi[0].normale;
	  int pj = fi[j].point;
	  int nj = fi[j].normale;
	  int pjp1 = fi[j + 1].point;
	  int njp1 = fi[j + 1].normale;
	  os << "Point { " << ps.listePoint[p0].attached[n0].finale.
	    printString (100, x, y, z) << "}" << endl;
	  os << "Point { " << ps.listePoint[pj].attached[nj].finale.
	    printString (100, x, y, z) << "}" << endl;
	  os << "Point { " << ps.listePoint[pjp1].attached[njp1].finale.
	    printString (100, x, y, z) << "}" << endl;
	  os << "}" << endl;
	};
      // Maintenant, crer les bords...
      // regarder pour tous les bords, les bords adjacents...
      for (int j = 0; j != fi.size (); j++)
	{
	  int p0 = fi[j].point;
	  int p1 = fi[0].point;
	  if (j + 1 != fi.size ())
	    p1 = fi[j + 1].point;
	  for (int kindice = 0;
	       kindice != ps.listePoint[fi[j].point].refFacette.size ();
	       kindice++)
	    {
	      int k = ps.listePoint[fi[j].point].refFacette[kindice];
	      FacetteInt & fi2 = tf[k];
	      for (int l = 0; l != fi2.size (); l++)
		{
		  int pp0 = fi2[l].point;
		  int pp1 = fi2[0].point;
		  if (l + 1 != fi2.size ())
		    pp1 = fi2[l + 1].point;
		  bool check = false;
		  for (int test = 0; test != lbt.size (); test++)
		    {
		      if (((p0 == lbt[test].p0) && (p1 == lbt[test].p1)) ||
			  ((p1 == lbt[test].p0) && (p0 == lbt[test].p1)))
			check = true;
		    }
		  if ((p0 == pp1) && (p1 == pp0) && !check)
		    {
		      BordTrace bt;
		      bt.p0 = p0;
		      bt.p1 = p1;
		      lbt.insert (lbt.end (), bt);

		      os << "Facette {" << endl;

		      int n0 = fi[j].normale;
		      int n1 = fi[0].normale;
		      if (j + 1 != fi.size ())
			n1 = fi[j + 1].normale;

		      int nn0 = fi2[l].normale;
		      int nn1 = fi2[0].normale;
		      if (l + 1 != fi2.size ())
			nn1 = fi2[l + 1].normale;

		      os << "Point { "
			<< ps.listePoint[pp0].attached[nn0].finale.
			printString (100, x, y, z) << "}" << endl;
		      os << "Point { " << ps.listePoint[p1].attached[n1].
			finale.printString (100, x, y, z) << "}" << endl;
		      os << "Point { " << ps.listePoint[p0].attached[n0].
			finale.printString (100, x, y, z) << "}" << endl;

		      os << " } Facette {" << endl;

		      os << "Point { "
			<< ps.listePoint[pp1].attached[nn1].finale.
			printString (100, x, y, z) << "}" << endl;
		      os << "Point { " << ps.listePoint[pp0].attached[nn0].
			finale.printString (100, x, y, z) << "}" << endl;
		      os << "Point { " << ps.listePoint[p0].attached[n0].
			finale.printString (100, x, y, z) << "}" << endl;

		      os << "}" << endl;

		    };
		};
	    }
	}
      // Maintenant, on s'occupe des coins.

      for (int j = 0; j != fi.size (); j++)
	{
	  int p0 = fi[j].point;
	  EnsemblePoint & ep = ps.listePoint[fi[j].point];
	  if (ep.attached.size () >= 3)
	    {
	      bool check = false;
	      for (int test = 0; test != coin.size (); test++)
		{
		  if (p0 == coin[test])
		    check = true;
		}
	      if (!check)
		{
		  coin.insert (coin.end (), p0);
		  // un bord...
		  os << "Facette {" << endl;
		  for (int kindice = 0; kindice != ep.attached.size ();
		       kindice++)
		    {
		      position p = ep.attached[kindice].finale;
		      os << "Point { "
			<< p.printString (100, x, y, z) << "}" << endl;
		    }
		  os << "}" << endl;
		  os << "Facette {" << endl;
		  for (int kindice = ep.attached.size () - 1; kindice != -1;
		       kindice--)
		    {
		      position p = ep.attached[kindice].finale;
		      os << "Point { "
			<< p.printString (100, x, y, z) << "}" << endl;
		    }
		  os << "}" << endl;
		}
	    }
	}

      /*
         {
         os << "Facette {" << endl;  
         position p=ps.listePoint[fi[0].point].root;
         position p2=ps.listePoint[fi[2].point].root;
         bool x=((p.coord[0]-p2.coord[0])!=0.0);
         bool y=((p.coord[1]-p2.coord[1])!=0.0);
         bool z=((p.coord[2]-p2.coord[2])!=0.0);
         for (int j=0;j!=fi.size();j++)
         {
         int p=fi[j].point;
         int n=fi[j].normale;
         os << "Point { " << ps.listePoint[p].root.printString(100,x,y,z) <<  "}" << endl;
         };
         os << "}" << endl;
         }
       */
    }
};

UniversPoint up;

/// pour tracer un portal uniquement... 
void
UniversPoint::facette (ostream & os, position centre, int rotation, float c)
{
  position tab[4];
  int ptab = 0;
  os << "Facette {" << endl;
  for (int i = -1; i < 2; i += 2)
    for (int j = -1; j < 2; j += 2)
      {
	position pp (i, 0, j * i);
	int co = (int) cos (rotation * M_PI / 2);
	int si = (int) sin (rotation * M_PI / 2);
	position p (+pp.coord[0] * c * co,
		    -pp.coord[0] * c * si, pp.coord[2]);
	p = p + centre;
	os << "Point { " << p.printString () << "}" << endl;
	tab[ptab++] = p;
      }
  os << "}" << endl;
};

void
facette_tourne (ostream & os, position pos[], position centre, int rotation,
		float c)
{
  os << "Facette {" << endl;
  if (rotation == 0)
    rotation = 2;
  else if (rotation == 2)
    rotation = 0;
  rotation += 2;
  for (int i = 0; i < 4; i++)
    {
      position pp = pos[i];
      int co = (int) cos (rotation * M_PI / 2);
      int si = (int) sin (rotation * M_PI / 2);
      position p (+pp.coord[0] * c * co - pp.coord[1] * c * si,
		  pp.coord[0] * c * si + pp.coord[1] * c * co, pp.coord[2]);
      p = p + centre;
      os << "Point { " << p.printString () << "}" << endl;
    }
  os << "}" << endl;
}

void
UniversPoint::marche (ostream & os, position centre, int rotation, float c,
		      int hauteur)
{
  position centre2 = centre + position ();
  position pp[4];

  pp[0] = position (hauteur, hauteur * 2.5, -hauteur - c);
  pp[1] = position (hauteur, 0.4, -c + 0.1);
  pp[2] = position (-hauteur, 0.4, -c + 0.1);
  pp[3] = position (-hauteur, hauteur * 2.5, -hauteur - c);
  facette_tourne (os, pp, centre, rotation, c);

  pp[0] = position (hauteur, 0.4, -c + 0.1);
  pp[1] = position (hauteur, 0, -c + 0.1);
  pp[2] = position (-hauteur, 0, -c + 0.1);
  pp[3] = position (-hauteur, 0.4, -c + 0.1);
  facette_tourne (os, pp, centre, rotation, c);

  pp[0] = position (hauteur, 0, -c + 0.1);
  pp[1] = position (hauteur, 0.4, -c + 0.1);
  pp[2] = position (hauteur, hauteur * 2.5, -c - hauteur);
  pp[3] = position (hauteur, 0.4, -c - hauteur);
  facette_tourne (os, pp, centre, rotation, c);

  pp[3] = position (-hauteur, 0, -c + 0.1);
  pp[2] = position (-hauteur, 0.4, -c + 0.1);
  pp[1] = position (-hauteur, hauteur * 2.5, -c - hauteur);
  pp[0] = position (-hauteur, 0.4, -c - hauteur);
  facette_tourne (os, pp, centre, rotation, c);

};


void
UniversPoint::facette (ostream & os, int c, int c1, int c2, position base,
		       bool ordre, int taille, string tex,
		       TableauFacette & tf, position normale)
{
  position p1, p2, p3, p4;

  int v = int (base.coord[c]);
  int c1m = int (base.coord[c1]);
  int c1M = int (base.coord[c1] + taille);
  int c2m;
  int c2M;
  if (ordre)
    {
      c2m = int (base.coord[c2]);
      c2M = int (base.coord[c2] + taille);
    }
  else
    {
      c2M = int (base.coord[c2]);
      c2m = int (base.coord[c2] + taille);
    };

  p1.coord[c] = v;
  p2.coord[c] = v;
  p3.coord[c] = v;
  p4.coord[c] = v;

  p1.coord[c1] = c1m;
  p1.coord[c2] = c2m;

  p2.coord[c1] = c1M;
  p2.coord[c2] = c2m;

  p3.coord[c1] = c1M;
  p3.coord[c2] = c2M;

  p4.coord[c1] = c1m;
  p4.coord[c2] = c2M;

  p1 = p1;
  p2 = p2;
  p3 = p3;
  p4 = p4;

  up.insert (p1, p2, p3, p4, tf, tex, normale);

}

void
getCentreRotation (ListBloc & salle, listBloc & lien, int &rotation,
		   position & centre, bool invert)
{
  position sm = salle.getMin ();
  position sM = salle.getMax ();
  position lm = lien.getMin ();
  position lM = lien.getMax ();

  centre = (lien.getMax () + lien.getMin () + position (1, 1, 1)) * (0.5);

  if (lM.coord[0] <= sm.coord[0])
    {

      if (invert)
	{
	  rotation = 1;
	  //centre=lien.getMax();
	  cerr << "-----------rotation " << int2string (rotation) << endl;
	  return;
	}
      else
	{
	  rotation = 3;
	  //centre=lien.getMax();
	  cerr << "-----------rotation inv " << int2string (rotation) << endl;
	  return;
	}

    }

  if (lM.coord[1] <= sm.coord[1])
    {
      if (invert)
	{
	  rotation = 0;
	  //centre=lien.getMax();
	  cerr << "-----------rotation " << int2string (rotation) << endl;
	  return;
	}
      else
	{
	  rotation = 2;
	  //centre=lien.getMax();
	  cerr << "-----------rotation inv " << int2string (rotation) << endl;
	  return;
	}
    }

  if (sM.coord[0] <= lm.coord[0])
    {
      if (invert)
	{
	  rotation = 3;
	  //centre=lien.getMax()-position(-1,0,0);
	  cerr << "-----------rotation " << int2string (rotation) << endl;
	  return;
	}
      else
	{
	  rotation = 1;
	  //centre=lien.getMax()-position(-1,0,0);
	  cerr << "-----------rotation inv" << int2string (rotation) << endl;
	  return;
	}
    }

  if (sM.coord[1] <= lm.coord[1])
    {
      // BON
      if (invert)
	{
	  rotation = 2;
	  //centre=lien.getMax()-position(0,-1,0);
	  cerr << "-----------rotation " << int2string (rotation) << endl;
	  return;
	}
      else
	{
	  rotation = 0;
	  //centre=lien.getMax()-position(0,-1,0);
	  cerr << "-----------rotation inv " << int2string (rotation) << endl;
	  return;
	}
    }
  // Pas de solution...
  rotation = -1;
};

void
Generator::patternMineSalle (GeneratorSalle * sub, ostream & os)
{
  sub->data = new EnvDataMine ();
  char texName[100];
  int i = int (rand () * 16.0 / RAND_MAX);
  sprintf (texName, "d_mine/cave%i.pcx", i);
  TableauFacette & tf = ((EnvDataMine *) sub->data)->tfGlobal;
  EnvDataMine & dmine = *(EnvDataMine *) sub->data;
  dmine.start = dmine.tfGlobal.size ();
  ListBloc & blocLien = dmine.blocLien;
  ListBloc & blocLienPere = dmine.blocLienPere;
  ListBloc & blocVoisin = dmine.blocVoisin;
  ListIndex li = trouveLien (sub);
  for (int i = 0; i != li.size (); i++)
    {
      GeneratorLien & gl = getLien (li[i]);
      blocLien = blocLien + gl.connection;
      //if (gl.salles[0].salle==sub)
      {
	blocLienPere = blocLienPere + gl.connection;
	blocVoisin = blocVoisin + gl.salles[1].salle->placementBloc;
	//ajout
	blocVoisin = blocVoisin + gl.salles[0].salle->placementBloc;
      }
      //else blocVoisin=blocVoisin+gl.connection;
    };
  // Somme des liens
  // Pour chaque point trouver si il est a cote d'un autre...
  ListBloc l = sub->placementBloc + blocLienPere;
  //ListBloc l=sub->placementBloc+blocVoisin;
  for (int i = 0; i != l.size (); i++)
    {
      position p = l[i];
      for (int c = 0; c != 3; c++)
	{
	  for (int pm = -1; pm != 3; pm += 2)
	    {
	      position pplus;
	      pplus.coord[c] = pm;
	      position p2 = p + pplus;
	      if (!l.testInclus (p2))	// C'est un bord...
		{
		  // tester si il y a un lien...          
		  if (!blocVoisin.testInclus (p2))
		    {
		      position pbase = p;
		      if (pm == 1)
			pbase = p2;
		      string nfac;
		      if (sub->placementBloc.testInclus (p))
			nfac = texName;
		      else
			nfac = "d_mine/cave7.pcx";
		      // C'est bon, c'est une facette a tracer...
		      if (pplus == position (-1, 0, 0))
			up.facette (os, 0, 1, 2, pbase, false, 1, nfac, tf,
				    pplus);
		      if (pplus == position (1, 0, 0))
			up.facette (os, 0, 1, 2, pbase, true, 1, nfac, tf,
				    pplus);

		      if (pplus == position (0, -1, 0))
			up.facette (os, 1, 0, 2, pbase, true, 1, nfac, tf,
				    pplus);
		      if (pplus == position (0, 1, 0))
			up.facette (os, 1, 0, 2, pbase, false, 1, nfac, tf,
				    pplus);

		      if (pplus == position (0, 0, -1))
			up.facette (os, 2, 0, 1, pbase, false, 1, nfac, tf,
				    pplus);
		      if (pplus == position (0, 0, 1))
			up.facette (os, 2, 0, 1, pbase, true, 1, nfac, tf,
				    pplus);
		    }
		}
	    }
	}
    }
  dmine.end = dmine.tfGlobal.size ();
};

void
Generator::patternMineSalleFinal (GeneratorSalle * sub, ostream & os)
{
  static bool calcFinal = false;
  if (!calcFinal)
    {
      calcFinal = true;
      up.ps.calculFinal ();
    };

  // nom
  string nom = "Salle" + int2string (sub->numero);
  string texture;
  // en-tete
  os << "Objet {" << endl << "Nom=\"" << nom << "\";" << endl << "Source { "
    << endl;

  ListIndex li = trouveLien (sub);
  for (int i = 0; i != li.size (); i++)
    {
      GeneratorLien & gl = getLien (li[i]);
      if (gl.salles[0].salle == sub)
	{
	  position centre;
	  int rotation;
	  cerr << "TEST DES LIENS ...\n";
	  getCentreRotation (gl.salles[0].salle->placementBloc, gl.connection,
			     rotation, centre, true);
	  if (rotation != -1)
	    {
	      os << "Portal {" << endl;
	      up.facette (os, centre, rotation, 1.0);
	      os << "Objet=\"Salle" << int2string (gl.salles[1].salle->
						   numero) << "\"; }" << endl;
	    }
	}
      else
	{
	  position centre;
	  int rotation;
	  cerr << "TEST DES LIENS ...\n";
	  getCentreRotation (gl.salles[0].salle->placementBloc, gl.connection,
			     rotation, centre, false);
	  if (rotation != -1)
	    {
	      os << "Portal {" << endl;
	      up.facette (os, centre, rotation, 1.0);
	      os << "Objet=\"Salle" << int2string (gl.salles[0].salle->
						   numero) << "\"; }" << endl;
	    }
	}
    };
  TableauFacette & tf = ((EnvDataMine *) sub->data)->tfGlobal;
  EnvDataMine & dmine = *(EnvDataMine *) sub->data;
  // rajouter des artefacts comme des "pilliers" et autres.
  int longueur, largeur;
  float taille;
  position voltaille =
    sub->placementBloc.getMax () - sub->placementBloc.getMin ();
  position centre =
    (sub->placementBloc.getMax () + sub->placementBloc.getMin ()) * (0.5);
  float volume = voltaille.coord[0] * voltaille.coord[1] * voltaille.coord[2];
  if (volume > 20)
    {
      if (rand () % 2 == 0)
	os << "Texture { Fichier=\"d_mine/bois01.pcx\"; } " << endl;
      else
	os << "Texture { Fichier=\"d_mine/bois02.pcx\"; } " << endl;
      longueur = int (rand () * 3.0 / RAND_MAX + 1);
      largeur = int (rand () * 3.0 / RAND_MAX + 1);
      taille = rand () * 0.2 / RAND_MAX + 0.3;
      for (int L = 0; L != longueur; L++)
	for (int l = 0; l != largeur; l++)
	  {
	    // poser un pillier... = poser 4 murs.
	    position z0 (0, 0, sub->placementBloc.getMin ().coord[2]);
	    position z1 (0, 0, sub->placementBloc.getMax ().coord[2] + 1.0);
	    position pcentre (voltaille.coord[0] * (L + 0.5) / longueur +
			      sub->placementBloc.getMin ().coord[0],
			      voltaille.coord[1] * (l + 0.5) / largeur +
			      sub->placementBloc.getMin ().coord[1], 0);
	    position pcentre0 = pcentre;
	    position pcentre1 = pcentre + position (0, taille, 0);
	    position pcentre2 = pcentre + position (taille, taille, 0);
	    position pcentre3 = pcentre + position (taille, 0, 0);

	    position z0p0 = pcentre0 + z0;
	    position z0p1 = pcentre1 + z0;
	    position z0p2 = pcentre2 + z0;
	    position z0p3 = pcentre3 + z0;

	    position z1p0 = pcentre0 + z1;
	    position z1p1 = pcentre1 + z1;
	    position z1p2 = pcentre2 + z1;
	    position z1p3 = pcentre3 + z1;

	    os << "Facette {" << endl;
	    os << "Point { " << z0p0.printString () << "}" << endl;
	    os << "Point { " << z0p1.printString () << "}" << endl;
	    os << "Point { " << z1p1.printString () << "}" << endl;
	    os << "Point { " << z1p0.printString () << "}" << endl;
	    os << "}" << endl;

	    os << "Facette {" << endl;
	    os << "Point { " << z0p1.printString () << "}" << endl;
	    os << "Point { " << z0p2.printString () << "}" << endl;
	    os << "Point { " << z1p2.printString () << "}" << endl;
	    os << "Point { " << z1p1.printString () << "}" << endl;
	    os << "}" << endl;

	    os << "Facette {" << endl;
	    os << "Point { " << z0p2.printString () << "}" << endl;
	    os << "Point { " << z0p3.printString () << "}" << endl;
	    os << "Point { " << z1p3.printString () << "}" << endl;
	    os << "Point { " << z1p2.printString () << "}" << endl;
	    os << "}" << endl;

	    os << "Facette {" << endl;
	    os << "Point { " << z0p3.printString () << "}" << endl;
	    os << "Point { " << z0p0.printString () << "}" << endl;
	    os << "Point { " << z1p0.printString () << "}" << endl;
	    os << "Point { " << z1p3.printString () << "}" << endl;
	    os << "}" << endl;

	  }
    }
  // Rajouter les marches pour monter d'un tage ou plus.
  for (int i = 0; i != li.size (); i++)
    {
      GeneratorLien & gl = getLien (li[i]);
      if (gl.connection.getMin ().coord[2] != sub->placementBloc.getMin ().coord[2])	// il y a une marche...
	{
	  bool local = false;
	  if (gl.salles[0].salle == sub)
	    local = true;
	  position centre;
	  int rotation;
	  getCentreRotation (gl.salles[0].salle->placementBloc, gl.connection,
			     rotation, centre, local);
	  if (rotation != -1)
	    {
	      up.marche (os, centre, rotation, 1.0, 1);
	    }
	}
    };


  up.traceFinal (os, tf, dmine.start, dmine.end);

  os << "}" << endl << "}" << endl;
}

void
Generator::patternMineSalleExterieur (GeneratorSalle *, ostream &)
{

};

void
Generator::patternMineCouloir (GeneratorSalle *, ostream &)
{

};

TableauFacette
  EnvDataMine::tfGlobal;
