/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          placement_spatial.cpp  -  description
                             -------------------
    begin                : lun jan 19 2004
    copyright            : (C) 2004 by avila
    email                : avila@deimos
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "generator.h"

#include <math.h>

/***************************************************************************
 *             listBloc                                                    *
 ***************************************************************************/

void
listBloc::save (ostream & os)
{
  os << int2string (size ()) << endl;
  for (int i = 0; i != size (); i++)
    {
      (*this)[i].save (os);
    }
};

void
listBloc::load (istream & os)
{
  int s;
  os >> s;
  for (int i = 0; i != s; i++)
    {
      position p;
      p.load (os);
      insert (end (), p);
    }
};

void
listBloc::translation (position p)
{
  for (int i = 0; i != size (); i++)
    (*this)[i] = (*this)[i] + p;
};

bool
listBloc::testConflit (listBloc & lb2)
{
  position m = getMin ();
  position M = getMax ();
  for (int j = 0; j != lb2.size (); j++)
    {
      position p2 = lb2[j];
      if ((p2 >= m) && (p2 <= M))
	for (int i = 0; i != size (); i++)
	  {
	    position p1 = (*this)[i];
	    if (p1 == p2)
	      return true;
	  }
    }
  return false;
};

listBloc
listBloc::etendUn ()
{
  listBloc ret = *this;
  for (int i = 0; i != size (); i++)
    {
      position pos = (*this)[i];
      for (int j = -1; j <= 1; j++)
	for (int k = -1; k <= 1; k++)
	  for (int l = -1; l <= 1; l++)
	    if ((j != 0) || (k != 0) || (l != 0))
	      ret.
		insertPosition (position
				(j + pos.coord[0], k + pos.coord[1],
				 l + pos.coord[2]));
    }
  return ret;
};

listBloc::listBloc (position min, position max)
{
  for (int i = int (min.coord[0]); i != int (max.coord[0]); i++)
    for (int j = int (min.coord[1]); j != int (max.coord[1]); j++)
      for (int k = int (min.coord[2]); k != int (max.coord[2]); k++)
	insertPosition (position (i, j, k));
};

listBloc::listBloc ()
{
}

position
listBloc::getMin ()
{
  position ret;
  if (size ())
    ret = (*this)[0];
  for (int i = 1; i < size (); i++)
    {
      position courant = (*this)[i];
      for (int j = 0; j < 3; j++)
	{
	  if (courant.coord[j] < ret.coord[j])
	    ret.coord[j] = courant.coord[j];
	}
    }
  return ret;
};

position
listBloc::getMax ()
{
  position ret;
  if (size ())
    ret = (*this)[0];
  for (int i = 1; i < size (); i++)
    {
      position courant = (*this)[i];
      for (int j = 0; j < 3; j++)
	{
	  if (courant.coord[j] > ret.coord[j])
	    ret.coord[j] = courant.coord[j];
	}
    }
  return ret;
};

bool
listBloc::inclus (listBloc & intoBloc)
{
  for (int i = 0; i != size (); i++)
    {
      position p = (*this)[i];
      listBloc test;
      test.insert (test.end (), p);
      if (!test.testConflit (intoBloc))
	return false;
    };
  return true;
};

listBloc
listBloc::operator+ (listBloc & plus)
{
  listBloc ret = plus;
  for (int i = 0; i != size (); i++)
    {
      position p = (*this)[i];
      ret.insertPosition (p);
    };
  return ret;
};

void
listBloc::insertPosition (position p)
{
  for (int i = 0; i != size (); i++)
    {
      position p2 = (*this)[i];
      if (p == p2)
	return;
    };
  insert (end (), p);
};

float
listBloc::distanceMin (listBloc & t)
{
  position d[2][8];
  position pMn[2][2];
  pMn[0][0] = getMin ();
  pMn[0][1] = getMax ();
  pMn[1][0] = t.getMin ();
  pMn[1][1] = t.getMax ();
  for (int i = 0; i != 2; i++)
    {
      for (int j = 0; j != 2; j++)
	{
	  for (int k = 0; k != 2; k++)
	    {
	      for (int l = 0; l != 2; l++)
		{
		  d[i][j + k * 2 + l * 4] =
		    position (pMn[i][j].coord[0], pMn[i][k].coord[1],
			      pMn[i][l].coord[2]);
		};
	    };
	};
    };
  float minDist = 10000;
  for (int i = 0; i != 8; i++)
    {
      for (int j = 0; j != 8; j++)
	{
	  float testDist = d[0][i].distanceNorme1 (d[1][j]);
	  //printf("testDir %i\n",testDist);
	  //d[0][i].print();
	  //d[1][j].print();
	  if (testDist < minDist)
	    minDist = testDist;
	};
    };
  //printf("minDist %i\n",minDist);
  return minDist;
};

bool
listBloc::testInclus (position p)
{
  for (int i = 0; i != size (); i++)
    {
      position p2 = (*this)[i];
      if (p == p2)
	return true;
    };
  return false;
};


/***************************************************************************
 *             POSITION                                                    *
 ***************************************************************************/

void
position::save (ostream & os)
{
  for (int i = 0; i != 3; i++)
    {
      os << coord[i] << endl;
    }
};

void
position::load (istream & os)
{
  for (int i = 0; i != 3; i++)
    {
      int c;
      os >> c;
      coord[i] = c;
    }
};

string
int2string (int i)
{
  char buffer[100];
  sprintf (buffer, "%i", i);
  return string (buffer);
};

string
float2string (float i)
{
  char buffer[100];
  sprintf (buffer, "%f", i);
  return string (buffer);
};

string
position::printString ()
{
  string ret;
  ret += " X=" + float2string (coord[0] * 2) + ";";
  ret += " Y=" + float2string (coord[1] * 2) + ";";
  ret += " Z=" + float2string (coord[2] * 2) + ";";
  return ret;
};

string
position::printString (int subdivision, bool x, bool y, bool z)
{
  string ret;
  ret += " X=" + float2string (coord[0] * 2.0 / float (subdivision)) + ";";
  ret += " Y=" + float2string (coord[1] * 2.0 / float (subdivision)) + ";";
  ret += " Z=" + float2string (coord[2] * 2.0 / float (subdivision)) + ";";
  float coeffx1 = 0, coeffy1 = 0, coeffz1 = 0, coeffx2 = 0, coeffy2 =
    0, coeffz2 = 0;
  if (x && y)
    {
      coeffx1 = 1.0;
      coeffy2 = 1.0;
    }
  if (y && z)
    {
      coeffy1 = 1.0;
      coeffz2 = 1.0;
    }
  if (z && x)
    {
      coeffz1 = 1.0;
      coeffx2 = 1.0;
    }
  ret +=
    " TX=" +
    float2string ((coord[0] * coeffx1 + coord[1] * coeffy1 +
		   coord[2] * coeffz1) * 0.5 / float (subdivision)) + ";";
  ret +=
    " TY=" +
    float2string ((coord[0] * coeffx2 + coord[1] * coeffy2 +
		   coord[2] * coeffz2) * 0.5 / float (subdivision)) + ";";
  return ret;
};


position
position::operator* (float x)
{
  position ret;
  for (int i = 0; i != 3; i++)
    ret.coord[i] = x * coord[i];
  return ret;
};

float
abs (float x)
{
  if (x < 0)
    return -x;
  return x;
}

float
position::distanceNorme1 (position & p)
{
  float ret = -10000;
  position m = p - (*this);
  for (int i = 0; i != 3; i++)
    if (abs (m.coord[i]) > ret)
      ret = abs (m.coord[i]);
  return ret;
};

float
position::distanceEuclidienne (position & p)
{
  float ret = 0;
  position m = p - (*this);
  ret =
    sqrt (m.coord[0] * m.coord[0] + m.coord[1] * m.coord[1] +
	  m.coord[2] * m.coord[2]);
  return ret;
};

void
position::print ()
{
  printf ("X %f Y %f Z %f \n", coord[0], coord[1], coord[2]);
};



position
position::operator+ (position pl)
{
  return position (pl.coord[0] + coord[0],
		   pl.coord[1] + coord[1], pl.coord[2] + coord[2]);
};

position
position::operator- (position pl)
{
  return position (-pl.coord[0] + coord[0],
		   -pl.coord[1] + coord[1], -pl.coord[2] + coord[2]);
};

bool
position::operator== (position pl)
{
  return (pl.coord[0] == coord[0]) && (pl.coord[1] == coord[1])
    && (pl.coord[2] == coord[2]);
};

bool
position::operator<= (position pl)
{
  return (coord[0] <= pl.coord[0]) && (coord[1] <= pl.coord[1])
    && (coord[2] <= pl.coord[2]);
};

bool
position::operator>= (position pl)
{
  return (coord[0] >= pl.coord[0]) && (coord[1] >= pl.coord[1])
    && (coord[2] >= pl.coord[2]);
};

position::position (float x, float y, float z)
{
  coord[0] = x;
  coord[1] = y;
  coord[2] = z;
};

position::position ()
{
  coord[0] = 0;
  coord[1] = 0;
  coord[2] = 0;
};

position
position::min (position m)
{
  position ret = m;
  for (int i = 0; i != 3; i++)
    if (ret.coord[i] > coord[i])
      ret.coord[i] = coord[i];
  return ret;
};

position
position::max (position m)
{
  position ret;
  for (int i = 0; i != 3; i++)
    if (ret.coord[i] < coord[i])
      ret.coord[i] = coord[i];
  return ret;
};

/***************************************************************************
 *             GENERATOR                                                   *
 ***************************************************************************/

void
Generator::creerCouloirArtificiel (GeneratorLien &, listBloc & P1,
				   listBloc & P2, ListBloc & monde)
{
}

// salle est bloque en (0,0,0)
ListPositionPossible
Generator::testConfig (ListBloc & salle, ListBloc & connectionPossible,
		       GeneratorSalle * sub, ListBloc & monde)
{
  /*
     printf("RAPPORT\n");
     connectionPossible.getMin().print();
     connectionPossible.getMax().print();
     printf("AVEC\n");
     salle.getMin().print();
     salle.getMax().print();
   */
  ListPositionPossible retour;
  ListIndex li = trouveLien (sub);
  position cubeMin, cubeMax;
  position taille;
  if (li.size () == 0)
    {
      PositionPossible pp;
      pp.position = salle;
      retour.insert (retour.begin (), pp);
      return retour;
    }
  taille = (salle.getMax () - salle.getMin ()) + position (3, 3, 3);
  for (int i = 0; i != li.size (); i++)
    {
      GeneratorLien & gl = getLien (li[i]);
      GeneratorSalle *next = gl.getSuivant (sub);
      BlocLien *courant;
      BlocLien *suivant;
      int suivantIndex = gl.getSuivant (sub, &courant, &suivant);
      if (i == 0)
	{
	  cubeMin = gl.connection.getMin ();
	  cubeMax = gl.connection.getMax ();
	};
      cubeMin = cubeMin.min (gl.connection.getMin ());
      cubeMax = cubeMax.max (gl.connection.getMax ());
    }
  cubeMin = (cubeMin - taille) - position (6, 6, 6);
  cubeMax = cubeMax + position (6, 6, 6);
  cubeMin.print ();
  cubeMax.print ();

  ListBloc salleTestOrig = salle;
  ListBloc salleTestEtenduOrig = salleTestOrig;
  //salleTestEtenduOrig=salleTestEtenduOrig.etendUn();
  ListBloc salleTestEtendu;
  // ListBloc mondeEtendu=monde;
  // mondeEtendu.etendUn();
  // Force brute : TESTER TOUTES LES POSSIBILITES... (si ca, c'est pas bourrinos !)
  for (int x = int (cubeMin.coord[0]); x <= int (cubeMax.coord[0]); x++)
    for (int y = int (cubeMin.coord[1]); y <= int (cubeMax.coord[1]); y++)
      for (int z = int (cubeMin.coord[2]); z <= int (cubeMax.coord[2]); z++)
	{
	  //printf("POSITION TEST\n");
	  //position(x,y,z).print();
	  salleTestEtendu = salleTestEtenduOrig;
	  salleTestEtendu.translation (position (x, y, z));
	  ListBloc connectionTest = connectionPossible;
	  connectionTest.translation (position (x, y, z));
	  //printf("POSIOTN TEST 2\n");
	  if (!salleTestEtendu.testConflit (monde))
	    {
	      //printf("POSITION TEST 3\n");
	      // Ca passe.
	      PositionPossible pp;
	      pp.position = salleTestOrig;
	      pp.position.translation (position (x, y, z));
	      // tester les liens satisfaits...
	      for (int i = 0; i != li.size (); i++)
		{
		  GeneratorLien & gl = getLien (li[i]);
		  GeneratorSalle *next = gl.getSuivant (sub);
		  BlocLien *courant;
		  BlocLien *suivant;
		  int suivantIndex = gl.getSuivant (sub, &courant, &suivant);
		  if (gl.connection.size () == 0)
		    {
		      pp.indifferent.insert (pp.indifferent.begin (), li[i]);
		    }
		  else
		    {
		      if (gl.connection.inclus (connectionTest))
			{
			  // C'est tout bon !
			  //printf("SATISFAIT\n");
			  pp.satisfait.insert (pp.satisfait.begin (), li[i]);
			}
		      else
			{
			  //printf("INSATISFAIT\n");
			  pp.insatisfait.insert (pp.insatisfait.begin (),
						 li[i]);
			}
		    };
		}
	      if (pp.satisfait.size ())
		{
		  if (retour.size ())
		    {
		      if (retour[0].insatisfait.size () >
			  pp.insatisfait.size ())
			{
			  // meilleure config...
			  retour.clear ();
			  retour.insert (retour.end (), pp);
			};
		      if (retour[0].insatisfait.size () ==
			  pp.insatisfait.size ())
			{
			  // pareil que les autres...
			  retour.insert (retour.end (), pp);
			};
		    }
		  else
		    retour.insert (retour.end (), pp);
		};
	    }
	}
  return retour;
}

void
Generator::completeLien (GeneratorSalle * sub, ListBloc & monde,
			 ListBloc & connectionPossible)
{
  ListIndex li = trouveLien (sub);
  position centre (0, 0, 0);
  float tailleSalle =
    (sub->placementBloc.getMax () -
     sub->placementBloc.getMin ()).distanceNorme1 (centre);

  for (int i = 0; i != li.size (); i++)
    {
      GeneratorLien & gl = getLien (li[i]);
      if (gl.connection.size ())
	{
	  // C'est bon pour ca.
	}
      else
	{
	  // Trouver un point de connexion, avec une salle non-encore creee, qui maximise la distance min
	  // avec tous les autres points de connexion.
	  float distMin = -2;
	  vector < ListBloc > pointPossible;
	  for (int t = 0; t != 2; t++)
	    {
	      ListBloc possible (position (0, 0, 0), position (1, 2, 2));
	      if (t == 1)
		possible = ListBloc (position (0, 0, 0), position (2, 1, 2));
	      for (int c = 0; c != connectionPossible.size (); c++)
		{
		  ListBloc test = possible;
		  test.translation (connectionPossible[c]);
		  if (test.inclus (connectionPossible))
		    if (!test.testConflit (monde))
		      {
			//printf("INCLUS\n");
			//test.getMin().print();
			//test.getMax().print();
			//connectionPossible.getMin().print();
			//connectionPossible.getMax().print();
			float dist = -1;
			for (int tl = 0; tl != li.size (); tl++)
			  {
			    GeneratorLien & gtl = getLien (li[tl]);
			    if (gtl.connection.size ())
			      {
				float dist2 =
				  test.distanceMin (gtl.connection);
				if ((dist2 < dist) || (dist == -1))
				  dist = dist2;
			      };
			  }
			// On maximise la distance si c'est une salle avec uniquement 2 portes, pour pouvoir partir
			// de travers.
			if ((li.size () <= 2) && (dist > tailleSalle / 2))
			  {
			    dist = tailleSalle / 2;
			  };


			// On regarde si c'est une meilleure solution.
			if (distMin == -2)
			  {
			    pointPossible.insert (pointPossible.begin (),
						  test);
			  };
			if (dist != -1)
			  {
			    if ((dist > distMin) || (distMin == -2))
			      {
				pointPossible.clear ();
				distMin = dist;
			      }
			    if ((dist == distMin) || (distMin == -2))
			      {
				pointPossible.insert (pointPossible.begin (),
						      test);
			      }
			  }
		      }
		}
	    };
	  //printf("avant choix %i\n",pointPossible.size());
	  //choisir une connection possible parmi toutes les possibles.
	  gl.connection = pointPossible[random () % pointPossible.size ()];
	  //gl.connection=pointPossible[0];
	  //printf("apres choix\n");
	};
    };
};

void
Generator::creationSalleCouloir (GeneratorSalle * sub, ListBloc & monde)
{
  // On procde par essai erreur, tant qu'on peut. On prend la meilleure solution value
  // par une distance type Norme1 (avec une prfrence pour les axes XY. On se rapproche
  // jusqu' tre bon, ou jusqu' chouer un certain nombre de fois.
  // Si on choue, on place un drapeau, qu'on remplacera par un tltransporteur.

  bool echec = false;
  ListBloc mondeTest = monde;
  position debut, fin;
  // trouver les 2 bouts, avec les positions-solutions associes.
  ListIndex li = trouveLien (sub);
  for (int i = 0; i != li.size (); i++)
    {
      if (getLien (li[i]).connection.size ())
	{
	  GeneratorLien & gl = getLien (li[i]);
	  if (i == 0)
	    debut = gl.connection.getMin ();
	  else
	    fin = gl.connection.getMin ();
	  printf ("COULOIR AVEC BORD CONNU \n");
	}
      else
	{
	  printf ("COULOIR AVEC BORD INCONNU !!!!\n");
	};
    };

  // Choisir le bloc le plus proche de la solution.
  while (0)
    {
    }
};

void
Generator::creationSalleCommune (GeneratorSalle * sub, position tailleMin,
				 position tailleMax, int minHauteurSolPorte,
				 int maxHauteurSolPorte, ListBloc & monde)
{
  // Trouver les contraintes...
  position diff = tailleMax - tailleMin;
  position taille (random () % (int (diff.coord[0])) +tailleMin.coord[0],
		   random () % (int (diff.coord[1])) +tailleMin.coord[1],
		   random () % (int (diff.coord[2])) +tailleMin.coord[2]);
  position vide;
  ListBloc testSalle (vide, taille);
  ListBloc connectionPossible;
  // generation des points de rattachement possibles.
  for (int z = minHauteurSolPorte; z < maxHauteurSolPorte; z++)
    {
      for (int y = 0; y < taille.coord[1]; y++)
	{
	  connectionPossible.insertPosition (position (-1, y, z));
	  connectionPossible.
	    insertPosition (position (taille.coord[0], y, z));
	}
      for (int x = 0; x < taille.coord[0]; x++)
	{
	  connectionPossible.insertPosition (position (x, -1, z));
	  connectionPossible.
	    insertPosition (position (x, taille.coord[1], z));
	}
    }
  bool placementhasard = true;
  ListIndex li = trouveLien (sub);
  position centre;
  for (int i = 0; i != li.size (); i++)
    {
      if (getLien (li[i]).connection.size ())
	placementhasard = false;
    };
  ListPositionPossible lpp;
  if (!placementhasard)
    {
      lpp = testConfig (testSalle, connectionPossible, sub, monde);
    }
  if (!lpp.size () || placementhasard)	// trouver une position au hasard jusqu'a satisfaction.
    {
      printf ("HASARD\n");
      if (!placementhasard)
	{
	  // trouver le centre de gravite dans le cas ou il y a des liens pour ne pas en etre trop
	  // eloigne...
	  position somme;
	  int nombre = 0;
	  for (int i = 0; i != li.size (); i++)
	    {
	      if (getLien (li[i]).connection.size ())
		{
		  nombre += 2;
		  GeneratorLien & gl = getLien (li[i]);
		  somme =
		    somme + (gl.connection.getMax () +
			     gl.connection.getMin ());
		};
	    };
	  centre = position (int (somme.coord[0] / nombre),
			     int (somme.coord[1] / nombre),
			     int (somme.coord[2] / nombre));
	};

      int maxPosHasard = 1;
      ListBloc salle, testEtend, salleEtend;
      testEtend = testSalle;
      for (int etend = 0; etend != 6; etend++)
	testEtend = testEtend.etendUn ();
      position decal;
      do
	{
	  maxPosHasard++;
	  decal = position (random () % (maxPosHasard * 2) - maxPosHasard, random () % (maxPosHasard * 2) - maxPosHasard, 0	//random()%(maxPosHasard*2)-maxPosHasard
	    ) + centre;
	  salle = testEtend;
	  salle.translation (decal);
	}
      while (salle.testConflit (monde));
      testSalle.translation (decal);
      sub->placementBloc = testSalle;
    }
  else
    {
      printf ("COMPLETE LIEN : SATISFAIT\n");
      int randomSolution = random () % (lpp.size ());
      sub->placementBloc = lpp[randomSolution].position;
    }

  // Une fois la position choisie, on complete les liens ...
  // satisfait= rien faire
  // insatisfait= LIER artificiellement
  // independant = creer
  connectionPossible.translation (sub->placementBloc.getMin ());
  sub->connectionPossible = connectionPossible;
  completeLien (sub, monde, connectionPossible);

  // pour finir, on MAJ le monde avec la salle.
  ListBloc mondeEtend = sub->placementBloc;
  mondeEtend = mondeEtend.etendUn ();
  monde = monde + mondeEtend;
  for (int i = 0; i != li.size (); i++)
    {
      monde = monde + getLien (li[i]).connection;
    };
  printf ("RESULTAT PLACEMENT\n");
  sub->placementBloc.getMin ().print ();
  sub->placementBloc.getMax ().print ();
};

void
Generator::subPlacementSpatial (GeneratorSalle * sub, ListBloc & monde)
{
  if (sub->placementEffectue)
    return;
  sub->placementEffectue = true;
  fprintf (stderr, "PLACEMENT %i\n", getIndexSalle (sub));
  printf ("\nPLACEMENT %i\n", getIndexSalle (sub));
  // prendre les liens...
  ListIndex li = trouveLien (sub);
  switch (sub->type)
    {
    case SALLE_COULOIR:
      // Creer les autres salles, connecter ensuite...
      break;
    case SALLE_GRANDE:
      creationSalleCommune (sub, position (10, 10, 4), position (11, 11, 5),
			    1, 3, monde);
      break;
    case SALLE_SECRET:
      creationSalleCommune (sub, position (2, 2, 2), position (3, 3, 3), 0, 2,
			    monde);
      break;
    case SALLE_DEBUT:
      creationSalleCommune (sub, position (2, 2, 2), position (3, 3, 3), 0, 2,
			    monde);
      break;
    case SALLE_FIN:
      creationSalleCommune (sub, position (2, 2, 2), position (3, 3, 3), 0, 2,
			    monde);
      break;
    case SALLE_NORMALE:
      creationSalleCommune (sub, position (6, 6, 2), position (7, 7, 3), 0, 2,
			    monde);
      break;
    case SALLE_EXTERIEUR:
      creationSalleCommune (sub, position (6, 6, 2), position (7, 7, 3), 0, 2,
			    monde);
      break;
    case SALLE_INTERMEDIAIRE:
      creationSalleCommune (sub, position (5, 5, 2), position (6, 6, 3), 0, 2,
			    monde);
      break;
    }
  for (int i = 0; i != li.size (); i++)
    {
      GeneratorLien & gl = getLien (li[i]);
      GeneratorSalle *next = gl.getSuivant (sub);
      subPlacementSpatial (next, monde);
    }
  switch (sub->type)
    {
    case SALLE_COULOIR:
      // connecter maintenant...
      creationSalleCouloir (sub, monde);
      break;
    }
};
