/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: RWvsNDJ_game.h,v 1.3 2006/12/21 18:18:14 atila Exp $

#include "bloc_info.h"
#include "lecture.h"

// Constante pour l'intervalle de refresh minimal du serveur. (50 FPS)
#define MIN_INTERVALLE_TEMPS	0.02

typedef enum GAME_TYPE
{
  STANDALONE_SERVER,		// Un serveur complet, seul.
  STANDALONE_CLIENT,		// Un client connect sur un serveur.
  CLIENT_SERVER_MELTED,		// Un client qui hberge le jeu.
  CLIENT_SERVER_FULL		// Uniquement pour simuler un rseau.
};


// Une tentitive d'unification du gros bazar haut-niveau.
class RW_GAME
{
  // Tenter de rafraichir "raisonnablement" le serveur. , une trop grande rapidité
  // peut entrainer des incohérences 
  // sur les calculs de position et autres ...
  double lt_serveur;
  double diff_serveur;

  int FPS;
  int lFPS;
  int tFPS;

  int son_mort;

  bool jeu_engage_client;
  bool mode_texte;
  MOT texte;

  GAME_TYPE game_type;
  void fill_NULL_blocinfo (BLOCINFO & blocinfo, bool server, bool client);

  void affichage_client (BLOCINFO & blocinfo);

  void gestion_commun ();
  void gestion_blocinfo (BLOCINFO & blocinfo);

public:

  int width;
  int height;


  BLOCINFO blocinfo_serveur;
  BLOCINFO blocinfo_client;
  BLOCINFO blocinfo_commun;
  void gestion_temps ();

  // Premire initialisation
    RW_GAME (bool server);
  void set_wh (int, int);
  void debut_game (GAME_TYPE gt, MOT srv, MOT map, MOT nom);
  int gestion_jeu ();
  void set_info_joueur (MOT nom, MOT skin);
  void fin_jeu ();
   ~RW_GAME ();

};
