/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: RWvsNDJ_sdl_version.cpp,v 1.6 2006/12/28 10:50:43 atila Exp $
//#include "confdef.h"
#ifdef linux
#include <SDL/SDL.h>
#define GL_GLEXT_PROTOTYPES
#include <GL/gl.h>

#include <stdlib.h>
#include "win3d.h"

#endif

#ifndef linux
#include "windows.h"
#include "win3d.h"

PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2fARB_local;
PFNGLACTIVETEXTUREARBPROC glActiveTextureARB_local;

#endif

#include <stdio.h>
#include "menu.h"
#include <sys/time.h>
#include <unistd.h>

int bpp;
void init_video (bool fs, int resolution);
void init_son();
#include "RWvsNDJ_game.h"

#ifndef WIN_WIDTH		//!+rzr redefinit dans ../confdef.h
#define WIN_WIDTH 800
#endif

#ifndef WIN_HEIGHT
#define WIN_HEIGHT 600
#endif //!-rzr
void
quit (int code)
{
  SDL_Quit ();
  exit (code);
}

int width;
int height;

void
init_video (bool fs, int resolution)
{
#ifndef linux
  fs = true;
  resolution = RESOLUTION_800_600;
  static bool firsttime = true;
  if (!firsttime)
    return;
  firsttime = false;
#endif

  int flags;
  if (fs)
    flags =
      SDL_OPENGL | SDL_FULLSCREEN | SDL_HWSURFACE | SDL_ANYFORMAT |
      SDL_DOUBLEBUF;
  else
    flags = SDL_OPENGL | SDL_HWSURFACE | SDL_ANYFORMAT | SDL_DOUBLEBUF;
  width = 640;
  height = 480;
  switch (resolution)
    {
    case RESOLUTION_320_240:
      width = 320;
      height = 240;
      break;
    case RESOLUTION_640_480:
      width = 640;
      height = 480;
      break;
    case RESOLUTION_800_600:
      width = 800;
      height = 600;
      break;
    case RESOLUTION_1024_768:
      width = 1024;
      height = 768;
      break;
    }
  printf ("Resolution %i Largeur %i Hauteur %i\n", resolution, width, height);
  if (SDL_SetVideoMode (width, height, bpp, flags) == 0)
    {
      fprintf (stderr, "Video mode set failed: %s\n", SDL_GetError ());
      quit (1);
    }
  float ratio = (float) width / (float) height;
  glViewport (0, 0, width, height);

  glActiveTextureARB_local (GL_TEXTURE1_ARB);
  glEnable (GL_TEXTURE_2D);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

  glShadeModel (GL_SMOOTH);

  glClearColor (0, 0, 0, 1.0);
  glPixelStorei (GL_UNPACK_ALIGNMENT, 1);
  glEnable (GL_CULL_FACE);
  glCullFace (GL_FRONT);

  glDepthMask (GL_TRUE);
  glEnable (GL_DEPTH_TEST);

  glEnable (GL_BLEND);
  glTexEnvf (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);

  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

  // 2,3 optimisations qui coutent pas cheres.
  glEnable (GL_SCISSOR_TEST);
  glScissor (0, 0, width, height);

}

void
fin_classique_client ()
{
  SDL_QuitSubSystem (SDL_INIT_VIDEO | SDL_INIT_TIMER | SDL_INIT_AUDIO);
  SDL_Quit ();
}

void
init_classique_client (bool fs)
{
  const SDL_VideoInfo *info = NULL;
  if (SDL_Init (SDL_INIT_VIDEO | SDL_INIT_TIMER | SDL_INIT_AUDIO) < 0)
    {
      fprintf (stderr, "L'initialisation SDL a echouee: %s\n",
	       SDL_GetError ());
      quit (1);
    }
  info = SDL_GetVideoInfo ();
  if (!info)
    {
      fprintf (stderr, "Vieux probleme puant avec la SDL: %s\n",
	       SDL_GetError ());
      quit (1);
    }
  bpp = info->vfmt->BitsPerPixel;

  SDL_GL_SetAttribute (SDL_GL_RED_SIZE, 5);
  SDL_GL_SetAttribute (SDL_GL_GREEN_SIZE, 5);
  SDL_GL_SetAttribute (SDL_GL_BLUE_SIZE, 5);
  SDL_GL_SetAttribute (SDL_GL_DEPTH_SIZE, 16);
  SDL_GL_SetAttribute (SDL_GL_DOUBLEBUFFER, 1);

  init_video (fs, 2);
  init_son();
}

void
client_classique ()
{
  init_classique_client (false);
  bool fin = false;
  while (!fin)
    {
      RW_GAME game (false);
      MENU *lpmenu = new MENU (&(game.blocinfo_commun));
      while (!lpmenu->gestion_courante ())
	{
	  game.gestion_temps ();
	};
      bool fin_menu=lpmenu->quit ();
      MOT srv = MOT ("");
      MOT map = MOT ("");
      bool ok_srv;
      int nbj;
      int port;

      MOT skin = MOT ("");
      MOT nom = MOT ("");
      lpmenu->info (nom, skin);

      if (lpmenu->jeu_local (map, nbj))
	{
	  MOT srv = MOT ("localhost");
	  game.debut_game (CLIENT_SERVER_MELTED, srv, map, nom);
	}
      if (lpmenu->jeu_distant (srv, port))
	{
	  game.debut_game (STANDALONE_CLIENT, srv, map, nom);
	}
      delete lpmenu;	  
      if (fin_menu)
	{
	  return;
	}
      bool test_fin_jeu = false;
      while (!test_fin_jeu)
	{
	  game.set_info_joueur (skin, nom);
	  test_fin_jeu = game.gestion_jeu ();
	};
    };
#ifndef DONT_WANT_SOUND
  SDL_CloseAudio ();
#endif
}

void
client (char *maps, GAME_TYPE gt)
{
  printf ("Init Client Local :\n");
  init_classique_client (false);
  bool fin = false;
  RW_GAME game (false);
  MOT map = MOT (maps);
  bool ok_srv;
  int nbj;
  int port;
  MOT skin = MOT ("");
  MOT nom = MOT ("popof");
  MOT srv = MOT ("localhost");
  game.debut_game (gt, srv, map, nom);
  bool test_fin_jeu = false;
  while (!test_fin_jeu)
    {
      test_fin_jeu = game.gestion_jeu ();
    };
  game.fin_jeu ();
#ifndef DONT_WANT_SOUND
  SDL_CloseAudio ();
#endif

}

void
serveur_classique (char *map)
{
  SDL_Init (SDL_INIT_TIMER);
  MOT srv = MOT ("");
  MOT mmap = MOT (map);
  MOT nom = MOT ("");
  RW_GAME game (true);
  game.debut_game (STANDALONE_SERVER, srv, map, nom);
  printf ("SERVER : Charge carte %s\n", map);
  bool test_fin_jeu = false;
  while (!test_fin_jeu)
    {
      test_fin_jeu = game.gestion_jeu ();
      // On va dormir un peu : ZZZZzzzZZZZZzzzzzZZ....
      SDL_Delay ((int) (1.0 / MIN_INTERVALLE_TEMPS));
    };
  printf ("Fin du jeu programmee\n");
  game.fin_jeu ();
}


void
f1 (unsigned int, float s, float t)
{
};

void
f2 (unsigned int target)
{
};



int
main (int argc, char *argv[])
{
#ifndef linux
  glMultiTexCoord2fARB_local =
    (PFNGLMULTITEXCOORD2FARBPROC) wglGetProcAddress ("glMultiTexCoord2fARB");
  glActiveTextureARB_local =
    (PFNGLACTIVETEXTUREARBPROC) wglGetProcAddress ("glActiveTextureARB");
  //   glMultiTexCoord2fARB_local = (PFNGLMULTITEXCOORD2FARBPROC) wglGetProcAddress("f1");
  //  glActiveTextureARB_local = (PFNGLACTIVETEXTUREARBPROC) wglGetProcAddress("f2");

  // glMultiTexCoord2fARB_local =  &f1;
  // glActiveTextureARB_local = &f2;
#endif
  // Une init fortcée : le générateur de nombres aléatoires.
  srand (0);

  if (argc <= 1)
    {
      client_classique ();
      exit (0);
    }
  if (argc == 3)
    {
      if (!strcmp (argv[1], "c"))
	{
	  // Version debug. Donner le serveur.
	  client (argv[2], STANDALONE_CLIENT);
	}
      else if (!strcmp (argv[1], "s"))
	{
	  // Sinon c'est un serveur local... Donner la carte
	  serveur_classique (argv[2]);
	}
      else if (!strcmp (argv[1], "l"))
	{
	  client (argv[2], CLIENT_SERVER_FULL);
	}
      else if (!strcmp (argv[1], "t"))
	{
	  client (argv[2], CLIENT_SERVER_MELTED);
	}
      else
	{
	  printf ("Please provide the good option (s l t or c)\n");
	};
    }
  else
    {
      printf ("EXEC c SERVER_ADDR\n");
      printf ("EXEC s MAP\n");
      printf ("EXEC l MAP\n");
    }
  fin_classique_client();
}
