/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*************************************************
Ce fichier sert  la gestion des informations sur
les sockets TCP.
*************************************************/
// $Id: TCP.h,v 1.3 2004/06/02 19:21:19 atila Exp $


#ifndef FICHIER_TCP
#define FICHIER_TCP

#ifdef linux
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#endif

#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include "lecture.h"
#include <unistd.h>
#define PORT_STANDARD 	3257

#define SIGNATURE_REBEL_WARRIOR	 "RW_CON_V1"

struct entete_TCP
{
  char signature[10];
  unsigned char type_requete;
  unsigned int taille_info;
};

typedef enum MODE_SOCKET
{
  ECHEC,
  LECTURE,
  ECRITURE,
  INACTIF,
  FIN_IO,
  LECTURE_PASSIVE
};
/*
ECHEC		:	La dernire opration a totalement choue
			L'erreur est irrcuprable. La connection
			doit etre termine.
LECTURE		:	Attente en lecture 
ECRITURE	:	Attente en ecriture
INACTIF		:	Aucune op requise.
FIN_IO 		:	Fin d'une Lecture/Ecriture
LECTURE_PASSIVE	:	Attente en lecture passive.
*/

class TCP
{
  int sock;
  static int maxfd;
  MODE_SOCKET mode;
  void *buffer;
  entete_TCP entete;
  unsigned int taille_buffer;
  unsigned int position_buffer;
  time_t dernier_acces_ok;
  MOT nom_distant;
  unsigned int port_distant;

public:
  int ouverture_socket_ecoute (int port);
  int connection_serveur (char *machine, int port);
  int ecoute_connection (TCP * c2);
  int get_nom_machine (MOT & nom);
  int get_port_machine (unsigned int &port);
  MODE_SOCKET etat ();
  int recup_info (unsigned char *msg_type, void **buffer_recup,
		  int &taille_info);
  int mise_en_lecture ();
  int mise_en_lecture_passive ();
  int ecriture (unsigned char msg_type, void *buffer_ecr,
		unsigned int taille_buffer_ecr);
  int gestion_globale ();
   ~TCP ();
    TCP ();

};

#endif
