/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: action_salle.cpp,v 1.2 2004/06/02 17:14:29 atila Exp $

#include "action_salle.h"

ACTION_SALLE::ACTION_SALLE ()
{
};

ACTION_SALLE::~ACTION_SALLE ()
{
};

void
ACTION_SALLE::valide_position (float temps)
{
  lposition_actuelle = position_actuelle;
  position_actuelle = temps;
};

float
ACTION_SALLE::avance (float temps, float limite)
{
  float retour = 0;
  if (sens == 1)
    {
      retour = temps + position_actuelle;
      if (retour >= limite)
	{
	  retour = limite;
	  sens = -sens;
	  nb_boucle++;
	};
    }
  else
    {
      retour = position_actuelle - temps;
      if (retour <= limite)
	{
	  retour = limite;
	  sens = -sens;
	  nb_boucle++;
	};
    };
  return retour;
};

float
ACTION_SALLE::position_suivante (double temps)
{
  float retour;
  lposition_actuelle = position_actuelle;
  switch (taction)
    {
    case RIEN:
      return position_actuelle;
      break;
    case POSITION_DIRECTE:
      position_actuelle = v1;
      return position_actuelle;
      break;
    case ALLER_SIMPLE_INIT:
    case ALLER_SIMPLE:
      if (nb_boucle == 1)
	{
	  taction = RIEN;
	  nb_boucle = 0;
	  position_actuelle = v1;
	  return position_actuelle;
	};
      position_actuelle = avance (temps, v2);
      break;
    case ALLER_RETOUR_INIT:
    case ALLER_RETOUR:
      if (nb_boucle == 2)
	{
	  taction = RIEN;
	  nb_boucle = 0;
	  return position_actuelle;
	};
      if (nb_boucle == 1)
	position_actuelle = avance (temps, v1);
      if (nb_boucle == 0)
	position_actuelle = avance (temps, v2);
      break;
    case ALLER_RETOUR_INFINI:
      nb_boucle = nb_boucle % 2;
      if (nb_boucle == 1)
	position_actuelle = avance (temps, v1);
      if (nb_boucle == 0)
	position_actuelle = avance (temps, v2);
      break;
    case ALLER_SIMPLE_INFINI:
      if (nb_boucle == 1)
	{
	  nb_boucle = 0;
	  position_actuelle = v1;
	  return position_actuelle;
	};
      position_actuelle = avance (temps, v2);
      break;
    };
  return position_actuelle;
};

void
ACTION_SALLE::init_position_initiale (float v)
{
  position_actuelle = v;
  lposition_actuelle = v - 1;
};

void
ACTION_SALLE::init_mouvement ()
{
  nb_boucle = 0;
  switch (taction)
    {
    case RIEN:
      sens = 0;
      break;
    case POSITION_DIRECTE:
      position_actuelle = v1;
      break;
    case ALLER_SIMPLE:
    case ALLER_SIMPLE_INFINI:
      if (v2 >= position_actuelle)
	sens = 1;
      else
	sens = -1;
      break;
    case ALLER_SIMPLE_INIT:
      init_position_initiale (v1);
      if (v2 >= position_actuelle)
	sens = 1;
      else
	sens = -1;
      break;
    case ALLER_RETOUR:
      if (v2 >= v1)
	sens = 1;
      else
	sens = -1;
      break;
    case ALLER_RETOUR_INIT:
      init_position_initiale (v1);
      if (v2 >= position_actuelle)
	sens = 1;
      else
	sens = -1;
      break;
    case ALLER_RETOUR_INFINI:
      if (v2 >= position_actuelle)
	sens = 1;
      else
	sens = -1;
      break;
    };
};


void
ACTION_SALLE::applique_action (ACTION_SALLE & action)
{
  v1 = action.v1;
  v2 = action.v2;
  taction = action.taction;
  init_mouvement ();
};

void
ACTION_SALLE::lecture_action (BUFFER_NOEUD * BF, buffer_noeud * bn)
{
// Parser les paramtres du noeud...
  buffer_noeud *bns;
  bns = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_RIEN);
  if ((bns = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_RIEN)) != NULL)
    {
      taction = RIEN;
    }
  else if ((bns = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_POSITIONDIRECTE))
	   != NULL)
    {
      taction = POSITION_DIRECTE;
    }
  else if ((bns = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_ALLERSIMPLE)) !=
	   NULL)
    {
      taction = ALLER_SIMPLE;
    }
  else if ((bns = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_ALLERSIMPLEINIT))
	   != NULL)
    {
      taction = ALLER_SIMPLE_INIT;
    }
  else if ((bns = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_ALLERRETOUR)) !=
	   NULL)
    {
      taction = ALLER_RETOUR;
    }

  else if ((bns = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_ALLERRETOURINIT))
	   != NULL)
    {
      taction = ALLER_RETOUR_INIT;
    }
  else if ((bns = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_ALLERRETOURINFINI))
	   != NULL)
    {
      taction = ALLER_RETOUR_INFINI;
    }
  else if ((bns = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_ALLERSIMPLEINFINI))
	   != NULL)
    {
      taction = ALLER_SIMPLE_INFINI;
    }

  v1 = BF->get_float (BF->trouve_suivant (bn, CONSTANTE_SCRIPT_T1));
  v2 = BF->get_float (BF->trouve_suivant (bn, CONSTANTE_SCRIPT_T2));
  nom_anim =
    BF->get_MOT (BF->trouve_suivant (bn, CONSTANTE_SCRIPT_NOMANIMATION));
  init_position_initiale (v1);
  init_mouvement ();
  nb_boucle = 0;
};

typedef struct ACTION_SALLE_REDUITE
{
  TACTION taction;
  float v1, v2, lposition_actuelle, position_actuelle, sens;
  int nb_boucle;
};

void
ACTION_SALLE::lecture (STOCK & stock, int &curseur)
{
  struct ACTION_SALLE_REDUITE *lpaction;
  lpaction = (struct ACTION_SALLE_REDUITE *) stock.get_posbuffer (curseur);
  curseur += sizeof (struct ACTION_SALLE_REDUITE);
  taction = lpaction->taction;
  v1 = lpaction->v1;
  v2 = lpaction->v2;

// Bidouille : 
// SI la diffrence absolue n'est pas "trop" importante, on ne modifie pas, 
// l'estimation tant suffisamment bonne pour viter un effet de lag dsagrable...

  double diff = fabs (lposition_actuelle - lpaction->lposition_actuelle) +
    fabs (position_actuelle - lpaction->position_actuelle);
  if (diff > TEMPS_LAG_MAX)
    {
      lposition_actuelle = lpaction->lposition_actuelle;
      position_actuelle = lpaction->position_actuelle;
    }

  sens = lpaction->sens;
  nb_boucle = lpaction->nb_boucle;
};

void
ACTION_SALLE::ecriture (STOCK & stock)
{
  struct ACTION_SALLE_REDUITE action;
  action.taction = taction;
  action.v1 = v1;
  action.v2 = v2;
  action.lposition_actuelle = lposition_actuelle;
  action.position_actuelle = position_actuelle;
  action.sens = sens;
  action.nb_boucle = nb_boucle;

  stock.put_buffer ((char *) &action, sizeof (struct ACTION_SALLE_REDUITE));
};
