/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: affiche_texte.cpp,v 1.3 2006/12/21 18:18:14 atila Exp $
#define GL_GLEXT_PROTOTYPES
#include "affiche_texte.h"
#include "def_texture.h"
#include "local_glu.h"
#include "win3d.h"
// Dfinition d'un tableau de stockage des constantes...
// On commence  compter  32.

AFFICHE_TEXTE::AFFICHE_TEXTE (LPBANQUE_TEXTURE lpbanque_texture, LPBDD lpbdd)
{
  dessin_font = 0;
};

void
AFFICHE_TEXTE::init_client (LPBANQUE_TEXTURE lpbanque_texture, LPBDD lpbdd,
			    bool texture)
{
  if ((dessin_font == 0) || (texture))
    {
      dessin_font = 0;
      lastID = 0;
      firstID = 0;
      dessin_font = 0;
      DESCRIPTEUR_TEXTURE desc;
      desc.nom = MOT ("d_commun/d_ecran/font_principale2.pcx");
      desc.blend_type = 1;
      desc.blend = 200;
      dessin_font = lpbanque_texture->trouve_texture (&desc, lpbdd);

      ELEMENT_TEXTURE elem;
      //dessin_font = elem.chargement (&desc,lpbdd);
    }
};

AFFICHE_TEXTE::~AFFICHE_TEXTE ()
{
};


void
trace_caractere (char u)
{
  if (u == 32)
    return;
  int i = u - 33;
  float TX = 0;
  float TY = 0;
  while (i > 7)
    {
      i -= 8;
      TY += 60.0 / 512.0;
    }
  TX = i * 61.0 / 512.0;

  float TINCX = 36.0 / 512.0;
  float TINCY = 50.0 / 512.0;
  TX -= 5.0 / 512.0;
  TY -= 5.0 / 512.0;

  glBegin (GL_POLYGON);

  glMultiTexCoord2fARB_local (GL_TEXTURE1_ARB, TX + TINCX, TY + TINCY);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, TX + TINCX, TY + TINCY);
  glVertex3f (1, -1, 0);

  glMultiTexCoord2fARB_local (GL_TEXTURE1_ARB, TX, TY + TINCY);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, TX, TY + TINCY);
  glVertex3f (0, -1, 0);

  glMultiTexCoord2fARB_local (GL_TEXTURE1_ARB, TX, TY);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, TX, TY);
  glVertex3f (0, 0, 0);

  glMultiTexCoord2fARB_local (GL_TEXTURE1_ARB, TX + TINCX, TY);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, TX + TINCX, TY);
  glVertex3f (1, 0, 0);

  glEnd ();

}

void
AFFICHE_TEXTE::affiche_texte (LPBLOCINFO lpblocinfo, MOT & affiche, float x,
			      float y, float z, float blending)
{
  affiche_texte (lpblocinfo, affiche, x, y, z, 1, 1, 1, blending);
};

extern int width, height;

void
AFFICHE_TEXTE::affiche_texte (LPBLOCINFO lpblocinfo, MOT & affiche,
			      float x, float y, float z,
			      float R, float G, float B, float blending)
{

  char *chaine = affiche.info;

  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  gluPerspective (60.0, (GLfloat) width / (GLfloat) height, 0.01, 300.0);
  glMatrixMode (GL_MODELVIEW);
  glLoadIdentity ();
  glTranslatef (x, -y, -z);

  glDisable (GL_DEPTH_TEST);

  VALEUR_LUMIERE coul (R, G, B, blending);
  lpblocinfo->lpetat_texture->set_color (0, coul);
  lpblocinfo->lpetat_texture->set_color (1, coul);

  ETAT_MULTITEXTURE em;
  em.texture = dessin_font;

  em.actif = true;
  lpblocinfo->lpetat_texture->active_etat (1, em);
  em.actif = true;
  lpblocinfo->lpetat_texture->active_etat (0, em);


  for (char *u = chaine; *u; u++)
    {
      char c = *u;
      trace_caractere (c);
      glTranslatef (1, 0, 0);
    }

  glEnable (GL_DEPTH_TEST);

};


void
AFFICHE_TEXTE::affiche_tout (LPBLOCINFO lpblocinfo)
{
  affiche aff;
  int ligne = -17;
  for (LISTE_AFFICHE::iterator i = liste_courante.begin ();
       i != liste_courante.end (); i++)
    {
      aff = *i;
      affiche_texte (lpblocinfo, aff.texte, -23, ligne, 30, 0);
      ligne++;
    }
}

void
AFFICHE_TEXTE::print (MOT & m, LPBLOCINFO lpblocinfo)
{
  affiche aff;
  lastID++;
  aff.ID = lastID;
  aff.texte = m;
  aff.temps = lpblocinfo->T;
  liste_courante.insert (liste_courante.end (), aff);
}

void
AFFICHE_TEXTE::gestion_globale (LPBLOCINFO lpblocinfo)
{
  // Filtrer les paquets trop agés.
  // On va les garder 5 sec.
  LISTE_AFFICHE::iterator i = liste_courante.begin ();
  while (i != liste_courante.end ())
    {
      affiche & aff = *i;
      if (lpblocinfo->T - aff.temps > 5.0)
	{
	  liste_courante.erase (i, i + 1);
	  i = liste_courante.begin ();
	}
      else
	i++;
    }

  if (lpblocinfo->serveur)
    {
      // Créer les paquets.
      STOCK stock (64000);
      short int t = liste_courante.size ();
      stock.put_buffer ((char *) &t, sizeof (t));
      for (LISTE_AFFICHE::iterator i = liste_courante.begin ();
	   i != liste_courante.end (); i++)
	{
	  affiche aff = *i;
	  stock.put_buffer ((char *) &(aff.ID), sizeof (aff.ID));
	  stock.put_buffer ((char *) &(aff.texte.info),
			    strlen (aff.texte.info) + 1);
	}
      char *buffer;
      int taille;
      stock.get_buffer (&buffer, &taille);
      lpblocinfo->lpreseau->put_UDP (CANAL_MESSAGE, taille, buffer);
      if (buffer)
	free (buffer);
    }
  else
    {
      // Récupérer les paquets.
      int position = 0;
      unsigned int taille;
      void *buffer;
      STOCK stock (64 * 1024);
      lpblocinfo->lpreseau->get_UDP (CANAL_MESSAGE, &taille, &buffer);
      stock.put_buffer ((char *) buffer, taille);
      if (buffer)
	{
	  // Le nombre.
	  short int t;
	  short int *t2 = (short int *) stock.get_posbuffer (position);
	  t = *t2;
	  position += sizeof (short int);
	  for (int i = 0; i < t; i++)
	    {
	      affiche aff;
	      aff.ID = *(unsigned int *) stock.get_posbuffer (position);
	      position += sizeof (aff.ID);

	      aff.texte = MOT ((char *) stock.get_posbuffer (position));
	      position +=
		strlen ((char *) stock.get_posbuffer (position)) + 1;

	      if (aff.ID > lastID)
		{
		  lastID = aff.ID;
		  aff.temps = lpblocinfo->T;
		  liste_courante.insert (liste_courante.end (), aff);
		}
	    };

	  free (buffer);
	}
    }
}
