/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: affiche_texte.h,v 1.3 2006/12/21 18:18:14 atila Exp $

#ifndef AFFICHE_TEXTE_FICHIER
#define AFFICHE_TEXTE_FICHIER

#include "bloc_info.h"
#include "lecture.h"
#include "GL/gl.h"
#include "def_texture.h"
#include "def_3d.h"
#include <deque>
#include <string>
#include "stock.h"
#include "reseau.h"

typedef struct _affiche
{
  unsigned int ID;
  double temps;
  MOT texte;
} affiche;

typedef deque < affiche > LISTE_AFFICHE;

class AFFICHE_TEXTE
{

  GLuint dessin_font;
  unsigned int lastID;
  unsigned int firstID;
  LISTE_AFFICHE liste_courante;

public:

  // client uniquement.
  void affiche_texte (LPBLOCINFO lpblocinfo, MOT & affiche, float x, float y,
		      float z, float blending);
  void affiche_texte (LPBLOCINFO lpblocinfo, MOT & affiche, float x, float y,
		      float z, float R, float G, float B, float blending);

  void affiche_tout (LPBLOCINFO lpblocinfo);

  //client/serveur
  void gestion_globale (LPBLOCINFO lpblocinfo);

  //serveur
  void print (MOT & m, LPBLOCINFO lpblocinfo);


    AFFICHE_TEXTE (LPBANQUE_TEXTURE lpbanque_texture, LPBDD lpbdd);
   ~AFFICHE_TEXTE ();

  void init_client (LPBANQUE_TEXTURE lpbanque_texture, LPBDD lpbdd,
		    bool texture);
};

#endif
