/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef fichier_animation_texture
#define fichier_animation_texture

#include <stdlib.h>
#include "def_texture.h"
#include "mathsRWvsNDJ.h"

// Une facilit pour lire des points : le VERTEX.
#include "facette.h"
#include "bloc_info.h"


/************************************************/
/* Classe de banque animation de texture	*/
/************************************************/

enum TYPE_ACTION_TEXTURE
{ TEXTURE_TRANSLATION,
  TEXTURE_ROTATIONX,
  TEXTURE_ROTATIONY,
  TEXTURE_ROTATIONZ,
  TEXTURE_ECHELLE,
  TEXTURE_SAUT,
  TEXTURE_SAUT_ALEATOIRE,
  TEXTURE_APPLIQUE_TEXTURE
};

class ACTION_ANIMATION_TEXTURE
{
  float SautT;
  float SautAleatoireT1;
  float SautAleatoireT2;
  TYPE_ACTION_TEXTURE type_action_texture;	// le type d'action  grer

  // Les params pour chaque type d'action.
  GLuint desc_texture;
  bool blend;			// dtermine si la texture  changer est transparente.
  RWVECTOR deb_pos, fin_pos;	// des structures relatives  chaque type d'actions
  float ANGLE1, ANGLE2;
  RWVECTOR deb_echelle, fin_echelle;
  float TEMPS1, TEMPS2;		// les temps de depart et de fin sont globaux 
  // pour chaque type d'action : le calcul des diffrents 
  // paramtres au temps T se font linairement
public:  ACTION_ANIMATION_TEXTURE (BUFFER_NOEUD * BF, buffer_noeud * bn,
			      LPBLOCINFO lpblocinfo);
   ~ACTION_ANIMATION_TEXTURE ();

  // Modifie les paramtres temporels de T1 et T2.
  void pre_applique_action (LPBLOCINFO lpblocinfo, MATRIX & m,
			    GLuint & desc_text);
  void post_applique_action (LPBLOCINFO lpblocinfo, MATRIX & m,
			     GLuint & desc_text);
  bool get_blend ();
};

class ANIMATION_TEXTURE:public CLASSE_MODELE
{
  deque < ACTION_ANIMATION_TEXTURE * >liste_action_animation_texture;

  float T, LT;

  // Le descripteur OpenGL de la liste  regnrer  chaque tour.
  GLuint GLdesc;

  // dtermine si il y a au moins 1 texture transparente dans l'animation_texture
  bool blend;

public:
    ANIMATION_TEXTURE ();
   ~ANIMATION_TEXTURE ();
  GLuint get_GLdesc ();
  bool get_blend ();

  // Pour grer globalement la texture/matrice
  void gestion_globale (LPBLOCINFO lpblocinfo);

  // Pour grer localement la texture/matrice : renvoie le rsultat...
  void gestion_locale (LPBLOCINFO lpblocinfo, MATRIX & m, GLuint & desc_text);

  int charge_avec_fichier (void *data, LPBLOCINFO lpblocinfo);
  CLASSE_MODELE *duplique_element ();
};

typedef ANIMATION_TEXTURE *LPANIMATION_TEXTURE;

// On surcharge pour avoir une gestion particulire.
class BANQUE_ANIMATION_TEXTURE:BANQUE < ANIMATION_TEXTURE >
{
public:
  // Regnrer les descripteur  chaque tour.
  void gestion_globale (LPBLOCINFO lpblocinfo);
  GLuint trouve_animation_texture (LPBLOCINFO lpblocinfo, MOT & fichier,
				   bool & blend);
  ANIMATION_TEXTURE *trouve_animation_texture_brutal (LPBLOCINFO lpblocinfo,
						      MOT & fichier);


    BANQUE_ANIMATION_TEXTURE ();
   ~BANQUE_ANIMATION_TEXTURE ();

};

#endif
