/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: bdd.cpp,v 1.3 2006/12/21 18:18:14 atila Exp $

#include "bdd.h"
#include <string.h>


// LF

LF::LF ()
{
};

LF::~LF ()
{
};


// LF_BDD

LF_BDD::LF_BDD ()
{
};

LF_BDD::~LF_BDD ()
{
};


// BDD

BDD::BDD ()
{
};


BDD::~BDD ()
{
};

int
BDD::extrait_fichier_buffer (MOT * nom, char **buffer, int *taille)
{
  *buffer = NULL;
  *taille = 0;
  //printf("%s\n",nom->info);
  bool trouve = false;
  deque_LF::iterator lf_courant = liste_fichier.begin ();
  LF lf;
  for (; lf_courant != liste_fichier.end (); lf_courant++)
    {
      MOT nomf = (*lf_courant).nom_fichier;
      if (nomf == *nom)
	{
	  lf = *lf_courant;
	  trouve = true;
	  break;
	};
    }
  if (!trouve)
    return -1;
  int err = UNZ_OK;
  unzFile uf = liste_fichier_bdd[lf.fichier_bdd_princ].uf;
  if (unzLocateFile (uf, nom->info, 0) != UNZ_OK)
    {
      if (nom->info[0] != 0)
	printf ("file %s not found in the zipfile\n", nom->info);
      return -1;
    }

  char filename_inzip[1024];
  char *filename_withoutpath;
  unz_file_info file_info;
  uLong ratio = 0;
  err =
    unzGetCurrentFileInfo (uf, &file_info, filename_inzip,
			   sizeof (filename_inzip), NULL, 0, NULL, 0);
  if (err != UNZ_OK)
    {
      printf ("file %s error the zipfile\n", nom->info);
      return -1;
    }
  *taille = file_info.uncompressed_size;
  *buffer = (char *) malloc (*taille);
  err = unzOpenCurrentFile (uf);
  if (err < 0)
    {
      printf ("Erreur a l'ouverture de %s\n", nom->info);
      return -1;
    }
  err = unzReadCurrentFile (uf, *buffer, file_info.uncompressed_size);
  if (err < 0)
    {
      printf ("Erreur a l'extraction de %s\n", nom->info);
      return -1;
    }
  unzCloseCurrentFile (uf);
  return 0;
};

int
BDD::ajoute_bdd (MOT * nom_fichier_bdd)
{
  // ouverture du fichier initial.
  char zipfilename[1024];
  strcpy (zipfilename, nom_fichier_bdd->info);
  LF_BDD lfbdd;
  lfbdd.uf = unzOpen (zipfilename);
  if (!lfbdd.uf)
    {
      printf ("ZIP : Fichier inexistant : %s\n", nom_fichier_bdd->info);
      return -1;
    };
  unz_global_info gi;
  int err;
  err = unzGetGlobalInfo (lfbdd.uf, &gi);
  liste_fichier_bdd.insert (liste_fichier_bdd.end (), lfbdd);
  if (err != UNZ_OK)
    {
      printf ("Erreur %d avec le fichier ZIP, dans unzGetGlobalInfo \n", err);
      return -1;
    }
  for (int i = 0; i < gi.number_entry; i++)
    {
      LF lf;
      char filename_inzip[1024];
      filename_inzip[0] = 0;
      unz_file_info file_info;
      uLong ratio = 0;
      err =
	unzGetCurrentFileInfo (lfbdd.uf, &file_info, filename_inzip,
			       sizeof (filename_inzip), NULL, 0, NULL, 0);
      if (err != UNZ_OK)
	{
	  printf
	    ("Erreur %d avec le fichier ZIP dans unzGetCurrentFileInfo\n",
	     err);
	  //   return -1;
	}
      lf.nom_fichier = filename_inzip;
      lf.fichier_bdd_princ = liste_fichier_bdd.size () - 1;
      lf.size = file_info.uncompressed_size;
      if ((i + 1) < gi.number_entry)
	{
	  err = unzGoToNextFile (lfbdd.uf);
	  if (err != UNZ_OK)
	    {
	      printf ("ERREUR %d DANS FICHIER ZIP A unzGoToNextFile\n", err);
	      return -1;
	    }
	}
      liste_fichier.insert (liste_fichier.begin (), lf);
    };
  return 0;
};

LISTE_NOM
BDD::liste_fichier_speciaux (MOT rep, MOT ext)
{
  // Parcourir a la recherche d'un fichier ayant les proprits dsires...
  LISTE_NOM ln;
  for (deque_LF::iterator lf_courant = liste_fichier.begin ();
       lf_courant != liste_fichier.end (); lf_courant++)
    {
      MOT nomf = (*lf_courant).nom_fichier;
      if (!strncmp (rep.info, nomf.info, rep.taille + 1))
	{
	  char *ext2 = nomf.info + nomf.taille - ext.taille;
	  //printf("REP2 OK %s - %s - %s - %s\n",rep.info,nomf.info,ext2,ext.info);
	  if (!strcmp (ext.info, ext2))
	    {
	      ln.insert (ln.begin (), nomf);
	      //printf("REP OK %s\n",ext.info,ext2);
	    }
	}
    }
  return ln;
}

bool
BDD::fichier_existe (MOT & nom)
{
  bool trouve = false;
  for (deque_LF::iterator lf_courant = liste_fichier.begin ();
       lf_courant != liste_fichier.end (); lf_courant++)
    {
      MOT nomf = (*lf_courant).nom_fichier;
      if (nomf == nom)
	return true;
    }
  return trouve;
}
