/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: bloc_info.h,v 1.3 2006/12/21 18:18:14 atila Exp $


#ifndef fichier_bloc_info
#define fichier_bloc_info

#include "stdlib.h"
#include "mathsRWvsNDJ.h"
using namespace std;

class JEU;
class MOTEUR;
class BDD;
class NIVEAU;
class RESEAU;
class AFFICHE_TEXTE;
class CONTROLE;
class BANQUE_TEXTURE;
class BANQUE_ANIMATION_TEXTURE;
class ANIMATION;
class OBJET;
class MIXER;
class FICHIER_OPTION;
class ETAT_TEXTURE;
class DICO;

template < class T > class BANQUE;
typedef BANQUE < ANIMATION > BANQUE_ANIMATION;
typedef BANQUE < OBJET > BANQUE_OBJET;

typedef JEU *LPJEU;
typedef MOTEUR *LPMOTEUR;
typedef BDD *LPBDD;
typedef NIVEAU *LPNIVEAU;
typedef RESEAU *LPRESEAU;
typedef AFFICHE_TEXTE *LPAFFICHE_TEXTE;
typedef CONTROLE *LPCONTROLE;
typedef MIXER *LPMIXER;
typedef FICHIER_OPTION *LPFICHIER_OPTION;
typedef ETAT_TEXTURE *LPETAT_TEXTURE;
typedef DICO* LPDICO;

enum TypeVue
{
  TypeVueExterneDos,
  TypeVueExterneFixe,
  TypeVueInterne
};

enum TypeLumiere
{
  TypeLumiereSansLumiere,
  TypeLumiereVertex,
  TypeLumiereComplete
};

struct BLOCOPTION
{
  TypeVue typeVue;
  float vueDistance;
};

#define RESOLUTION_320_240          0
#define RESOLUTION_640_480          1
#define RESOLUTION_800_600          2
#define RESOLUTION_1024_768         3

struct BLOCECRAN
{
  bool fullscreen;
  int resolution;
  TypeLumiere lumiere;
};

typedef enum mode_jeu_t
{
  MODE_JEU_ARCADE,
  MODE_JEU_CLAVIER,
  MODE_JEU_CALCUL
} mode_jeu_t;

typedef enum mode_mouvement_t
{
  MODE_MOUVEMENT_LIBRE,
  MODE_MOUVEMENT_CONTRAINT
} mode_mouvement_t;

struct BLOCINFO
{
  bool serveur;
  bool client;
  double LT, T, diff;
  double real_LT, real_T, real_diff;
  BANQUE_TEXTURE *lpbanque_texture;
  LPBDD lpbdd;
  LPJEU lpjeu;
  LPNIVEAU lpniveau;
  BANQUE_ANIMATION *lpbanque_animation;
  BANQUE_OBJET *lpbanque_objet;
  BANQUE_ANIMATION_TEXTURE *lpbanque_animation_texture;
  LPRESEAU lpreseau;
  LPAFFICHE_TEXTE lpaffiche_texte;
  LPCONTROLE lpcontrole;
  LPMOTEUR lpmoteur;
  BLOCOPTION blocoption;
  LPMIXER lpmixer;
  LPFICHIER_OPTION lpfichier_option;
  LPETAT_TEXTURE lpetat_texture;
  LPDICO lpdictionnaire;
  BLOCECRAN blocecran;
  unsigned int texture_halo;
  mode_jeu_t mode_jeu;
  mode_mouvement_t mode_mouvement;
  MATRIX position_camera;
};


// Routines de verification.
// Pour deboguer en dernier recours.
extern void set_check_data (bool *, int *, char *);
extern void print_checking_up ();

#define LPBLOCINFO BLOCINFO*
#endif
