/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: buffer.cpp,v 1.2 2004/06/02 17:14:29 atila Exp $

#include "buffer.h"

BUFFER::BUFFER ()
{
  buffer = NULL;
  ligne = NULL;
  taille_reelle = 0;
  taille_donnees = 0;
};

BUFFER::~BUFFER ()
{
  if (buffer)
    free (buffer);
  if (ligne)
    free (ligne);
};

char *
BUFFER::get_posbuffer (int position)
{
  return &(buffer[position]);
};

int
BUFFER::get_info (int i, char *c, int *l)
{
  if (i < taille_donnees)
    {
      *c = buffer[i];
      *l = ligne[i];
      return 0;
    }
  else
    return -1;
};

unsigned int
BUFFER::get_size ()
{
  return taille_donnees;
};

void
BUFFER::expand (int n)
{
  char *temp = (char *) malloc (taille_reelle + n);
  int *templ = (int *) malloc ((taille_reelle + n) * sizeof (int));

  memcpy (temp, buffer, taille_donnees);
  memcpy (templ, ligne, taille_donnees * sizeof (int));

  free (buffer);
  free (ligne);

  buffer = temp;
  ligne = templ;

  taille_reelle = taille_reelle + n;
};

int
BUFFER::get_buffer (char **breq, int **lreq, int *treq)
{
  *breq = (char *) malloc (taille_donnees);
  *lreq = (int *) malloc (taille_donnees * sizeof (int));

  *treq = taille_donnees;

  memcpy (*breq, buffer, taille_donnees);
  memcpy (*lreq, ligne, taille_donnees * sizeof (int));
};

int
BUFFER::put_buffer (char c, int l)
{
  if (taille_donnees + 1 > taille_reelle)
    expand (TAILLE_INIT);

  buffer[taille_donnees] = c;
  ligne[taille_donnees] = l;

  taille_donnees++;
};



int
BUFFER::put_buffer (char *b, int *l, int i)
{
  if (taille_donnees + i > taille_reelle)
    expand (i + TAILLE_INIT);
  memcpy (&buffer[taille_donnees], b, i);
  if (l)
    memcpy (&ligne[taille_donnees], l, i * sizeof (int));
  taille_donnees += i;
};

/*
int main()
{
BUFFER *b=new BUFFER();
char * buff;
int* lig;
int ligne[10];
int j;

for (int i=0;i<10;i++) ligne[i]=i;


for (int i=0;i<10;i++) b->put_buffer("Coucou",ligne,6);
b->put_buffer(0,100);
b->get_buffer(&buff,&lig,&j);

printf("%s\n",buff);
for (int i=0;i<j;i++) printf("%i ",lig[i]);

delete b;
};
*/
