// $Id: buffer_noeud.cpp,v 1.4 2006/12/21 18:18:14 atila Exp $

#include "buffer_noeud.h"

// 2,3 fonctions de manimulation des buffers de noeuds.

buffer_noeud *
BUFFER_NOEUD::trouve_suivant (buffer_noeud * courant, short int recherche)
{
  buffer_noeud *retour = NULL;
  while (courant && (!retour))
    {
      if (courant->nom_noeud == recherche)
	retour = courant;
      if (trouve_suivant (courant))
	courant = trouve_suivant (courant);
      else
	courant = NULL;
    };
  return retour;
};

buffer_noeud *
BUFFER_NOEUD::trouve_suivant (buffer_noeud * courant)
{
  if (!courant)
    return NULL;
  if (courant->frere_noeud)
    return (buffer_noeud *) (offset + ((unsigned int) courant->frere_noeud));
  return NULL;
};

MOT
BUFFER_NOEUD::get_MOT (buffer_noeud * courant)
{
  if (!courant)
    return MOT ("");
  if (courant->type_noeud != NTEXTE)
    return MOT ("");
  return MOT (&((buffer_noeud_texte *) courant)->texte);
};

float
BUFFER_NOEUD::get_float (buffer_noeud * courant)
{
  if (!courant)
    return 0.0;
  if (courant->type_noeud != NVALEUR)
    return 0.0;
  return ((buffer_noeud_valeur *) courant)->valeur;
};

buffer_noeud *
BUFFER_NOEUD::get_fils (buffer_noeud * courant)
{
  if (!courant)
    return NULL;
  if (courant->type_noeud != NFILS)
    return NULL;
  return (buffer_noeud *) (offset +
			   ((unsigned int) ((buffer_noeud_fils *) courant)->
			    fils));
};

char
BUFFER_NOEUD::get_type (buffer_noeud * courant)
{

};

short int
BUFFER_NOEUD::get_nom (buffer_noeud * courant)
{
  return courant->nom_noeud;
};

buffer_noeud *
BUFFER_NOEUD::pretraitement_buffer_noeud (buffer_noeud * courant)
{
#ifndef linux
  offset = buffer;
  return courant;

  printf ("SUB %i %i\n", courant->type_noeud, courant);
  if (courant)
    {
      printf ("NODE %i %i\n", courant->type_noeud, courant);
      buffer_noeud *nouveau;
      switch (courant->type_noeud)
	{
	case NFILS:
	  {
	    nouveau = (buffer_noeud *) new (buffer_noeud_fils);
	    memcpy (nouveau, courant, sizeof (buffer_noeud_fils));

	    buffer_noeud_fils *cour = (buffer_noeud_fils *) nouveau;
	    unsigned int fils;
	    printf ("avant copie\n");
	    memcpy (&fils, &(cour->fils), 4);
	    printf ("aprs copie\n");
	    if (fils >= taille)
	      {
		printf ("fils %u\n", fils);
		exit (0);
	      }
	    if ((fils) && (fils < taille))
	      {
		buffer_noeud *f = (buffer_noeud *) ((char *) buffer + fils);
		printf ("ALIGN %i %i \n",
			(unsigned int) ((char *) buffer + fils),
			((unsigned int) (((char *) buffer + fils))) % 4);
		cour->fils = pretraitement_buffer_noeud (f);
	      };
	    printf ("sortie fils\n");
	    break;
	  }
	case NNONE:
	  nouveau = (buffer_noeud *) new (buffer_noeud);
	  memcpy (nouveau, courant, sizeof (buffer_noeud));
	  break;
	case NVALEUR:
	  nouveau = (buffer_noeud *) new (buffer_noeud_valeur);
	  memcpy (nouveau, courant, sizeof (buffer_noeud_valeur));
	  break;
	case NTEXTE:
	  {
	    buffer_noeud_texte *txt = (buffer_noeud_texte *) (courant);
	    char *c = &(txt->texte);
	    int len = strlen (c);
	    nouveau =
	      (buffer_noeud *) malloc (sizeof (buffer_noeud_texte) + len);
	    memcpy (nouveau, courant, sizeof (buffer_noeud_texte) + len);
	    break;
	  }
	};
      printf ("AVANT COPY\n");
      unsigned int decal;
      memcpy (&decal, &(nouveau->frere_noeud), 4);
      printf ("APRES COPY\n");
      if (decal >= taille)
	{
	  printf ("frere %u %u %i\n",
		  decal,
		  (unsigned int) &(nouveau->frere_noeud),
		  (unsigned int) (nouveau->frere_noeud) % 4);
	  exit (0);
	}
      buffer_noeud *cour = NULL;
      if ((decal > 0) && (decal < taille))
	{
	  printf ("FRERE.... %i\n", nouveau->frere_noeud);

	  cour = (buffer_noeud *) ((char *) buffer + decal);

	  // nouveau->frere_noeud=
	  pretraitement_buffer_noeud (cour);

	  printf ("FRERE2.... %i %i %i\n", buffer, nouveau,
		  nouveau->frere_noeud);
	}
      else
	nouveau->frere_noeud = NULL;
      //  courant = courant->frere_noeud;
      //printf("cour %i\n",cour);
      return nouveau;
    }
#endif

#ifdef linux
  while (courant)
    {
      if (courant->type_noeud == NFILS)
	{
	  unsigned int fils =
	    (unsigned int) (((buffer_noeud_fils *) courant)->fils);
	  if ((fils) && (fils < taille))
	    {
	      ((buffer_noeud_fils *) courant)->fils =
		(buffer_noeud *) ((char *) buffer + fils);
	      pretraitement_buffer_noeud (((buffer_noeud_fils *) courant)->
					  fils);
	    }
	};
      if (((unsigned int) courant->frere_noeud > 0)
	  && ((unsigned int) courant->frere_noeud < taille))
	{
	  courant->frere_noeud =
	    (buffer_noeud *) ((unsigned int) courant->frere_noeud +
			      (unsigned int) buffer);
	}
      else
	courant->frere_noeud = NULL;
      courant = courant->frere_noeud;
    };
  return courant;
#endif
};

int
BUFFER_NOEUD::dump_buffer_noeud (buffer_noeud * courant, int sub)
{
  if (sub == -1)
    {
      courant = (buffer_noeud *) buffer;
      sub = 0;
    }
  while (courant)
    {
      for (int i = 0; i < sub; i++)
	printf ("  ");
      printf ("%i [ %s ]", courant->nom_noeud,
	      (courant->nom_noeud <
	       MAX_ASSOCIATION) ? tableau_association[courant->
						      nom_noeud] : "");
      if (courant->type_noeud == NFILS)
	{
	  printf ("\n");
	  dump_buffer_noeud (get_fils (courant), sub + 1);
	};
      if (courant->type_noeud == NTEXTE)
	{
	  printf (" = %s\n", get_MOT (courant).info);
	}
      if (courant->type_noeud == NVALEUR)
	{
	  printf (" = %f\n", ((buffer_noeud_valeur *) courant)->valeur);
	}
      if (courant->type_noeud == NNONE)
	{
	  printf ("\n");
	}
      courant = trouve_suivant (courant);
    };
};

BUFFER_NOEUD::BUFFER_NOEUD (BDD * bdd, MOT * fichier)
{
  bdd->extrait_fichier_buffer (fichier, &buffer, &taille);
  root = pretraitement_buffer_noeud ((buffer_noeud *) buffer);
//  printf("FIN NOEUD\n");
#ifdef linux
  root = (buffer_noeud *) buffer;
  offset = 0;
#endif
  // dump_buffer_noeud (root, 0);
};

buffer_noeud *
BUFFER_NOEUD::ROOT ()
{
  return root;
};

BUFFER_NOEUD::~BUFFER_NOEUD ()
{
  free (buffer);
}
