/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: buffer_noeud.h,v 1.3 2006/12/21 18:18:14 atila Exp $

#ifndef BUFFER_NOEUD_FICHIER
#define BUFFER_NOEUD_FICHIER

#include <stdio.h>
#include "bdd.h"
#include "lecture.h"
#include "script_nom.h"

enum TNOEUD
{ NNONE, NVALEUR, NTEXTE, NFILS };

typedef struct _buffer_noeud
{
  struct _buffer_noeud *frere_noeud;
  char type_noeud;
  short int nom_noeud;
} buffer_noeud;

struct _buffer_noeud_fils
{
  buffer_noeud core;
  buffer_noeud *fils;
};

struct _buffer_noeud_valeur
{
  buffer_noeud core;
  float valeur;
};

struct _buffer_noeud_texte
{
  buffer_noeud core;
  char texte;
};

typedef struct _buffer_noeud_fils buffer_noeud_fils;
typedef struct _buffer_noeud_valeur buffer_noeud_valeur;
typedef _buffer_noeud_texte buffer_noeud_texte;


class BUFFER_NOEUD
{
  buffer_noeud *pretraitement_buffer_noeud (buffer_noeud * courant);
  char *buffer;
  buffer_noeud *root;
  char *offset;
  int taille;

public:

  int dump_buffer_noeud (buffer_noeud * courant, int sub);

  buffer_noeud *trouve_suivant (buffer_noeud * courant, short int nom_noeud);
  buffer_noeud *trouve_suivant (buffer_noeud * courant);

  MOT get_MOT (buffer_noeud * courant);
  float get_float (buffer_noeud * courant);
  buffer_noeud *get_fils (buffer_noeud * courant);
  char get_type (buffer_noeud * courant);
  short int get_nom (buffer_noeud * courant);

    BUFFER_NOEUD (BDD * bdd, MOT * fichier);
  buffer_noeud *ROOT ();
   ~BUFFER_NOEUD ();
};

#endif
