/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: connexion.cpp,v 1.3 2006/12/21 18:18:14 atila Exp $

#include "connexion.h"
#include <time.h>

int
CONNEXION::thread_attente_fin_evenement ()
{
  bool actif = false;
  while ((!actif) && (!demande_fin_thread))
    {
      connexion_tcp->gestion_globale ();
      if (connexion_tcp->etat () == ECHEC)
	{
	  etat = CONNEXION_ERREUR;
	};
      actif = (connexion_tcp->etat () == FIN_IO);
      SDL_Delay (20);
    };
  if (demande_fin_thread)
    return -1;
  else
    return 0;
};


void
CONNEXION::thread_gestion_client ()
{
  while (!((connexion_tcp) || (demande_fin_thread)));
  // initialisation de connexion;

  if (connexion_tcp)
    while ((etat != CONNEXION_ERREUR) &&
	   (etat != CONNEXION_FIN) &&
	   (etat != CONNEXION_REFUSE) &&
	   (connexion_tcp->etat () != ECHEC) && (!demande_fin_thread))
      {
	printf ("CLIENT : Le client essaie de se connecter...\n");
	connexion_tcp->mise_en_lecture ();
	printf ("CLIENT : Mise en lecture effectue\n");
	thread_attente_fin_evenement ();
	printf ("CLIENT : Rception des donnes\n");
	unsigned char msg_type;
	// traitement des infos.

	void *bbj;
	int tbj;
	connexion_tcp->recup_info (&msg_type, &bbj, tbj);
	printf ("CLIENT : Infos rcupres...\n");
	set_bloc_jeu (bbj, tbj);
	if (info_jeu)
	  {
	    connexion_tcp->ecriture (TCP_C_CONN,
				     bloc_info_joueur, taille_info_joueur);
	    thread_attente_fin_evenement ();
	    connexion_tcp->mise_en_lecture ();
	    thread_attente_fin_evenement ();
	    unsigned char msg_type;
	    // traitement des infos.
	    connexion_tcp->recup_info (&msg_type,
				       &bloc_carac_joueur,
				       taille_carac_joueur);
	    set_carac_joueur (bloc_carac_joueur, taille_carac_joueur);
	    if (msg_type == TCP_S_CONN_OK)
	      {
		etat = CONNEXION_CONNECTE;
		// On initie le download...
		MOT *recpt_bfu;
		int recpt_tfu;

		//get_fichier_up(recpt_bfu,&recpt_tfu);
		// Lancer le download.
		//thread_initie_download(recpt_bfu,recpt_tfu);

		// On rentre dans une boucle finale...
		fin_partie = false;
		tour_ecriture = true;
		time (&dernier_temps);
		printf ("CLIENT : Connection accepte .... Boucle finale.\n");
		while ((!fin_partie) && (!demande_fin_thread))
		  {
		    connexion_tcp->gestion_globale ();
		    if (thread_time_has_come ())
		      {
			if (tour_ecriture)
			  {
			    //printf("CLIENT : ping de contact \n");
			    connexion_tcp->ecriture (TCP_CS_PING, NULL, 0);
			    thread_attente_fin_evenement ();
			    tour_ecriture = false;
			  }
			else
			  {
			    //printf("CLIENT : ATTENTE ping de contact \n");
			    connexion_tcp->mise_en_lecture ();
			    thread_attente_fin_evenement ();
			    tour_ecriture = true;
			  }
		      }
		  }
	      }
	    else
	      {
		etat = CONNEXION_REFUSE;
		demande_fin_thread = true;
	      };
	  }
	else
	  {
	    etat = CONNEXION_FIN;
	    demande_fin_thread = true;
	  };
      };
};

int
CONNEXION::thread_time_has_come ()
{
  time_t temps_actuel;
  time (&temps_actuel);
  if (temps_actuel - dernier_temps > TEMPS_LAG_MAXIMAL)
    {
      time (&dernier_temps);
      return 1;
    };
  SDL_Delay (200);
  return 0;
};

void
CONNEXION::thread_passage_tour ()
{

};

void
CONNEXION::thread_gestion_serveur ()
{
  while (!((connexion_tcp) || (demande_fin_thread)));
  // initialisation de connexion;
  printf ("SERVEUR : Dbut de gestion\n");
  if (connexion_tcp)
    while ((etat != CONNEXION_ERREUR) &&
	   (etat != CONNEXION_FIN) &&
	   (etat != CONNEXION_REFUSE) &&
	   (connexion_tcp->etat () != ECHEC) && (!demande_fin_thread))
      {
	void *bloc_jeu;
	int taille_bloc;
	printf ("SERVEUR : Le serveur envoie les infos de connexion...\n");

	get_bloc_jeu (&bloc_jeu, &taille_bloc);
	connexion_tcp->ecriture (TCP_S_INFO_SERVEUR, bloc_jeu, taille_bloc);

	thread_attente_fin_evenement ();
	printf ("SERVEUR : infos envoyes...\n");
	connexion_tcp->mise_en_lecture ();
	thread_attente_fin_evenement ();

	//attendre de récupérer les infos de jeu...
	unsigned char msg_type;
	void *recpt_bij;
	int recpt_tij;
	connexion_tcp->recup_info (&msg_type, &recpt_bij, recpt_tij);
	set_info_joueur (recpt_bij, recpt_tij);

	if (msg_type == TCP_C_CONN)
	  {
	    // Demande recue. En attente de traitement.
	    void *recpt_bcj;
	    int recpt_tcj;
	    get_carac_joueur (&recpt_bcj, &recpt_tcj);
	    if (!recpt_bcj)
	      {
		// La connexion est refusée par le top level thread.
		printf ("SERVEUR : on refuse la connexion\n");
		connexion_tcp->ecriture (TCP_S_CONN_CANCEL,
					 recpt_bcj, recpt_tcj);
		thread_attente_fin_evenement ();
		demande_fin_thread = true;
	      }
	    else
	      {
		printf ("SERVEUR : connexion accepte\n");
		connexion_tcp->ecriture (TCP_S_CONN_OK, recpt_bcj, recpt_tcj);
		thread_attente_fin_evenement ();
		// On commence le download de skin ...
		// Commencer par récupérer le nom du "fichier skin"

		MOT *recpt_bfu;
		int recpt_tfu;

		//printf("Le serveur récupère la skin\n");
		//get_fichier_up(recpt_bfu,&recpt_tfu);
		//printf("Skin récupérée\n");
		// Lancer le download.
		//thread_initie_download(recpt_bfu,recpt_tfu);
		// Rentrer dans une boucle infinie ...

		fin_partie = false;
		tour_ecriture = false;
		connexion_tcp->mise_en_lecture_passive ();
		time (&dernier_temps);
		printf
		  ("SERVEUR : Connection accepte .... Boucle finale.\n");

		while ((!fin_partie) && (!demande_fin_thread))
		  {

		    connexion_tcp->gestion_globale ();
		    if (connexion_tcp->etat () == ECHEC)
		      {
			etat = CONNEXION_ERREUR;
			demande_fin_thread = true;
		      };

		    if (thread_time_has_come ())
		      {
			if (tour_ecriture)
			  {
			    connexion_tcp->ecriture (TCP_CS_PING, NULL, 0);
			    thread_attente_fin_evenement ();
			    tour_ecriture = false;
			  }
			else
			  {
			    // Passer en mode URGENT. Maintenant, plus auncun
			    // Lag accepté; RECEPTION OU MORT DU CLIENT.
			    connexion_tcp->mise_en_lecture ();
			    thread_attente_fin_evenement ();
			    tour_ecriture = true;
			  };

		      };


		  };
	      };
	  }
	else
	  {
	    // pas de connexion ? Bah, on arrete de tourner alors...
	    etat = CONNEXION_FIN;
	    demande_fin_thread = true;
	  };
      };
  etat = CONNEXION_FIN;
};

void
CONNEXION::thread_gestion_globale (void)
{
  if (client)
    thread_gestion_client ();
  else
    thread_gestion_serveur ();
  thread_termine = true;
};

void
CONNEXION::set_info_jeu (bool ij)
{
  info_jeu = ij;
};

/********************************************
 *
 *	Pour BLOC_JEU
 *
 ********************************************/

bool
CONNEXION::get_bloc_jeu_ok ()
{
  return bloc_jeu_ok;
};

int
CONNEXION::set_bloc_jeu (void *bloc, int taille)
{
  if (bloc_jeu)
    free (bloc_jeu);
  bloc_jeu = bloc;
  taille_jeu = taille;
  bloc_jeu_ok = true;
  return 0;
};

int
CONNEXION::get_bloc_jeu (void **bbj, int *tbj)
{
  while (!bloc_jeu_ok);
  *bbj = bloc_jeu;
  *tbj = taille_jeu;
  bloc_jeu = NULL;
  taille_jeu = 0;
  bloc_jeu_ok = false;
  return 0;
};

/********************************************
 *
 *	Pour INFO_JOUEUR
 *
 ********************************************/

bool
CONNEXION::get_info_joueur_ok ()
{
  return info_joueur_ok;
};

int
CONNEXION::set_info_joueur (void *bij, int tij)
{
  if (bloc_info_joueur)
    free (bloc_info_joueur);
  bloc_info_joueur = bij;
  taille_info_joueur = tij;
  info_joueur_ok = true;
  return 0;
};

int
CONNEXION::get_info_joueur (void **bij, int *tij)
{
  while (!info_joueur_ok);
  *bij = bloc_info_joueur;
  *tij = taille_info_joueur;
  bloc_info_joueur = NULL;
  taille_info_joueur = 0;
  info_joueur_ok = false;
  return 0;
};

/********************************************
 *
 *	Pour CARAC_JOUEUR
 *
 ********************************************/

bool
CONNEXION::get_carac_joueur_ok ()
{
  return carac_joueur_ok;
};

int
CONNEXION::get_carac_joueur (void **bcj, int *tcj)
{
  while (!carac_joueur_ok);
  *bcj = bloc_carac_joueur;
  *tcj = taille_carac_joueur;
  bloc_carac_joueur = NULL;
  taille_carac_joueur = 0;
  carac_joueur_ok = false;
  return 0;
};

int
CONNEXION::set_carac_joueur (void *bcj, int tcj)
{
  bloc_carac_joueur = bcj;
  taille_carac_joueur = tcj;
  carac_joueur_ok = true;
  return 0;
};

/********************************************
 *
 *	Pour FICHIER_UP
 *
 ********************************************/

bool
CONNEXION::get_fichier_up_ok ()
{
  return fichier_up_ok;
};

int
CONNEXION::set_fichier_up (MOT fichier_skin, int tfu)
{
  fichier_up.remplace_info (&fichier_skin);
  fichier_up_ok = true;
  return 0;
};

int
CONNEXION::get_fichier_up (MOT * fichier_skin, int *tfu)
{
  while (!fichier_up_ok);
  fichier_skin->remplace_info (&fichier_up);
  fichier_up_ok = false;
  return 0;
};

/********************************************
 *
 *	Pour CANAL_UDP
 *
 ********************************************/

int
CONNEXION::ecrire_canal_UDP (int no_canal, unsigned int taille, void *buffer)
{
  if (connexion_udp)
    connexion_udp->remplit_canal_emission (no_canal, buffer, taille);
};

int
CONNEXION::recuperer_canal_UDP (int no_canal, unsigned int *taille,
				void **buffer)
{
  unsigned int taille2 = 0;
  *buffer = NULL;
  *taille = 0;
  if (connexion_udp)
    connexion_udp->recupere_canal_reception (no_canal, buffer, taille2);
  *taille = taille2;
};

CONNEXION::CONNEXION (bool client_default)
{
  ID_connexion = -1;

  // init des sockets TCP et UDP.
  connexion_tcp = NULL;
  connexion_udp = NULL;

  // init de l'état de la connexion
  etat = CONNEXION_AUCUNE;

  client = client_default;

  //cherche à jouer par défaut.
  info_jeu = false;

  bloc_jeu_ok = false;
  bloc_jeu = NULL;
  taille_jeu = 0;

  info_joueur_ok = false;
  bloc_info_joueur = NULL;
  taille_info_joueur = 0;

  carac_joueur_ok = false;
  bloc_carac_joueur = NULL;
  taille_carac_joueur = 0;

  MOT fichier_skin;
  fichier_up_ok = false;

  // initialiser le thread;
  thread_termine = false;
  demande_fin_thread = false;
  thread_global = NULL;
  thread_global = SDL_CreateThread (&point_entree_thread, this);
  if (!thread_global)
    {
      thread_termine = true;
      etat = CONNEXION_ERREUR;
    };

  DeltaT_UDP = 0;
};

int
CONNEXION::connexion (int port, char *hote)
{
  // Tente une connexion UDP, puis TCP.
  int erreur;
  client = true;
  //etat=CONNEXION_AUCUNE;

  connexion_udp = new UDP (client);
  erreur = connexion_udp->connexion (port, port - 1, hote);
  if (erreur)
    {
      etat = CONNEXION_ERREUR;
      return -1;
    };

  connexion_tcp = new TCP ();
  erreur = connexion_tcp->connection_serveur (hote, port);
  if (erreur)
    {
      etat = CONNEXION_ERREUR;
      printf ("ERREUR FATALE CONNEXION TCP CLIENT->SERVEUR");
      return -1;
    };
  return 0;
};

ETAT_CONNEXION
CONNEXION::recup_etat ()
{
  return etat;
};

int
CONNEXION::recup_connexion (TCP * conn)
{
  client = false;
  connexion_tcp = conn;
  int erreur;

  connexion_udp = new UDP (client);
  MOT nom_hote;
  conn->get_nom_machine (nom_hote);
  unsigned int port_hote;
  conn->get_port_machine (port_hote);
  erreur = connexion_udp->connexion (port_hote - 1, port_hote, nom_hote.info);
  if (erreur)
    {
      etat = CONNEXION_ERREUR;
      return -1;
    };

  return 0;
};

void
CONNEXION::gestion_tour (double DeltaT)
{
  DeltaT_UDP += DeltaT;
  //if (DeltaT_UDP>0.05)
  {
    DeltaT_UDP = 0;
    if (connexion_udp)
      connexion_udp->gestion_globale ();
  }
}

CONNEXION::~CONNEXION ()
{
  demande_fin_thread = true;
  //printf("Demande la fin CLIENT %i NUM %i \n",client,ID_connexion);
  while (!thread_termine);
  //printf("Demande la fin OK CLIENT %i NUM %i \n",client,ID_connexion);
  if (connexion_tcp)
    delete connexion_tcp;
  if (connexion_udp)
    delete connexion_udp;
  if (bloc_jeu)
    free (bloc_jeu);
  if (bloc_info_joueur)
    free (bloc_info_joueur);
};

int
point_entree_thread (void *conn)
{
  ((CONNEXION *) conn)->thread_gestion_globale ();
};
