/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: context_objet.h,v 1.3 2006/12/21 18:18:14 atila Exp $


#ifndef CONTEXT_OBJET_FICHIER
#define CONTEXT_OBJET_FICHIER

#include "def_facette.h"
#include "mathsRWvsNDJ.h"
#include "deque"
#include "facette.h"

struct LOCAL_CALC_CONTEXT_OBJET
{
  // coefficient de resistance, dpend du type de deplacement.
  // ~0 si c'est l'air. ( !=0 pour eviter une singularite dans l'intgration des exponentielles)
  float k;

  RWVECTOR position;

  RWVECTOR fconstant, v_fconstant;

  RWVECTOR v_avance;
  int k_avance;

  RWVECTOR v_objet_local, v_decor_local;
  RWVECTOR v_impulsion;

  // Si il y a actuellement un contact avec un sol quelconque.
  bool contact;
  // contact avec un mur sur lequel l'objet "s'ecrase" (ou glisse)
  bool contact_mur_suit;
  // contatc avec un mur sur lequel l'objet adhere.
  bool contact_mur_acroche;

  // Type de surface;
  TYPE_MATIERE_FACETTE type_surface_contact;

  // Informel : la vitesse.
  RWVECTOR V0;

};

struct CONTEXT_OBJET
{
  // Fixe pour tout le calcul.
  RWVECTOR normale_surface;

  LOCAL_CALC_CONTEXT_OBJET contexte;

  DECLENCHE_FACETTE_PAR type;

  // paramtres fixs à l'extrieur...
  float masse;
  float rayon;

  // Volont d'avancer.
  RWVECTOR v_avance;

  // La force gnre par une explosion, une force, etc...
  RWVECTOR v_avance_involontaire;

  // Une force gnre par collision avec un autre objet.
  RWVECTOR v_pousse_objet, v_pousse_decor;

  // Force de saut.
  RWVECTOR v_saute;

  // Valeurs d'amortissements quand il y a un contact avec une surface.
  float amortissement_z, amortissement_xy;

  // Coefficient d'adhrence avec une surface.
  float k_adherence;

  // norme de la vitesse max pour pouvoir commander la marche.  
  float v_avance_max;

  // Hauteur max d'une marche.
  float hauteur_marche;

  // Des variables passées pour une action_facette...
  bool active_facette;

  // Quand on applique le résultat d'une action à un objet...
  LPACTION_SALLE lpaction_salle;

  bool action;

  float delta_vie;
  float temps_delta_vie;

  // La liste des facettes proches.
  LISTE_LPFACETTE_PROCHE liste;

  // POssibilit d'avancer sans contact;
  bool avance_sans_contact;

  // Le coefficient de gravite fournit par le jeu.
  float coeff_gravite;
};

typedef CONTEXT_OBJET *LPCONTEXT_OBJET;


#endif
