/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: controle.h,v 1.3 2006/12/21 18:18:14 atila Exp $

#ifndef FICHIER_CONTROLE_H
#define FICHIER_CONTROLE_H

#define MAX_TOUCHE 	1000

#include <SDL/SDL.h>
#include <unistd.h>

#include "stdlib.h"
#include "lecture.h"

#define TOUCHE_AVANCE 			0
#define TOUCHE_RECULE 			1
#define TOUCHE_STRAFE_GAUCHE		2
#define TOUCHE_STRAFE_DROITE		3
#define TOUCHE_TIR			4
#define TOUCHE_TEXTE			5
#define TOUCHE_ACTION			6
#define TOUCHE_SAUTE			7
#define TOUCHE_ARME			8
#define TOUCHE_VUE			20
#define TOUCHE_FULLSCREEN		21

#define MAX_TOUCHE_CONTROLE		100

#define MAX_SOURIS			6

class CONTROLE
{

  bool touche[MAX_TOUCHE];
  bool touche_simple[MAX_TOUCHE];

  bool souris[MAX_SOURIS];
  bool souris_simple[MAX_SOURIS];

//  0 -> 1000 = Touche
//  -1 vaut souris gauche
//  -2 vaut souris droite
//  -3 vaut souris centre
//  -4 vaut molette up
//  -5 vaut molette down.

  int touche_controle[MAX_TOUCHE_CONTROLE];

  int premier;

  bool isToucheActif (int i);
  bool isToucheActifComplexe (int i);
  bool getToucheActif (int &i);
  bool mouse_inverse;
  float mouse_sensib;

  float x_view, z_view, raw_x_view, raw_y_view;

public:

  float get_z_view ();
  float get_x_view ();

  float get_raw_x_view ();
  float get_raw_y_view ();

  void touche_handle (SDL_keysym * keysym, bool up);
  void gestion_globale ();

    CONTROLE ();
   ~CONTROLE ();

  bool avance ();
  bool recule ();
  bool saute ();
  bool tir ();
  bool texte ();
  bool action ();
  bool strafe_gauche ();
  bool strafe_droite ();
  bool arme (int i);
  bool arme_plus ();
  bool arme_moins ();

  int get_touche (MOT m);
  void set_avance (int i);
  void set_recule (int i);
  void set_saute (int i);
  void set_tir (int i);
  void set_texte (int i);
  void set_action (int i);
  void set_vue (int i);
  void set_strafe_gauche (int i);
  void set_strafe_droite (int i);
  void set_arme (int arme, int i);
  void set_sensibilite (float);

  float get_sensibilite ();
  MOT get_name (int);
  MOT get_avance ();
  MOT get_recule ();
  MOT get_saute ();
  MOT get_tir ();
  MOT get_texte ();
  MOT get_action ();
  MOT get_vue ();
  MOT get_strafe_gauche ();
  MOT get_strafe_droite ();
  MOT get_arme (int i);

  bool haut ();
  bool bas ();
  bool entree ();
  bool droite ();
  bool gauche ();
  bool vue ();
  bool fullscreen ();

  char lettre_appuyee ();
  char chiffre_appuyee ();
  bool efface_appuyee ();

  bool fin_jeu ();

  bool getControleActif (int &);

  void set_inverse (bool inv);
  bool get_inverse ();

};


#endif
