/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: def_3d.cpp,v 1.5 2006/12/29 12:30:17 atila Exp $

#include "def_3d.h"

/************************************/
/*******                        *****/
/*******                   OBJET      *****/
/*******                         *****/
/************************************/

OBJET::OBJET (MOT * nom_fichier, LPBLOCINFO lpblocinfo)
{
  init ();
  texture_base = 0;
  charge_fichier (nom_fichier, lpblocinfo);
}

OBJET::OBJET (BUFFER_NOEUD & BF, buffer_noeud * bf, LPBLOCINFO lpblocinfo)
{
  init ();
  texture_base = 0;
  charge_fichier (BF, bf, lpblocinfo);
}

void
OBJET::trace_objet_base ()
{
  if (GL_statique)
    {
      glCallList (GL_statique);
    }
  /*
     for (int i=0;i!=lf_statique.size();i++)
     if (lf_statique[i]->get_propriete_facette()->visible)
     lf_statique[i]->trace_facette(lpbi->lpetat_texture);
   */
  if (lpmodele)
    lpmodele->trace_objet_base ();
};

void
OBJET::fin_animation (LPBLOCINFO lpblocinfo)
{
  repere_global_OpenGL = repere_global.special_OpenGL ();
  // Manip' speciale si il faut l aligner avec la camra.
  if (aligne_camera)
    {
      MATRIX m = repere_global;
      RWVECTOR a = m.extrait_origine ();
      RWVECTOR b = lpblocinfo->lpmoteur->position_camera;
      float ux = m.extrait_x ().norme ();
      float uy = m.extrait_y ().norme ();
      b = b * (-1.0);
      b = (b - a).normalise ();
      m.translation (m.extrait_origine ());
      MATRIX m3;
      MATRIX echelle;
      echelle.echelle (RWVECTOR (ux, uy, 1));
      m3.genere_avec_u (b);
      m = m * m3 * echelle;
      repere_global_OpenGL = m.special_OpenGL ();
    };
  // Appel de la fonction d'enregistrement.
}

void
OBJET::trace_objet_final_transparent (LPBLOCINFO lpblocinfo)
{
  if (lpmodele)
    {
      if ((lf_translucide.size () == 0)
	  && (lpmodele->lf_translucide.size () == 0))
	return;
    }
  else if (lf_translucide.size () == 0)
    return;

  glMatrixMode (GL_MODELVIEW);
  glLoadMatrixf ((const GLfloat *) &repere_global_OpenGL);
  lpblocinfo->lpetat_texture->init_etat_basique ();
  lpblocinfo->lpetat_texture->set_color (1, valeur_lumiere_locale);
  lpblocinfo->lpetat_texture->set_color (0, valeur_lumiere_locale);

  for (LISTE_FACETTE::iterator i = lf_translucide.begin ();
       i != lf_translucide.end (); i++)
    {
      (*i)->trace_facette (lpblocinfo->lpetat_texture);
    };
  if (lpmodele)
    {
      for (LISTE_FACETTE::iterator i = lpmodele->lf_translucide.begin ();
	   i != lpmodele->lf_translucide.end (); i++)
	{
	  (*i)->trace_facette (lpblocinfo->lpetat_texture);
	};
    };

  if (lf_dynamique_lumiere_transparente.size ())
    {
      glEnable (GL_POLYGON_OFFSET_FILL);
      glPolygonOffset (0.0, -1.0);
      ETAT_MULTITEXTURE em;
      em.actif = true;
      em.reflechie = false;
      em.animation = 0;
      em.texture = lpblocinfo->texture_halo;
      lpblocinfo->lpetat_texture->active_etat (1, em);
      lpblocinfo->lpetat_texture->active_etat (0, em);
      lpblocinfo->lpetat_texture->set_color (0, valeur_lumiere_locale);
      glBlendFunc (GL_SRC_ALPHA, GL_ONE);

      for (LISTE_FACETTE_IMPACT::iterator i =
	   lf_dynamique_lumiere_transparente.begin ();
	   i != lf_dynamique_lumiere_transparente.end (); i++)
	{
	  (*i)->trace_facette (lpblocinfo->lpetat_texture, lpblocinfo);
	};
      glDisable (GL_POLYGON_OFFSET_FILL);
      glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    }
};

void
OBJET::trace_objet_final (LPBLOCINFO lpblocinfo)
{
  glMatrixMode (GL_MODELVIEW);
  glLoadMatrixf ((const GLfloat *) &repere_global_OpenGL);
  lpblocinfo->lpetat_texture->init_etat_basique ();
  lpblocinfo->lpetat_texture->set_color (0, valeur_lumiere_locale);
  // Vrifier si il faut appliquer une texture globale  l'objet.
  if (texture_base)
    {
      ETAT_MULTITEXTURE etatm;
      etatm.texture = texture_base;
      etatm.animation = 0;
      etatm.actif = true;
      lpblocinfo->lpetat_texture->active_etat (0, etatm);
    };
  trace_objet_base ();

  if (lf_dynamique_lumiere.size ())
    {
      glEnable (GL_POLYGON_OFFSET_FILL);
      glPolygonOffset (0.0, -1.0);
      glDepthMask (GL_FALSE);
      ETAT_MULTITEXTURE em;
      em.texture = lpblocinfo->texture_halo;
      lpblocinfo->lpetat_texture->active_etat (1, em);
      lpblocinfo->lpetat_texture->set_color (1, valeur_lumiere_locale);
      glBlendFunc (GL_SRC_ALPHA, GL_ONE);
      for (LISTE_FACETTE_IMPACT::iterator i = lf_dynamique_lumiere.begin ();
	   i != lf_dynamique_lumiere.end (); i++)
	{
	  (*i)->trace_facette (lpblocinfo->lpetat_texture, lpblocinfo);
	};
      glDisable (GL_POLYGON_OFFSET_FILL);
      glDepthMask (GL_TRUE);
      glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    }

  if (lf_dynamique.size ())
    {
      ETAT_MULTITEXTURE em;
      em.actif = true;
      lpblocinfo->lpetat_texture->active_etat (1, em);
      em.actif = false;
      lpblocinfo->lpetat_texture->active_etat (0, em);
      glDepthMask (GL_FALSE);
      for (LISTE_FACETTE_IMPACT::iterator i = lf_dynamique.begin ();
	   i != lf_dynamique.end (); i++)
	{
	  (*i)->trace_facette (lpblocinfo->lpetat_texture, lpblocinfo);
	};
      glDepthMask (GL_TRUE);
    }

};

void
OBJET::charge_fichier (MOT * nom_fichier, LPBLOCINFO lpblocinfo)
  // Chargement d'un objet ...
{
  init ();
  BUFFER_NOEUD BF (lpblocinfo->lpbdd, nom_fichier);
  buffer_noeud *bf = BF.ROOT ();
  MOT vide;
  if ((!bf) && (!(*nom_fichier == vide)))
    {
      printf ("Objet 3D non-trouv : %s\n", nom_fichier->info);
      return;
    }
  //printf("Fichier Objet %s\n",nom_fichier->info);
  charge_fichier (BF, bf, lpblocinfo);
}

void
OBJET::charge_fichier (BUFFER_NOEUD & BF, buffer_noeud * bf,
		       LPBLOCINFO lpblocinfo)
  // Chargement d'un objet ...
{
  //printf("Chargement objet \n");
  bool sensibleobjet = true;
  bool sensibleballe = true;
  bool visible = true;
  bool blend = false;
  buffer_noeud *orig_bf = bf;
  float TexGenX = 1.0;
  float TexGenY = 1.0;

  ETAT_MULTITEXTURE etatm;
  if (lpblocinfo->client)
    {
      lpblocinfo->lpetat_texture->init_etat_basique ();
    }
  while (bf)
    {
      //     printf("-- NOEUD %i\n",BF.get_nom (bf));
      switch (BF.get_nom (bf))
	{
	case CONSTANTE_SCRIPT_FACETTE:
	  {
	    LPFACETTE lpf =
	      new FACETTE (&BF, BF.get_fils (bf), etatm, TexGenX, TexGenY);
	    lpf->get_propriete_facette ()->visible = visible;
	    lpf->get_propriete_facette ()->transparent = blend;
	    lpf->get_propriete_facette ()->additif = (etatm.additif == 2);
	    lpf->get_propriete_facette ()->sensible_objet = sensibleobjet;
	    lpf->get_propriete_facette ()->sensible_balle = sensibleballe;
	    lf_statique.insert (lf_statique.end (), lpf);
	    if (blend)
	      lf_translucide.insert (lf_translucide.begin (), lpf);
	    //printf("Fin facette\n");
	    break;
	  }
	case CONSTANTE_SCRIPT_TEXTURE:
	  {
	    if (lpblocinfo->client)
	      etatm.texture =
		lpblocinfo->lpbanque_texture->trouve_texture (lpblocinfo->
							      lpbdd, &BF,
							      BF.
							      get_fils (bf),
							      blend);
	    etatm.animation = 0;
	    break;
	  }
	case CONSTANTE_SCRIPT_ANIMATION:
	  {
	    MOT nom_anim = BF.get_MOT (bf);
	    if (lpblocinfo->client)
	      etatm.animation =
		lpblocinfo->lpbanque_animation_texture->
		trouve_animation_texture (lpblocinfo, nom_anim, blend);
	    etatm.texture = 0;
	    break;
	  }
	case CONSTANTE_SCRIPT_SENSIBLEOBJET:
	  {
	    sensibleobjet = true;
	    break;
	  }
	case CONSTANTE_SCRIPT_INSENSIBLEOBJET:
	  {
	    sensibleobjet = false;
	    break;
	  }
	case CONSTANTE_SCRIPT_SENSIBLEBALLE:
	  {
	    sensibleballe = true;
	    break;
	  }
	case CONSTANTE_SCRIPT_INSENSIBLEBALLE:
	  {
	    sensibleballe = false;
	    break;
	  }
	case CONSTANTE_SCRIPT_VISIBLE:
	  {
	    visible = true;
	    break;
	  }
	case CONSTANTE_SCRIPT_INVISIBLE:
	  {
	    visible = false;
	    break;
	  }
	case CONSTANTE_SCRIPT_ALIGNECAMERA:
	  {
	    aligne_camera = true;
	    break;
	  }
	case CONSTANTE_SCRIPT_LUMIERE:
	  {
	    info_lumiere = INFO_LUMIERE (&BF, BF.get_fils (bf));
	    break;
	  }
	case CONSTANTE_SCRIPT_PORTAL:
	  {
	    // Rcuprer le nom chaine,
	    PORTAL portal;
	    buffer_noeud *bf2 = BF.get_fils (bf);
	    if (bf2)
	      {
		buffer_noeud *bf3 =
		  BF.trouve_suivant (bf2, CONSTANTE_SCRIPT_OBJET);
		buffer_noeud *bf4 =
		  BF.trouve_suivant (bf2, CONSTANTE_SCRIPT_FACETTE);
		if ((bf3) && (bf4))
		  {
		    portal.nom_objet = BF.get_MOT (bf3);
		    portal.facette =
		      new FACETTE (&BF, BF.get_fils (bf4), etatm, 1.0, 1.0);
		    l_portal.insert (l_portal.begin (), portal);
		  }
		else
		  printf
		    ("WARNING : Portal mal dfini: facette ou objet manquant !!!!");
	      }
	    else
	      printf ("WARNING : Portal mal dfini !!!!");
	    break;
	  }
	case CONSTANTE_SCRIPT_ATTRIBUTTEXTURE:
	  {
	    buffer_noeud *bf2 = BF.get_fils (bf);
	    if (bf2)
	      {
		while (bf2)
		  {
		    switch (BF.get_nom (bf2))
		      {
		      case CONSTANTE_SCRIPT_REFLECHI:
			etatm.reflechie = true;
			break;
		      case CONSTANTE_SCRIPT_NONREFLECHI:
			etatm.reflechie = false;
			break;
		      case CONSTANTE_SCRIPT_BLENDINGADDITIF:
			etatm.additif = 2;
			break;
		      case CONSTANTE_SCRIPT_BLENDINGNORMAL:
			etatm.additif = 1;
			break;
		      case CONSTANTE_SCRIPT_TEXX:
			TexGenX = BF.get_float (bf2);
			break;
		      case CONSTANTE_SCRIPT_TEXY:
			TexGenY = BF.get_float (bf2);
			break;
		      };
		    bf2 = BF.trouve_suivant (bf2);
		  };
	      };
	    break;
	  };
	}
      bf = BF.trouve_suivant (bf);
    }
  calcul_parametres_objet ();

  if (lpblocinfo->client)
    {
      lpblocinfo->lpetat_texture->init_etat_basique ();
      GL_statique = glGenLists (1);
      glNewList (GL_statique, GL_COMPILE);
      for (int i = 0; i != lf_statique.size (); i++)
	if (lf_statique[i]->get_propriete_facette ()->visible)
	  if (!(lf_statique[i]->get_propriete_facette ()->transparent))
	    lf_statique[i]->trace_facette (lpblocinfo->lpetat_texture);
      glEndList ();
    }
  //printf("Fin Chargement objet\n");
};

OBJET::OBJET ()			// init bestiale
{
  init ();
};

void
OBJET::init ()			// init bestiale
{
  GL_statique = 0;
  aligne_camera = false;
  lpmodele = NULL;
  frame_lumiere = -1;
  texture_base = 0;
  is_portal = false;
  is_camera = false;
  refreshTime = 0.0;
  activation = 0;
  calcul_inverse = false;
}

LPOBJET
OBJET::copie_objet ()
{
  LPOBJET copie;
  copie = new OBJET ();
  copie->index_pere = index_pere;
  copie->lpparent = NULL;
  copie->info_lumiere = info_lumiere;
  copie->aligne_camera = aligne_camera;
  if (lpmodele)
    copie->lpmodele = lpmodele;
  else
    copie->lpmodele = this;
  copie->boite = boite;
  copie->nom = nom;
  copie->nom_pere = nom_pere;
  copie->GL_statique = 0;
  copie->valeur_lumiere = valeur_lumiere;
  copie->valeur_lumiere_locale = valeur_lumiere_locale;
  copie->is_camera = is_camera;

  // Les listes sont initialises comme des lments vides.

  return copie;
};


void
OBJET::set_index_pere (int i)
{
  index_pere = i;
};

void
OBJET::set_nom (MOT * m)
{
  nom = *m;
  if (nom == MOT ("camera"))
    {
      is_camera = true;
      printf ("Trouve une camera\n");
    }
};

void
OBJET::set_nom_pere (MOT * m)
{
  nom_pere = *m;
};

MOT *
OBJET::get_nom ()
{
  return &nom;
};

MOT *
OBJET::get_nom_pere ()
{
  return &nom_pere;
};

int
OBJET::get_index_pere ()
{
  return index_pere;
};

void
OBJET::set_lpparent (LPOBJET lpo)
{
  lpparent = lpo;
};

OBJET::~OBJET ()
{
  if (GL_statique)
    glDeleteLists (GL_statique, 1);
  // On supprime les facettes restantes.
  for (LISTE_FACETTE_IMPACT::iterator i = lf_dynamique.begin ();
       i != lf_dynamique.end (); i++)
    {
      delete (*i);
    };
  for (LISTE_FACETTE_IMPACT::iterator i = lf_dynamique_lumiere.begin ();
       i != lf_dynamique_lumiere.end (); i++)
    {
      delete (*i);
    };
  for (LISTE_FACETTE_IMPACT::iterator i =
       lf_dynamique_lumiere_transparente.begin ();
       i != lf_dynamique_lumiere_transparente.end (); i++)
    {
      delete (*i);
    };
  for (LISTE_FACETTE::iterator i = lf_statique.begin ();
       i != lf_statique.end (); i++)
    {
      delete (*i);
    };
};

void
OBJET::calcul_parametres_objet ()
{
  for (LISTE_FACETTE::iterator i = lf_statique.begin ();
       i != lf_statique.end (); i++)
    {
      (*i)->calcul_parametres_solides ();
      boite.MAJ ((*i)->get_boite ());
    };
  //boite.print();
};

void
OBJET::calcul_matrices_inverse ()
{
  // Calculer le point inverse...
  if (!calcul_inverse)
    {
      calcul_inverse = true;
      lrepere_global_inverse = lrepere_global.inverse ();
      repere_global_inverse = repere_global.inverse ();
    }
}

void
OBJET::ajoute_facettes_proches (RWVECTOR point,
				float distance,
				LPLISTE_LPFACETTE_PROCHE liste,
				LPANIMATION lpanim)
{
  calcul_matrices_inverse ();
  point = repere_global_inverse.transforme (point);
  if (boite.distance (point) < distance)
    {
      ajoute_facette_proches_liste (point, distance, liste, &lf_statique,
				    lpanim);
      if (lpmodele)
	ajoute_facette_proches_liste (point,
				      distance,
				      liste, &lpmodele->lf_statique, lpanim);
    }
}

void
OBJET::ajoute_facette_proches_liste (RWVECTOR point,
				     float distance,
				     LPLISTE_LPFACETTE_PROCHE liste,
				     LISTE_FACETTE * lpliste,
				     LPANIMATION lpanim)
{
  LPFACETTE_PROCHE facette = NULL;
  for (LISTE_FACETTE::iterator i = lpliste->begin (); i != lpliste->end ();
       i++)
    {
      //printf("%f %f -- %f %f %f\n",(*i)->distance_boite(point),distance,point.x(),point.y(),point.z());
      if ((*i)->distance_boite (point) < distance)
	{
	  if (facette == NULL)
	    {
	      facette = new FACETTE_PROCHE;
	      facette->lpobjet = this;
	      facette->lpanim = lpanim;
	      liste->insert (liste->begin (), facette);
	    }
	  facette->liste_facette.insert (facette->liste_facette.begin (),
					 (*i));
	}
    }
}


void
OBJET::pre_mix ()
{
  sauve_local = repere_local;
}

void
OBJET::mix (float t)
{
  MATRIX m2 = repere_local;
  repere_local.mix (t, repere_local, sauve_local);
}

bool
OBJET::impact (RWVECTOR & a, RWVECTOR & b, LPFACETTE * touche)
{
  bool toucheretour = false;
  calcul_matrices_inverse ();
  // Passer a et b dans le repre local.
  RWVECTOR aprime = repere_global_inverse.transforme (a);
  RWVECTOR bprime = repere_global_inverse.transforme (b);

  if (boite.intersection (aprime, bprime))
    {
      for (LISTE_FACETTE::iterator i = lf_statique.begin ();
	   i != lf_statique.end (); i++)
	{
	  if ((*i)->interaction_base (aprime, bprime, 0.0))
	    {
	      *touche = *i;
	      toucheretour = true;
	    }
	}
      if (lpmodele)
	{
	  for (LISTE_FACETTE::iterator i = lpmodele->lf_statique.begin ();
	       i != lpmodele->lf_statique.end (); i++)
	    {
	      if ((*i)->interaction_base (aprime, bprime, 0.0))
		{

		  *touche = *i;
		  toucheretour = true;
		}
	    }
	}
    }
  if (toucheretour)
    {
      b = repere_global.transforme (bprime);
    }
  return toucheretour;
}

//*************************************************
//      Pour implmenter classe_modele
//*************************************************

int
OBJET::charge_avec_fichier (void *data, LPBLOCINFO lpblocinfo)
{
  CLASSE_MODELE::charge_avec_fichier (data, lpblocinfo);
  charge_fichier ((MOT *) data, lpblocinfo);
};

CLASSE_MODELE *
OBJET::duplique_element ()
{
  LPOBJET lpo = copie_objet ();
  return lpo;
};

//*************************************************
//      Pour faire des impacts sphriques.
//*************************************************

bool
  OBJET::impact_sphere (RWVECTOR & point,
			float distance,
			float distance_facette, int ID, float temps)
{
  bool retour = false;
  calcul_matrices_inverse ();
  RWVECTOR plocal = repere_global_inverse.transforme (point);
  for (LISTE_FACETTE::iterator i = lf_statique.begin ();
       i != lf_statique.end (); i++)
    {
      FACETTE_IMPACT *fi;
      if ((*i)->impact_sphere (plocal, distance, distance_facette, &fi))
	{
	  fi->set_Tmax (temps);
	  lf_dynamique.insert (lf_dynamique.end (), fi);
	  retour = true;
	  fi->set_nom (ID);
	}
    }
  if (lpmodele)
    for (LISTE_FACETTE::iterator i = lpmodele->lf_statique.begin ();
	 i != lpmodele->lf_statique.end (); i++)
      {
	FACETTE_IMPACT *fi;
	if ((*i)->impact_sphere (plocal, distance, distance_facette, &fi))
	  {
	    fi->set_Tmax (temps);
	    lf_dynamique.insert (lf_dynamique.end (), fi);
	    retour = true;
	    fi->set_nom (ID);
	  }
      }
  return retour;
};

void
OBJET::set_T (float diff)
{
  LISTE_FACETTE_IMPACT::iterator i, i2, i3, i4;
  for (i = lf_dynamique.begin (); i != lf_dynamique.end (); i++)
    (*i)->set_T (diff);
  i = lf_dynamique.begin ();
  while (i != lf_dynamique.end ())
    {
      if ((*i)->set_T (0))
	{
	  delete (*i);
	  lf_dynamique.erase (i, i + 1);
	  i = lf_dynamique.begin ();
	}
      else
	i++;
    };
};

void
OBJET::set_dynamique (int ID, MATRIX & m, GLuint text_desc)
{
  for (LISTE_FACETTE_IMPACT::iterator i = lf_dynamique.begin ();
       i != lf_dynamique.end (); i++)
    {
      if ((*i)->test_ID (ID))
	{
	  (*i)->set_info (m, text_desc);
	}
    }
}

/****************** POUR LA GESTION DE LA LUMIERE ************/

ZONE_LUMIERE
OBJET::get_zone_lumiere ()
{
  return info_lumiere.zone_lumiere;
};

void
OBJET::nettoie_impact_sphere_lumiere ()
{
  for (LISTE_FACETTE_IMPACT::iterator i = lf_dynamique_lumiere.begin ();
       i != lf_dynamique_lumiere.end (); i++)
    {
      delete (*i);
    };
  lf_dynamique_lumiere.erase (lf_dynamique_lumiere.begin (),
			      lf_dynamique_lumiere.end ());

  for (LISTE_FACETTE_IMPACT::iterator i =
       lf_dynamique_lumiere_transparente.begin ();
       i != lf_dynamique_lumiere_transparente.end (); i++)
    {
      delete (*i);
    };
  lf_dynamique_lumiere_transparente.erase (lf_dynamique_lumiere_transparente.
					   begin (),
					   lf_dynamique_lumiere_transparente.
					   end ());
  // Initialisation des loupiotes aux valeurs perso...
  valeur_lumiere_locale = VALEUR_LUMIERE ();
  for (LISTE_FACETTE_IMPACT::iterator i = lf_dynamique.begin ();
       i != lf_dynamique.end (); i++)
    {
      (*i)->reset_couleur_lumiere ();
    };
};

void
OBJET::lumiere (LPOBJET source, TypeLumiere type_lumiere)
{
  if ((source->info_lumiere.zone_lumiere == LUMIERE_ABSENTE) ||
      (source->info_lumiere.type_lumiere == LUMIERE_SANS))
    return;
  if (source->activation < 0)
    return;
  float distance = 0;

  //printf("%s %s -- %i %i -- %f %f %f\n",
  //     nom.info,source->nom.info,
  //     source->info_lumiere.zone_lumiere,
  //     source->info_lumiere.type_lumiere,
  //    source->valeur_lumiere.R,
  //    source->valeur_lumiere.G,
  //    source->valeur_lumiere.B);
  TYPE_LUMIERE tl = source->info_lumiere.type_lumiere;
  if ((tl == LUMIERE_SPOT) & (type_lumiere == TypeLumiereVertex))
    tl = LUMIERE_AMBIANTE_DIFFUSE;
  switch (tl)
    {
    case LUMIERE_SPOT:
      {
	if (source->valeur_lumiere.rayon <= 0.0)
	  return;
	//printf("SPOT %f %i\n",source->valeur_lumiere.rayon,source->activation);
	source->calcul_matrices_inverse ();
	RWVECTOR point (source->repere_global.extrait_origine ());
	calcul_matrices_inverse ();
	distance = source->valeur_lumiere.rayon;
	RWVECTOR plocal = repere_global_inverse.transforme (point);
	float maxDim = boite.maxDim ();
	float rayon = source->valeur_lumiere.rayon;
	//      printf("%s maxDim %f dist %f\n ",nom.info,maxDim,boite.distance(plocal),source->valeur_lumiere.rayon);
	// SI source trop loigne...
	if (boite.distance (plocal) > source->valeur_lumiere.rayon)
	  return;

	// Si petit objet  clairer par rapport  la source...
	if (maxDim < source->valeur_lumiere.rayon * 0.2)
	  {
	    // Calcul d'intensit moyenne.
	    float dist = (boite.centre () - plocal).norme ();
	    dist = 1 - dist / source->valeur_lumiere.rayon;
	    // Appliquer une lumiere surfacique globale en 1ire approximation...
	    if (dist > 0.0)
	      valeur_lumiere_locale.somme (source->valeur_lumiere, dist);
	  }
	else
	  {
	    if (lpmodele)
	      {
		for (LISTE_FACETTE::iterator i =
		     lpmodele->lf_statique.begin ();
		     i != lpmodele->lf_statique.end (); i++)
		  if ((*i)->get_propriete_facette ()->visible)
		    if (!((*i)->get_propriete_facette ()->additif))
		      {
			FACETTE_IMPACT *fi;
			if ((*i)->
			    impact_sphere (plocal, distance, 0.0005, &fi))
			  {
			    fi->set_couleur_RGB (source->valeur_lumiere);
			    if ((*i)->get_propriete_facette ()->transparent)
			      lf_dynamique_lumiere_transparente.
				insert (lf_dynamique_lumiere_transparente.
					end (), fi);
			    else
			      lf_dynamique_lumiere.
				insert (lf_dynamique_lumiere.end (), fi);
			  }
		      }
	      }
	    for (LISTE_FACETTE::iterator i = lf_statique.begin ();
		 i != lf_statique.end (); i++)
	      if ((*i)->get_propriete_facette ()->visible)
		if (!((*i)->get_propriete_facette ()->additif))
		  {
		    FACETTE_IMPACT *fi;
		    if ((*i)->impact_sphere (plocal, distance, 0.0005, &fi))
		      {
			fi->set_couleur_RGB (source->valeur_lumiere);
			if ((*i)->get_propriete_facette ()->transparent)
			  lf_dynamique_lumiere_transparente.
			    insert (lf_dynamique_lumiere_transparente.end (),
				    fi);
			else
			  lf_dynamique_lumiere.insert (lf_dynamique_lumiere.
						       end (), fi);
		      }
		  }

	  };
	// Rajouter une couleur pour les facettes dynamiques. La rfrence est un point (approx.)
	for (LISTE_FACETTE_IMPACT::iterator i = lf_dynamique.begin ();
	     i != lf_dynamique.end (); i++)
	  {
	    float dist = (plocal - (*i)->centre ()).norme ();
	    //printf("dist %f \n ",dist);
	    float attenuation = 1 - dist / rayon;
	    VALEUR_LUMIERE vl = source->valeur_lumiere * attenuation;
	    if (attenuation > 0.0)
	      {
		(*i)->add_couleur_lumiere (vl);
	      }
	  };
      }
      break;
    case LUMIERE_AMBIANTE:
      {
	valeur_lumiere_locale.somme (source->valeur_lumiere, 1);
      }
      break;
    case LUMIERE_AMBIANTE_DIFFUSE:
      {
	if (source->valeur_lumiere.rayon <= 0.0)
	  return;
	float v1, v2, ratio, ratio2, ratio_fin;
	v1 = boite.volume ();
	v2 = source->boite.volume ();
	if (v2)
	  ratio = v2 / v1;
	else
	  return;
	if (ratio > 1.0)
	  ratio = 1.0;
	source->calcul_matrices_inverse ();
	calcul_matrices_inverse ();
	float rayon = source->valeur_lumiere.rayon;
	distance = boite.distance (source->boite,
				   source->repere_global,
				   source->repere_global_inverse,
				   repere_global, repere_global_inverse);
	if (distance > rayon)
	  return;
	if (rayon != 0)
	  ratio2 = 1 - distance / rayon;
	else
	  ratio2 = 1.0;
	//printf ("ratio %f ratio2 %f distance %f\n", ratio, ratio2, distance);
	ratio_fin = ratio * ratio2;
	valeur_lumiere_locale.somme (source->valeur_lumiere, ratio_fin);
      }
      break;
    case LUMIERE_CONE:

      break;
    }
}

void
OBJET::init_lumiere ()
{
  valeur_lumiere = VALEUR_LUMIERE ();
};

bool
OBJET::valeur_lumiere_isNul ()
{
  return
    (valeur_lumiere.R == 0) &&
    (valeur_lumiere.G == 0) && (valeur_lumiere.B == 0);
};

void
OBJET::ajoute_lumiere_blanche ()
{
  valeur_lumiere_locale.R = 1.0;
  valeur_lumiere_locale.G = 1.0;
  valeur_lumiere_locale.B = 1.0;
};

void
OBJET::set_texture_objet (GLuint no_texture)
{
  texture_base = no_texture;
};

void
OBJET::fin_lumiere ()
{
  for (LISTE_FACETTE_IMPACT::iterator i = lf_dynamique.begin ();
       i != lf_dynamique.end (); i++)
    {
      (*i)->add_couleur_lumiere (valeur_lumiere_locale);
    };
  for (LISTE_FACETTE_IMPACT::iterator i =
       lf_dynamique_lumiere_transparente.begin ();
       i != lf_dynamique_lumiere_transparente.end (); i++)
    {
      (*i)->add_couleur_lumiere (valeur_lumiere_locale);
    };
};

void
OBJET::connecte_moteur3d (MOT nom_animation, LPBLOCINFO lpblocinfo)
{
  if (l_portal.size () != 0)
    {
      lpblocinfo->lpmoteur->insert_portal ((LPOBJET) this, nom_animation, nom,
					   l_portal);
      l_portal.clear ();
      is_portal = true;
    }
};

BOITE & OBJET::get_boite ()
{
  return boite;
}
