/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: def_texture.h,v 1.3 2006/12/21 18:18:14 atila Exp $

#ifndef fichier_texture
#define fichier_texture

#include <deque>
#include "buffer_noeud.h"
#include "banque.h"
#include "bloc_info.h"
#include "lumiere.h"

/*********************************************/
/* Création des classes de recherche texture */
/*********************************************/

class DESCRIPTEUR_TEXTURE
{
public:
  MOT nom;
  MOT nom_fichier_gestion;
  MOT nom_fichier_blending;
  int blend_type;
  // 0 : pas touche;
  // 1 : pas touche sauf (0,0,0) à zero.
  // 2 : approprié : moyenne des intensités de chaque composante;
  // 3 : niveau_fixe dans blend. 
  // 4 : niveau_fixe dans blend; (0,0,0) à zero quand même.
  // 5 : (0,0,0) à blend. Le reste opaque.
  // 6 : Tiré d'un fichier spécifique pour le blending.
  // 7 : Tiré d'un fichier spécifique pour le blending : A SPECIFIER.... (to be continued)
  int blend;
  bool operator== (DESCRIPTEUR_TEXTURE & d2);
    DESCRIPTEUR_TEXTURE (BUFFER_NOEUD * BF, buffer_noeud * bn);
    DESCRIPTEUR_TEXTURE ();
  void RAZ ();
   ~DESCRIPTEUR_TEXTURE ();
};

//
// Un redéfinition un peu plus "violente" de CLASSE_MODELE
// L'opérateur d'égalité est un renvoi vers celui de 
// DESCRIPTEUR_TEXTURE.
//

#include <GL/gl.h>

class ELEMENT_TEXTURE:CLASSE_MODELE
{
  DESCRIPTEUR_TEXTURE descripteur;
  GLuint GLdesc;
  unsigned char *lptexture;
  int TailleX, TailleY;

public:  bool chek_ID (DESCRIPTEUR_TEXTURE & desc);
  GLuint chargement (DESCRIPTEUR_TEXTURE * desc, BDD * bdd);
  int conversionRGB_24 ();
  void LoadFromPCXFile (MOT * filename, BDD * bdd);
  // Des PC X-File ??? (saison 5)
  // ... 
  // Nous sommes en septembre 2001, j'ai écrit ca il y a
  // 2 ans, et je n'assume absolument pas.
  GLuint get_GLdesc ();
    ELEMENT_TEXTURE ();
   ~ELEMENT_TEXTURE ();

  // Surcharge de CLASSE_MODELE...
  bool operator== (void *data);
  int charge_avec_fichier (void *data, LPBLOCINFO lpblocinfo);
  CLASSE_MODELE *duplique_element ();
  // Tester la transparence.
  bool transparent ();
};

typedef ELEMENT_TEXTURE *LPELEMENT_TEXTURE;

/************************************************/
/* Classe de banque texture			*/
/************************************************/

class BANQUE_TEXTURE:BANQUE < ELEMENT_TEXTURE >
{

public:bool texture_existe (DESCRIPTEUR_TEXTURE * desc, BDD * bdd);
  GLuint trouve_texture (DESCRIPTEUR_TEXTURE * desc, BDD * bdd);
  ELEMENT_TEXTURE *trouve_texture_brutal (DESCRIPTEUR_TEXTURE * desc,
					  BDD * bdd);
  GLuint trouve_texture (BDD * bdd, BUFFER_NOEUD * BF, buffer_noeud * bn);
  GLuint trouve_texture (BDD * bdd, BUFFER_NOEUD * BF, buffer_noeud * bn,
			 bool & blend);
    BANQUE_TEXTURE ();
   ~BANQUE_TEXTURE ();
  void recharge ();
};

typedef BANQUE_TEXTURE *LPBANQUE_TEXTURE;

/************************************************/
/* Classe d'tat texture			*/
/* Sert  ne pas rexpdier les commandes      */
/* OpenGL quand il y a redondance               */
/************************************************/

class ETAT_MULTITEXTURE
{
public:
  // Les etats locaux aux multitextures.
  GLuint texture;
  GLuint animation;
  bool reflechie;
  bool actif;

  // 2 etats globaux.
  // 0 : indiffrent, 1: non, 2:oui
  int additif;

    ETAT_MULTITEXTURE ();
   ~ETAT_MULTITEXTURE ();

};

class ETAT_TEXTURE
{
  // 4 banques max...
  ETAT_MULTITEXTURE etat_multitexture[4];


  //  numero des constantes OpenGL
  int CST_OPENGL[4];

  // Le numero actif actuel.
  int ARB_actif;

  // Est-on en couleur additive ?
  bool additif;

public:
    ETAT_TEXTURE ();
   ~ETAT_TEXTURE ();

  // Appel avant l'affichage d'un objet.
  // 1 Dsactiv.
  // 0 Activ. 
  // 0 et 1 : Text=0; Anim=0; reflechi=0; textureMat=ID
  void init_etat_basique ();
  void active_etat (int numero, ETAT_MULTITEXTURE);

  void set_color (int numero, VALEUR_LUMIERE);

};

#endif
