/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: dico.cpp,v 1.2 2006/12/29 12:30:17 atila Exp $


#include "dico.h"
#include "bdd.h"

DICO::DICO (LPBDD bdd)
{
  for (int i=0; i<MAX_LETTRE; i++)
    {
      char nom_buffer[128];
      sprintf(nom_buffer, "d_commun/d_dict/FR-%i.filtre.dict", i);
      MOT nom(nom_buffer);
      int taille=bdd->extrait_fichier_buffer (&nom, &(mots[i]), &(taille_dico[i]));
      if (taille < 0 ) taille_dico[i]=0;
    }
};

DICO::~DICO ()
{
  for (int i=0; i<MAX_LETTRE; i++)
    {
      if (mots[i] != NULL)
	{
	  free(mots[i]);
	};
    }
};

MOT DICO::get_mot_hasard(int taille_min,int taille_max)
{
  int taille=rand()%(taille_max - taille_min + 1) + taille_min;
  int position=rand()%(taille_dico[taille]);
  int position_org=position;
  while ((mots[taille][position]!='\n')&&(mots[taille][position]!=0)&&(position<taille_dico[taille]))
    {
      position++;
    }
  if (position==taille_dico[taille]) 
    {
      position=0;
    }
  else
    {
      position++;
    }
  MOT resultat;
  while ((mots[taille][position]!='\n')&&(mots[taille][position]!=0)&&(position<taille_dico[taille]))
    {
      char c=mots[taille][position]+'A'-'a';
      resultat.ajoute_caractere(mots[taille][position]+'A'-'a');
      position++;
    }
  return resultat;
};
