/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: jeu_debris.cpp,v 1.3 2006/12/21 18:18:14 atila Exp $

#include "jeu_debris.h"


JEU_DEBRIS::JEU_DEBRIS (MOT & nom_animation,
			RWVECTOR position,
			RWVECTOR vitesse,
			float rayon, float masse, float temps,
			LPBLOCINFO lpblocinfo)
{
  context_objet.rayon = rayon;
  context_objet.masse = masse;
  temps_restant = temps;	// Le temps de positionner les bonnes variables.
  lpblocinfo->lpbanque_animation->trouve_element ((void *) &nom_animation,
						  lpblocinfo, &lpanimation);
  context_objet.contexte.position = position;
  context_objet.v_avance_involontaire = vitesse;

  context_objet.amortissement_z = 1.8;
  context_objet.amortissement_xy = 0.8;

  rotation_x = 0.0;
  rotation_y = 0.0;
  rotation_z = 0.0;

  protation_x = float (rand ()) * (10.0) / float (RAND_MAX) - 5.0;
  protation_y = float (rand ()) * (10.0) / float (RAND_MAX) - 5.0;
  protation_z = float (rand ()) * (10.0) / float (RAND_MAX) - 5.0;
};


JEU_DEBRIS::~JEU_DEBRIS ()
{
};

void
JEU_DEBRIS::gestion_globale (LPBLOCINFO lpblocinfo)
{
  ELEMENTJEU::gestion_globale (lpblocinfo);
  temps_restant -= lpblocinfo->diff;
  // SI son temps de vie s'acheve, on le fait mourir.
  if (temps_restant < 0.0)
    {
      suicide = true;
    };
  if (lpblocinfo->client)
    {
      if (lpanimation)
	{
	  rotation_x += protation_x * lpblocinfo->diff;
	  rotation_y += protation_y * lpblocinfo->diff;
	  rotation_z += protation_z * lpblocinfo->diff;
	  lpanimation->init_animation ();
	  BLOCINFO blocinfo2 = *lpblocinfo;
	  MATRIX m, mx, my, mz;
	  m.translation (context_objet.contexte.position);
	  mx.rotationx (rotation_x);
	  my.rotationy (rotation_y);
	  mz.rotationz (rotation_z);
	  m = m * mx * my * mz;
	  lpanimation->fin_animation (&blocinfo2, &m);
	}
    }
};

void
JEU_DEBRIS::lecture (LPBLOCINFO lpblocinfo, STOCK & stock,
		     int &position_stock)
{
  // rien en principe
};

void
JEU_DEBRIS::ecriture (LPBLOCINFO lpblocinfo, STOCK & stock)
{
  // rien en principe
};
