/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: jeu_debris.h,v 1.3 2006/12/21 18:18:14 atila Exp $


/***************************************************
 *
 * Un ELEMENTJEU pour la gestion des debris : explosion et gore.
 * c'est un element inactif, il est cre et gere uniquement par le client.
 *
 ****************************************************/


#ifndef JEU_DEBRIS_FICHIER
#define JEU_DEBRIS_FICHIER

#include "jeu.h"
#include "animation_texture.h"
#include "def_texture.h"


// Le bloc qui est pass entre le serveur et le client.
typedef struct BLOC_JEU_DEBRIS
{
  // Temps d'apparition restant. A 0.0, on dtruit l'objet.
  float temps_restant;
  // 
  RWVECTOR position, vitesse_initiale;
};

class JEU_DEBRIS:public ELEMENTJEU
{
  // timing associ avec suppression...
  float temps_restant;

  float rotation_x, rotation_y, rotation_z;
  float protation_x, protation_y, protation_z;

public:

    virtual short int typeElementJeu ()
  {
    return TYPE_DEBRIS;
  };
  virtual bool serverKill ()
  {
    return false;
  };

  JEU_DEBRIS (MOT & nom_animation,
	      RWVECTOR position,
	      RWVECTOR vitesse,
	      float rayon, float masse, float temps, LPBLOCINFO lpblocinfo);

  ~JEU_DEBRIS ();
  void gestion_globale (LPBLOCINFO lpblocinfo);

  void lecture (LPBLOCINFO lpblocinfo, STOCK & stock, int &position_stock);
  void ecriture (LPBLOCINFO lpblocinfo, STOCK & stock);
};

#endif
