/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: jeu_impact.cpp,v 1.3 2006/12/21 18:18:14 atila Exp $

#include "jeu_impact.h"


JEU_IMPACT::JEU_IMPACT ()
{
// Positionner quelques variables.

// Ceci pour ne garantir AUCUNE interaction...
  context_objet.rayon = 0;
  context_objet.masse = 0;
  bloc_jeu_impact.temps_restant = 10;	// Le temps de positionner les bonnes variables.
  preinit = false;
};

bool
JEU_IMPACT::serverKill ()
{
  return false;
};

JEU_IMPACT::~JEU_IMPACT ()
{
};

void
JEU_IMPACT::lecture (LPBLOCINFO lpblocinfo, STOCK & stock,
		     int &position_stock)
{
  ELEMENTJEU::lecture (lpblocinfo, stock, position_stock);
  if (!preinit)
    {
      bloc_jeu_impact =
	*((BLOC_JEU_IMPACT *) stock.get_posbuffer (position_stock));
      init_standard (lpblocinfo);
      // Premire mise en place.
      gestion_globale (lpblocinfo);
    }
  position_stock += sizeof (struct BLOC_JEU_IMPACT);
};

void
JEU_IMPACT::ecriture (LPBLOCINFO lpblocinfo, STOCK & stock)
{
  ELEMENTJEU::ecriture (lpblocinfo, stock);
  stock.put_buffer ((char *) &bloc_jeu_impact,
		    sizeof (struct BLOC_JEU_IMPACT));
};

void
JEU_IMPACT::gestion_globale (LPBLOCINFO lpblocinfo)
{
  bloc_jeu_impact.temps_restant -= lpblocinfo->diff;
  // SI son temps de vie s'acheve, on le fait mourir.
  if (bloc_jeu_impact.temps_restant < 0.0)
    {
      suicide = true;
    };
  if (lpblocinfo->client)
    {
      if (lpanimation)
	{
	  // Déterminer la nouvelle position.
	  switch (bloc_jeu_impact.type_jeu_impact)
	    {
	    case IMPACT_MUR_BALLE:
	    case IMPACT_MUR_PLASMA:
	      {
		MATRIX t;
		if (lpobjetreference)
		  {
		    context_objet.contexte.position =
		      lpobjetreference->
		      repere_global.transforme (point_impact);
		    t = (lpobjetreference->repere_global) * normale_impact;
		    context_objet.contexte.position =
		      lpobjetreference->
		      repere_global.transforme (point_impact);
		  }
		// Calculer la nouvelle animation.
		lpanimation->init_animation ();
		BLOCINFO blocinfo2 = *lpblocinfo;

		MOT anim0 ("0");
		blocinfo2.T = bloc_jeu_impact.temps_restant;
		lpanimation->applique_animation (&anim0, &blocinfo2);

		lpanimation->fin_animation (&blocinfo2, &t);

		// Appeler aussi le callback sur les objets pour leur faire un zoli impact.
		MATRIX m;
		unsigned int desc_text = 0;
		BLOCINFO bi = *lpblocinfo;
		bi.T = temps_anim_texture;
		bi.LT = temps_anim_texture;
		bi.diff = 0;
		lpanimation_texture->gestion_locale (&bi, m, desc_text);

		temps_anim_texture += lpblocinfo->diff;
		for (LPLISTE_OBJET::iterator i = liste_objet.begin ();
		     i != liste_objet.end (); i++)
		  {
		    (*i)->set_dynamique (ID, m, desc_text);
		  }
	      };
	      break;
	    case IMPACT_EXPLOSION:
	    case IMPACT_CHAIR_BALLE:
	    case IMPACT_FUMEE:
	      {
		float elapsed_time =
		  tableau_typage_jeu_impact[bloc_jeu_impact.type_jeu_impact].
		  temps_animation - bloc_jeu_impact.temps_restant;
		context_objet.contexte.position =
		  bloc_jeu_impact.a + bloc_jeu_impact.b * elapsed_time;
		// Calculer la nouvelle animation.
		lpanimation->init_animation ();
		BLOCINFO blocinfo2 = *lpblocinfo;
		MOT anim0 ("0");
		blocinfo2.T = bloc_jeu_impact.temps_restant;
		lpanimation->applique_animation (&anim0, &blocinfo2);
		MATRIX t;
		t.translation (context_objet.contexte.position);
		lpanimation->fin_animation (&blocinfo2, &t);

	      };
	      break;
	    }
	}
    }
};

void
JEU_IMPACT::init_standard (LPBLOCINFO lpblocinfo)
{
  lpanimation = NULL;
  preinit = true;
  LPFACETTE lpf = NULL;
  lpobjetreference = NULL;
// Retrouver l'objet touché si on est sur le client...
  if (lpblocinfo->client)
    {
      MOT nom =
	MOT (tableau_typage_jeu_impact[bloc_jeu_impact.type_jeu_impact].
	     nom_animation);
      lpblocinfo->lpbanque_animation->trouve_element ((void *) &nom,
						      lpblocinfo,
						      &lpanimation);
      switch (bloc_jeu_impact.type_jeu_impact)
	{
	case IMPACT_MUR_BALLE:
	case IMPACT_MUR_PLASMA:
	  {
	    nom =
	      MOT (tableau_typage_jeu_impact[bloc_jeu_impact.type_jeu_impact].
		   nom_animation_texture);
	    lpanimation_texture =
	      lpblocinfo->lpbanque_animation_texture->
	      trouve_animation_texture_brutal (lpblocinfo, nom);
	    float rayon =
	      tableau_typage_jeu_impact[bloc_jeu_impact.type_jeu_impact].
	      rayon;
	    lpblocinfo->lpniveau->impact (bloc_jeu_impact.a,
					  bloc_jeu_impact.b, &lpf,
					  &lpobjetreference);
	    lpblocinfo->lpniveau->impact_sphere (bloc_jeu_impact.b, rayon,
						 0.01, ID, liste_objet, 5);
	    // Calcul du point d'impact.
	    if (lpobjetreference)
	      {
		lpobjetreference->calcul_matrices_inverse ();
		context_objet.contexte.position = bloc_jeu_impact.b;
		point_impact = lpobjetreference->
		  repere_global_inverse.transforme (bloc_jeu_impact.b);
		if (lpf)
		  normale_impact = lpf->get_transfo_zu ();
		else
		  printf ("Pas de facette pour l'impact\n");
		MATRIX t2;
		RWVECTOR z (0, 0, 1);
		z = normale_impact.transforme (z);
		RWVECTOR normale = lpf->get_u ();
		t2.translation (point_impact);
		normale_impact = t2 * normale_impact;
	      }
	    else
	      printf ("CLIENT : Pas d'objet pour l'impact...\n");
	  };
	  break;
	case IMPACT_EXPLOSION:
	  {
	    // creation de quelques debris, si c'est une explosion...
	    for (int i = 0; i != 10; i++)
	      {
		MOT debris ("d_commun/d_debris/explosion1.3da");
		//MOT debris("d_commun/d_armes/d_grenade/grenade.3da");
		lpblocinfo->lpjeu->creation_debris (debris,
						    bloc_jeu_impact.a,
						    RWVECTOR (float (rand ())
							      * (10.0) /
							      float (RAND_MAX)
							      - 5.0,
							      float (rand ())
							      * (10.0) /
							      float (RAND_MAX)
							      - 5.0,
							      float (rand ())
							      * (2.0) /
							      float (RAND_MAX)
							      + 5.0), 0.01,
						    float (rand ()) * (50.0) /
						    float (RAND_MAX) + 100, 2,
						    lpblocinfo);
	      }
	  };
	}
    }
  switch (bloc_jeu_impact.type_jeu_impact)
    {
    case IMPACT_EXPLOSION:
    case IMPACT_CHAIR_BALLE:
    case IMPACT_FUMEE:
      {
      };
      break;
    };
  temps_anim_texture = 0;
  gestion_globale (lpblocinfo);
};


void
JEU_IMPACT::init_serveur (TYPE_JEU_IMPACT type_jeu_impact, float puissance,
			  RWVECTOR & a, RWVECTOR & b, LPBLOCINFO lpblocinfo)
{
  bloc_jeu_impact.type_jeu_impact = type_jeu_impact;
  bloc_jeu_impact.temps_restant =
    tableau_typage_jeu_impact[bloc_jeu_impact.type_jeu_impact].
    temps_animation;
  bloc_jeu_impact.a = a;
  bloc_jeu_impact.b = b;
  bloc_jeu_impact.puissance = puissance;
  init_standard (lpblocinfo);
};
