/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// $Id: jeu_joueur.cpp,v 1.4 2006/12/28 10:50:43 atila Exp $

#include "jeu_joueur.h"
#include "jeu_option.h"
#include "snd_mixer.h"

void
JEU_JOUEUR::ajoute_option (int typeoption, int qte)
{
  if ((typeoption >= 0) && (typeoption < MAX_OPTION))
    {
      donnee_serveur.donnee_option[typeoption] += qte;
      return;
    }
  printf ("Invalide option value %i !!!\n", typeoption);
};

void
JEU_JOUEUR::ajoute_munition (int num, int qte)
{
  if (num >= NB_ARME)
    return;
  donnee_serveur.arme[num].munition += qte;
  donnee_serveur.trouve_ammo = true;
}

void
JEU_JOUEUR::ajoute_arme (int num)
{
  if (num >= NB_ARME)
    return;
  donnee_serveur.arme[num].possede = true;
  donnee_serveur.trouve_arme = true;
}

void
JEU_JOUEUR::ajoute_vie (int qte)
{
  bloc_vivant.vie += qte;
  donnee_serveur.trouve_vie = true;
}

void
JEU_JOUEUR::ajoute_armure (int qte)
{
  donnee_serveur.armure += qte;
  donnee_serveur.trouve_armure = true;
}

JEU_JOUEUR::JEU_JOUEUR (LPBLOCINFO lpblocinfo):JEU_VIVANT (lpblocinfo)
{
  // Positionner quelques variables.
  context_objet.rayon = 0.8;
  context_objet.masse = 100;
  context_objet.type = joueur;
  context_objet.v_avance_max = 15.0;
  context_objet.v_avance = RWVECTOR (0, 0, 0);
  context_objet.v_saute = RWVECTOR (0, 0, 0);
  context_objet.v_avance_involontaire = RWVECTOR (0, 0, 0);
  context_objet.amortissement_xy = 1.0;
  context_objet.k_adherence = 0.9;
  context_objet.hauteur_marche = 0.6;
  //context_objet.hauteur_marche=0;

  int
    err;
  lpanimation = NULL;
  MOT
  nom ("d_commun/d_warrior/warrior.3da");
  err =
    lpblocinfo->lpbanque_animation->trouve_element ((void *) &nom, lpblocinfo,
						    &lpanimation);

  for (int i = 0; i != NB_ARME; i++)
    {
      nom = MOT (constante_anim[i + Arme1].nom_anim);
      lpanim_armes[i] = NULL;
      int
	err = lpblocinfo->lpbanque_animation->trouve_element ((void *) &nom,
							      lpblocinfo,
							      &lpanim_armes
							      [i]);
    }

  controle_joueur.avance = false;
  controle_joueur.recule = false;
  controle_joueur.saute = false;
  controle_joueur.tir = false;
  controle_joueur.strafe_gauche = false;
  controle_joueur.strafe_droite = false;
  controle_joueur.action = false;

  controle_joueur.T_anim_jambe = 0;
  controle_joueur.T_anim_corps = 0;
  controle_joueur.arme_selectionnee = 0;
  controle_joueur.texte = MOT ("-I WAS BORN TO FRAG LOOSERS-");
  controle_joueur.dernier_texte = 0;
  controle_joueur.skin = MOT ("d_skin/standard.pcx");
  ratio_statique_avance = 0;
  ratio_sol_air = 0;
  donnee_client.T_anim_jambe = 0;
  donnee_client.T_anim_corps = 0;
  donnee_client.arme_selectionnee = 0;

  bloc_vivant.vie = 100;
  donnee_serveur.armure = 0;
  donnee_serveur.decompte_tir = 0;
  donnee_serveur.arme_selectionnee = 0;
  donnee_serveur.trouve_vie = false;
  donnee_serveur.trouve_super_vie = false;
  donnee_serveur.trouve_ammo = false;
  donnee_serveur.trouve_armure = false;
  donnee_serveur.trouve_arme = false;
  donnee_serveur.douleur_simple = false;
  donnee_serveur.douleur_dure = false;
  for (int i = 0; i < NB_ARME; i++)
    {
      // ON prselectionne les 2 premieres armes.
      donnee_serveur.arme[i].possede = (i <= 1);
      donnee_serveur.arme[i].munition = 0;
    }
  donnee_serveur.arme[0].munition = 10;

  for (int i = 0; i < NB_ARME; i++)
    {
      // ON prselectionne les 2 premieres armes.
      donnee_serveur.arme[i].possede = true;
      donnee_serveur.arme[i].munition = 1000;
    }

  // Les 2 suivantes doivent tre  la mme valeur
  donnee_serveur.temps_dernier_tir = 0;
  donnee_serveur.points = 0;
  donnee_serveur.frags = 0;
  donnee_serveur.temps_click = 0.0;
  donnee_serveur.gagne = false;

  temps_dernier_tir_serveur = 0;
  // Une valeur fortement ngative pour tre sr que l'arme sera au repos.
  temps_dernier_tir_client = -100;

  temps_click = 0.0;
  temps_client_click = 10.0;

  effet_vie = 0;
  effet_mort = 0;
  effet_degat = 0;
  effet_option = 0;

  last_vie = bloc_vivant.vie;

  son_douleur = -1;
  son_mort = -1;

  for (int i = 0; i != MAX_OPTION; i++)
    donnee_serveur.donnee_option[i] = 0.0;

  donnee_serveur.ID_ennemi_selectionne = 0;
  controle_joueur.touche_active = 0;

  compteur_fin=TEMPS_FIN_JEU;

};

JEU_JOUEUR::~JEU_JOUEUR ()
{
  for (int i = 0; i != NB_ARME; i++)
    {
      if (lpanim_armes[i])
	delete lpanim_armes[i];
    }
};

void
JEU_JOUEUR::affichage (LPBLOCINFO lpblocinfo)
{
  if (lpanimation)
    {
      // effet de flottement quand on vole.
      float temps_vole = donnee_serveur.donnee_option[OPTION_PIGEON] * 1.5;
      decal_effet =
	RWVECTOR (0, 0, 0.2 * cos (temps_vole) * cos (temps_vole) - 0.2);

      LPANIMATION lparme = NULL;
      int arme = donnee_serveur.arme_selectionnee;
      if ((arme >= 0) && (arme < NB_ARME))
	lparme = lpanim_armes[arme];
      //else printf("ARME INVALIDE ! %i \n",arme);
      MOT anim_final ("feu");
      BLOCINFO blocinfo2 = *lpblocinfo;
      blocinfo2.T = temps_dernier_tir_client;

      lpanimation->init_animation ();

      if ((bloc_vivant.vie == 0) && (son_mort == -1))
	{
	  MOT mort ("d_commun/d_warrior/mort.ogg");
	  son_mort = lpblocinfo->lpmixer->lance_son (mort, -1);
	};
      if (lparme)
	{
	  lparme->init_animation ();
	  lparme->applique_animation (&anim_final, &blocinfo2);
	}

      MATRIX matrix_arme;
      if (((donnee_serveur.ID_connexion ==
	    lpblocinfo->lpreseau->ID_connexion_client)
	   || (donnee_serveur.ID_connexion == -1))
	  && (lpblocinfo->blocoption.typeVue == TypeVueInterne))
	{
	  // Gnrer un affichage de l'arme en cours comme dans les autres cas, mais
	  // centr sur l'cran.
	  MATRIX m = lpblocinfo->lpmoteur->positionnement_relatif_inverse;
	  MATRIX m2, m3, m4, m5;
	  // x pour dire gauche. y pour abaisser, z pour mettre  distance.
	  m2.translation (RWVECTOR (0.2, -0.4, -0.5 + decal.z () / 3));
	  m3.translation (lpblocinfo->lpmoteur->position_camera * (-1));
	  m4.rotationx (-3.14 / 2);
	  m5.rotationz (3.14 / 2);
	  matrix_arme = m3 * m * m2 * m4 * m5;

	  // mise a jour des effets.
	  effet_vie -= lpblocinfo->diff;
	  effet_degat -= lpblocinfo->diff;
	  effet_option -= lpblocinfo->diff;
	  if (bloc_vivant.vie == 0)
	    {
	      donnee_serveur.arme_selectionnee = 0;
	      donnee_client.arme_selectionnee = 0;
	      effet_mort += lpblocinfo->diff;
	      if (effet_mort > 0.5)
		effet_mort = 0.5;
	    }
	  if (effet_vie < 0)
	    effet_vie = 0;
	  if (effet_option < 0)
	    effet_option = 0;
	  if (effet_degat < 0)
	    effet_degat = 0;

	  if (donnee_serveur.trouve_vie)
	    effet_vie += 0.5;
	  if (donnee_serveur.trouve_super_vie)
	    effet_vie += 1.0;

	  if (donnee_serveur.trouve_arme)
	    effet_option += 1.0;
	  if (donnee_serveur.trouve_ammo)
	    effet_option += 0.5;

	  if (last_vie > bloc_vivant.vie)
	    effet_degat += (last_vie - bloc_vivant.vie) / 20 + 0.5;
	  if (effet_degat > 0.5)
	    effet_degat = 0.5;
	  last_vie = bloc_vivant.vie;
	}
      else
	{
	  BLOCINFO blocinfo2 = *lpblocinfo;

	  MOT anim_final ("FINAL");
	  blocinfo2.T = 0.1;
	  lpanimation->applique_animation (&anim_final, &blocinfo2);

	  float temps3 = 0.1;
	  MOT anim_tir ("TIR");
	  blocinfo2.T = temps3;
	  lpanimation->applique_animation (&anim_tir, &blocinfo2);

	  lpanimation->pre_mix ();

	  MOT anim_avance ("AVANCE");
	  blocinfo2.T = donnee_client.T_anim_jambe;
	  lpanimation->applique_animation (&anim_avance, &blocinfo2);


	  MOT mot_vide ("");
	  lpanimation->mix (mot_vide, ratio_statique_avance);

	  lpanimation->pre_mix ();
	  MOT anim_saute ("SAUTE");
	  blocinfo2.T = 0.2;
	  lpanimation->applique_animation (&anim_saute, &blocinfo2);

	  lpanimation->mix (mot_vide, ratio_sol_air);

	  float temps2 = -(controle_joueur.angle_arme);
	  if (donnee_serveur.ID_connexion !=
	      lpblocinfo->lpreseau->ID_connexion_client)
	    {
	      temps2 = -donnee_client.angle_arme;
	    }
	  MOT anim_regarde ("REGARDE");
	  blocinfo2.T = temps2;
	  lpanimation->applique_animation (&anim_regarde, &blocinfo2);

	  MATRIX t, t2, t3;
	  t.translation (context_objet.contexte.position +
			 RWVECTOR (0.0, 0.0, 0.0));
	  t2.rotationz (controle_joueur.angle_corps - 3.14 / 2);

	  t3 = t * t2;
	  lpanimation->fin_animation (lpblocinfo, &t3);
	  DESCRIPTEUR_TEXTURE desc;
	  desc.nom = controle_joueur.skin;
	  desc.blend_type = 0;
	  lpanimation->
	    set_texture_animation (lpblocinfo->
				   lpbanque_texture->
				   trouve_texture (&desc, lpblocinfo->lpbdd));
	  MOT bras ("poignet");
	  matrix_arme = *lpanimation->get_ref_objet (bras);
	  lpanimation->trace_animation (lpblocinfo);
	}

      // Par defaut, on enleve toutes les armes....
      for (int i = 0; i != NB_ARME; i++)
	{
	  if (lpanim_armes[i])
	    lpanim_armes[i]->pas_affichage ();
	};

      if (lparme)
	{
	  MOT anim_click ("CLICK");
	  blocinfo2.T = temps_client_click;
	  lparme->applique_animation (&anim_click, &blocinfo2);
	  lparme->fin_animation (lpblocinfo, &matrix_arme);
	  lparme->trace_animation (lpblocinfo);
	}

    }
}

void
JEU_JOUEUR::gestion_globale (LPBLOCINFO lpblocinfo)
{
  if ((donnee_serveur.gagne) || (effet_mort == 0.5))
    {
    compteur_fin-=lpblocinfo->diff;
    if (compteur_fin<0)
      compteur_fin=0;
    }

  if (donnee_serveur.gagne)
    return;
  // Grer en fonction des commandes recues...

  JEU_VIVANT::gestion_globale (lpblocinfo);

  if (lpblocinfo->serveur)
    {
      // Faire vieillir les options.
      for (int i = 0; i != MAX_OPTION; i++)
	{
	  donnee_serveur.donnee_option[i] -= lpblocinfo->diff;
	  if (donnee_serveur.donnee_option[i] < 0)
	    donnee_serveur.donnee_option[i] = 0;
	};

      // calculer le coeff degat.
      if (donnee_serveur.donnee_option[OPTION_INVULNERABILITE])
	{
	  bloc_vivant.coeff_degat = 0;
	}
      else
	{
	  float armure = donnee_serveur.armure;
	  if (armure > 50.0)
	    armure = 50.0;
	  bloc_vivant.coeff_degat = 1.0 - armure / 100.0;
	};
      // Appliquer les degats sur l'armure.
      donnee_serveur.armure -= bloc_vivant.degat * 2;
      if (donnee_serveur.armure < 0.0)
	donnee_serveur.armure = 0;
      bloc_vivant.degat = 0;

      // Calculer le coeff de gravite
      if (donnee_serveur.donnee_option[OPTION_PIGEON] != 0.0)
	{
	  context_objet.contexte.contact_mur_acroche = true;
	  context_objet.contexte.contact_mur_suit = true;
	  context_objet.contexte.contact = true;
	  context_objet.coeff_gravite = 0.01;
	}
      else
	{
	  context_objet.coeff_gravite = 1.0;
	};

      // Recuperer les controles pour chaque joueur. Regarder dans la pile...

      unsigned int taille;
      void *buffer = NULL;
      if (donnee_serveur.ID_connexion != -1)
	{
	  //printf("retrouve ID %i\n",donnee_serveur.ID_connexion);
	  lpblocinfo->lpreseau->get_UDP (CANAL_COMMANDE, &taille,
					 &buffer,
					 donnee_serveur.ID_connexion);
	};
      if (buffer)
	{
	  controle_joueur = *(CONTROLE_JOUEUR *) buffer;
	  free (buffer);
	}
      double dernier_texte = controle_joueur.dernier_texte;
      donnee_client.arme_selectionnee = controle_joueur.arme_nouvelle;
      donnee_client.angle_corps = controle_joueur.angle_corps;
      donnee_client.angle_arme = controle_joueur.angle_arme;
      donnee_client.angle_jambes = controle_joueur.angle_jambes;
      donnee_serveur.skin = controle_joueur.skin;
      donnee_serveur.nom = controle_joueur.nom;
      context_objet.action = controle_joueur.action;

      if (controle_joueur.dernier_texte != dernier_texte)
	{
	  MOT m = controle_joueur.nom;
	  MOT esp (" : ");
	  m = m + esp;
	  m = m + controle_joueur.texte;
	  lpblocinfo->lpaffiche_texte->print (m, lpblocinfo);
	}

      if (bloc_vivant.vie <= 0)
	{
	  donnee_serveur.arme_selectionnee = 0;
	}
      if (bloc_vivant.vie > 0)
	{
	  if (lpblocinfo->mode_jeu == MODE_JEU_ARCADE)
	    {
	      // Pour ne pas slectionner d'arme qu'on n'a pas.
	      if (donnee_serveur.arme[donnee_client.arme_selectionnee].possede)
		{
		  donnee_serveur.arme_selectionnee =
		    donnee_client.arme_selectionnee;
		}
	      else
		{
		  donnee_client.arme_selectionnee =
		    donnee_serveur.arme_selectionnee;
		};
	      context_objet.action = false;
	      context_objet.action = controle_joueur.action;
	      if ((controle_joueur.tir) && (donnee_serveur.decompte_tir <= 0))
		{
		  // coeff de tir.
		  float coeff_tir = 1.0;
		  if (donnee_serveur.donnee_option[OPTION_SUPERPUISSANCE] != 0.0)
		    coeff_tir = 2.0;
		  bool tir = false;
		  bool click = false;
		  float canon = 0.5;
		  RWVECTOR decal (0, -0.2, 0.5);
		  RWVECTOR decal_position (0, 0, 0.7);
		  switch (donnee_client.arme_selectionnee)
		    {
		    case TYPE_ARME_GATLING:
		      if (donnee_serveur.arme[0].munition > 0)
			{
			  tir_balle (lpblocinfo, TYPE_ARME_GATLING, 50.0, 0.05,
				     controle_joueur.angle_corps,
				     controle_joueur.angle_arme, decal,
				     decal_position, canon, coeff_tir);
			  donnee_serveur.decompte_tir = 0.2;
			  donnee_serveur.arme[0].munition--;
			  tir = true;
			}
		      else
		    click = true;
		      break;
		    case TYPE_ARME_TROMBLON:
		      for (int i = 0; i < 10; i++)
			if (donnee_serveur.arme[0].munition > 0)
			  {
			    tir_balle (lpblocinfo, TYPE_ARME_GATLING, 50.0, 0.1,
				       controle_joueur.angle_corps,
				       controle_joueur.angle_arme, decal,
				       decal_position, canon, coeff_tir);
			    donnee_serveur.decompte_tir = 1.0;
			    donnee_serveur.arme[0].munition--;
			    tir = true;
		      }
			else
			  click = true;
		      break;
		    case TYPE_ARME_MEGAGATLING:
		      if (donnee_serveur.arme[0].munition > 0)
			{
			  tir_balle (lpblocinfo, TYPE_ARME_GATLING, 50.0, 0.1,
				     controle_joueur.angle_corps,
				     controle_joueur.angle_arme, decal,
				     decal_position, canon, coeff_tir);
			  donnee_serveur.decompte_tir = 0.1;
			  donnee_serveur.arme[0].munition--;
			  tir = true;
			}
		      else
			click = true;
		      break;
		    case TYPE_ARME_LANCEMINE:
		      if (donnee_serveur.arme[1].munition > 0)
			{
			  tir_balle (lpblocinfo, TYPE_ARME_LANCEMINE, 50.0, 0,
				     controle_joueur.angle_corps,
				     controle_joueur.angle_arme, decal,
				     decal_position, canon, coeff_tir);
			  donnee_serveur.decompte_tir = 1.5;
			  donnee_serveur.arme[1].munition--;
			  tir = true;
			}
		      else
			click = true;
		      break;
		    case TYPE_ARME_LANCEROQUETTE:
		      if (donnee_serveur.arme[2].munition > 0)
			{
			  tir_balle (lpblocinfo, TYPE_ARME_LANCEROQUETTE, 50.0, 0,
				     controle_joueur.angle_corps,
				     controle_joueur.angle_arme, decal,
				     decal_position, canon, coeff_tir);
			  donnee_serveur.decompte_tir = 2;
			  donnee_serveur.arme[2].munition--;
			  tir = true;
		    }
		      else
			click = true;
		      break;
		    case TYPE_ARME_FUSILPLASMA:
		      if (donnee_serveur.arme[3].munition > 0)
			{
			  tir_balle (lpblocinfo, TYPE_ARME_FUSILPLASMA, 150.0,
				 0.01, controle_joueur.angle_corps,
				     controle_joueur.angle_arme, decal,
				     decal_position, canon, coeff_tir);
			  donnee_serveur.decompte_tir = 0.2;
			  donnee_serveur.arme[3].munition--;
			  tir = true;
			}
		      else
			click = true;
		      break;
		    }
		  if (tir)
		    donnee_serveur.temps_dernier_tir = lpblocinfo->T;
		  if (click)
		    donnee_serveur.temps_click = lpblocinfo->T;
		}
	    }
	  else
	    {
	      // Determiner la cible la plus proche
	      int ennemi_ID=lpblocinfo->lpjeu->cible_la_plus_proche(lpblocinfo, 
								    context_objet.contexte.position,
								    15.0,
								    controle_joueur.angle_corps,
								    controle_joueur.angle_arme,
								    ID);
	      donnee_serveur.ID_ennemi_selectionne = ennemi_ID;

	      // Si une lettre a t appuye, on la traite...
	      int lettre=controle_joueur.touche_active;
	      if (lettre != 0)
		{
		if (ennemi_ID != 0)
		    {
		      LPELEMENTJEU cible=lpblocinfo->lpjeu->get_element(ennemi_ID);
		      bool touche=cible->envoie_lettre(lettre);
		    }
		}
	    }
	  if (donnee_serveur.donnee_option[OPTION_RAPIDITE] != 0)
	    donnee_serveur.decompte_tir -= lpblocinfo->diff * 2.0;
	  else
	    donnee_serveur.decompte_tir -= lpblocinfo->diff;

	  // Crer les mouvements des joueurs.

	  RWVECTOR x (FORCE_DEPLACEMENT_AVANT, 0, 0);
	  RWVECTOR y (0, FORCE_DEPLACEMENT_STRAFE, 0);
	  RWVECTOR z;

	  MATRIX tr, tr2;
	  tr.rotationz (controle_joueur.angle_corps);
	  if (donnee_serveur.donnee_option[OPTION_PIGEON] != 0.0)
	    tr2.rotationy (controle_joueur.angle_arme);
	  tr = tr * tr2;
	  x = tr.transforme (x);
	  y = tr.transforme (y);

	  RWVECTOR v_volonte = RWVECTOR (0, 0, 0);

	  if (controle_joueur.avance)
	    {
	      v_volonte = x;
	    };
	  if (controle_joueur.recule)
	    {
	      v_volonte = x * (-1);
	    };
	  if (controle_joueur.strafe_gauche)
	    {
	      v_volonte = v_volonte - y;
	    };

	  if (controle_joueur.strafe_droite)
	    {
	      v_volonte = v_volonte + y;
	    };
	  v_volonte = v_volonte.normalise () * 5.0;
	  if (donnee_serveur.donnee_option[OPTION_RAPIDITE] != 0.0)
	    {
	      v_volonte = v_volonte * 2.0;
	    }

	  context_objet.v_avance = v_volonte;
	  context_objet.v_saute = RWVECTOR (0, 0, 0);
	  if ((controle_joueur.saute)
	      && (donnee_serveur.donnee_option[OPTION_PIGEON] == 0.0))
	    {
	      context_objet.v_saute = RWVECTOR (0, 0, 5);
	    };
	  if (context_objet.contexte.contact)
	    {
	      if (v_volonte.norme () > 0.1)
		donnee_serveur.etat_jambe = JAMBE_AVANCE;
	      else
		donnee_serveur.etat_jambe = JAMBE_STATIQUE;
	    }
	  else
	    {
	      donnee_serveur.etat_jambe = JAMBE_SAUTE;
	    }
	}
    }
  if (lpblocinfo->client)
    {

      // Si c'est le joueur courant, il faut envoyer les commandes au serveur,
      // en fonction de ce qui est dans les controles.

      if (((donnee_serveur.ID_connexion ==
	    lpblocinfo->lpreseau->ID_connexion_client)
	   || (lpblocinfo->serveur)) && (bloc_vivant.vie != 0))
	{

	  LPCONTROLE lpc = lpblocinfo->lpcontrole;
	  controle_joueur.angle_corps = lpc->get_z_view ();
	  controle_joueur.angle_arme = lpc->get_x_view ();
	  controle_joueur.avance = lpc->avance ();
	  controle_joueur.recule = lpc->recule ();
	  controle_joueur.strafe_gauche = lpc->strafe_gauche ();
	  controle_joueur.strafe_droite = lpc->strafe_droite ();

	  if (lpblocinfo->mode_jeu == MODE_JEU_ARCADE)
	    {
	      controle_joueur.tir = lpc->tir ();
	      controle_joueur.saute = lpc->saute ();
	      controle_joueur.action = lpc->action ();
	      
	      // slection de l'arme.
	      // Rque : on peut modifier le client pour s'octroyer nue arme qu'on n'a pas, 
	      // mais le serveur contrle aussi.
	      for (int i = 0; i < NB_ARME; i++)
		if (lpc->arme (i) && (donnee_serveur.arme[i].possede))
		  {
		    controle_joueur.arme_nouvelle = i;
		  }
	      // Contrib d'Alan LeCorre : utiliser la molette pour arme+/arme-
	      if (lpc->arme_moins ())
		{
		  // trouver une arme moins...
		  controle_joueur.arme_nouvelle = donnee_client.arme_selectionnee;
		  for (int i = donnee_client.arme_selectionnee + 1; i < NB_ARME;
		       i++)
		    {
		      if (donnee_serveur.arme[i].possede)
			controle_joueur.arme_nouvelle = i;
		    };
		  for (int i = 0; i < donnee_client.arme_selectionnee; i++)
		    {
		      if (donnee_serveur.arme[i].possede)
			controle_joueur.arme_nouvelle = i;
		    };
		}
	      if (lpc->arme_plus ())
		{
		  // trouver une arme plsu...
		  controle_joueur.arme_nouvelle = donnee_client.arme_selectionnee;
		  for (int i = donnee_client.arme_selectionnee - 1; i >= 0; i--)
		    {
		      if (donnee_serveur.arme[i].possede)
			controle_joueur.arme_nouvelle = i;
		    };
		  for (int i = NB_ARME - 1; i > donnee_client.arme_selectionnee;
		       i--)
		    {
		      if (donnee_serveur.arme[i].possede)
			controle_joueur.arme_nouvelle = i;
		    };
		}
	    }
	  else
	    {
	      // Mode lecture.
	      controle_joueur.touche_active = lpblocinfo->lpcontrole->lettre_appuyee();
	      if (controle_joueur.touche_active == 0)
		{
		  controle_joueur.touche_active= lpblocinfo->lpcontrole->chiffre_appuyee();
		}
	    }
	  if (!lpblocinfo->serveur)
	    lpblocinfo->lpreseau->put_UDP (CANAL_COMMANDE,
					   sizeof (CONTROLE_JOUEUR),
					   (void *) &controle_joueur);
	  if (donnee_serveur.trouve_vie)
	    {
	      MOT vie ("d_commun/d_warrior/health.wav");
	      lpblocinfo->lpmixer->lance_son (vie, -1);
	    };
	  if (donnee_serveur.trouve_arme)
	    {
	      MOT vie ("d_commun/d_warrior/weapon.wav");
	      lpblocinfo->lpmixer->lance_son (vie, -1);
	    };

	  if (donnee_serveur.trouve_ammo)
	    {
	      MOT ammo ("d_commun/d_warrior/ammo.wav");
	      lpblocinfo->lpmixer->lance_son (ammo, -1);
	    };
	  if (donnee_serveur.trouve_armure)
	    {
	      MOT armure ("d_commun/d_warrior/armor.wav");
	      lpblocinfo->lpmixer->lance_son (armure, -1);
	    };
	};

      donnee_client.T_anim_jambe += lpblocinfo->diff;
      if (donnee_client.T_anim_jambe > 0.5)
	donnee_client.T_anim_jambe -= 1.0;
      // Calcul du nouveau ratio...
      if ((donnee_serveur.etat_jambe == JAMBE_STATIQUE) ||
	  (donnee_serveur.etat_jambe == JAMBE_SAUTE))
	ratio_statique_avance -= lpblocinfo->diff * 4;
      if (donnee_serveur.etat_jambe == JAMBE_AVANCE)
	ratio_statique_avance += lpblocinfo->diff * 4;

      if (donnee_serveur.etat_jambe == JAMBE_SAUTE)
	ratio_sol_air += lpblocinfo->diff * 4;
      else
	ratio_sol_air -= lpblocinfo->diff * 4;

      if (ratio_statique_avance > 1)
	ratio_statique_avance = 1;
      if (ratio_statique_avance < 0)
	ratio_statique_avance = 0;

      if (ratio_sol_air > 1)
	ratio_sol_air = 1;
      if (ratio_sol_air < 0)
	ratio_sol_air = 0;

      // Pour le dcalage du perso/de l'arme, il faut tout ramener  une position correcte.
      float diff = lpblocinfo->diff * 3;
      float decalx = 0, decaly = 0, decalz = 0;

      if (decal.x () > diff)
	decalx = decal.x () - diff;
      if (decal.x () < -diff)
	decalx = decal.x () + diff;

      if (decal.y () > diff)
	decaly = decal.y () - diff;
      if (decal.y () < -diff)
	decaly = decal.y () + diff;

      if (decal.z () > diff)
	decalz = decal.z () - diff;
      if (decal.z () < -diff)
	decalz = decal.z () + diff;

      decal = RWVECTOR (decalx, decaly, decalz);

      float diff_rot = lpblocinfo->diff * 3;
      float decalrotx = 0, decalroty = 0, decalrotz = 0;

      if (decal_rot.x () > diff_rot)
	decalrotx = decal_rot.x () - diff_rot;
      if (decal_rot.x () < -diff_rot)
	decalrotx = decal_rot.x () + diff_rot;

      if (decal_rot.y () > diff_rot)
	decalroty = decal_rot.y () - diff_rot;
      if (decal_rot.y () < -diff_rot)
	decalroty = decal_rot.y () + diff_rot;

      if (decal_rot.z () > diff_rot)
	decalrotz = decal_rot.z () - diff_rot;
      if (decal_rot.z () < -diff_rot)
	decalrotz = decal_rot.z () + diff_rot;

      decal_rot = RWVECTOR (decalrotx, decalroty, decalrotz);

      temps_dernier_tir_client -= lpblocinfo->diff;
      if (donnee_serveur.temps_dernier_tir != temps_dernier_tir_serveur)
	{
	  temps_dernier_tir_client = 0;
	  temps_dernier_tir_serveur = donnee_serveur.temps_dernier_tir;

	  // Grer le dcalage de l'arme et/ou du joueur, en fonction de l'arme.
	  switch (donnee_serveur.arme_selectionnee)
	    {
	    case TYPE_ARME_TROMBLON:
	    case TYPE_ARME_LANCEMINE:
	    case TYPE_ARME_LANCEROQUETTE:
	      decal_rot = RWVECTOR (0, 0.1, 0);
	      decal = RWVECTOR (0, 0, 0.4);
	      break;
	    case TYPE_ARME_FUSILPLASMA:
	    case TYPE_ARME_GATLING:
	      decal_rot = RWVECTOR (0, 0, 0.02);
	      decal = RWVECTOR (0, 0, 0.2);
	      break;
	    case TYPE_ARME_MEGAGATLING:
	      decal_rot = RWVECTOR (0, 0, 0.01);
	      decal = RWVECTOR (0, 0, 0.2);
	      break;

	    };

	}
      // Gestion du clickclickclick...
      temps_client_click += lpblocinfo->diff;
      if (donnee_serveur.temps_click != temps_click)
	{
	  temps_client_click = 0;
	  temps_click = donnee_serveur.temps_click;
	};
    }
  donnee_serveur.trouve_vie = false;
  donnee_serveur.trouve_super_vie = false;
  donnee_serveur.trouve_ammo = false;
  donnee_serveur.trouve_armure = false;
  donnee_serveur.trouve_arme = false;
  donnee_serveur.douleur_simple = false;
  donnee_serveur.douleur_dure = false;

};


int
JEU_JOUEUR::get_ID_connexion ()
{
  return donnee_serveur.ID_connexion;
};

void
JEU_JOUEUR::lecture (LPBLOCINFO lpblocinfo, STOCK & stock,
		     int &position_stock)
{
  JEU_VIVANT::lecture (lpblocinfo, stock, position_stock);

  DONNEE_CLIENT dc;

  donnee_serveur = *((DONNEE_SERVEUR *) stock.get_posbuffer (position_stock));
  dc = *((DONNEE_CLIENT *) stock.get_posbuffer (position_stock));
  position_stock += sizeof (DONNEE_SERVEUR) + sizeof (DONNEE_CLIENT);
  // Ecraser uniquement si ce n'est pas le joueur courant...

  context_objet.contexte.V0 = donnee_serveur.V0;

  if (lpblocinfo->lpreseau->ID_connexion_client !=
      donnee_serveur.ID_connexion)
    {
      donnee_client = dc;
    }
};

void
JEU_JOUEUR::ecriture (LPBLOCINFO lpblocinfo, STOCK & stock)
{
  JEU_VIVANT::ecriture (lpblocinfo, stock);
  donnee_serveur.V0 = context_objet.contexte.V0;
  stock.put_buffer ((char *) &donnee_serveur, sizeof (DONNEE_SERVEUR));
  stock.put_buffer ((char *) &donnee_client, sizeof (DONNEE_CLIENT));
};

void
JEU_JOUEUR::set_info (MOT s, MOT n)
{
  controle_joueur.skin = s;
  controle_joueur.nom = n;
};

void
JEU_JOUEUR::texte (MOT m, double t)
{
  controle_joueur.texte = m;
  controle_joueur.dernier_texte = t;
}

int
JEU_JOUEUR::get_vie ()
{
  return bloc_vivant.vie;
}

int
JEU_JOUEUR::get_armure ()
{
  return donnee_serveur.armure;
}

int
JEU_JOUEUR::get_points ()
{
  return donnee_serveur.points;
}

int
JEU_JOUEUR::get_frags ()
{
  return donnee_serveur.frags;
}

void
JEU_JOUEUR::ajoute_points (int points, bool frag)
{
  donnee_serveur.points += points;
  if (frag)
    donnee_serveur.frags += 1;
};

int
JEU_JOUEUR::get_munitions (DONNEE_ARME tab[NB_ARME])
{
  for (int i = 0; i != NB_ARME; i++)
    {
      tab[i] = donnee_serveur.arme[i];
    }
  return donnee_serveur.arme_selectionnee;
};

void
JEU_JOUEUR::get_decal (RWVECTOR & dec, RWVECTOR & rot_dec,
		       RWVECTOR & dec_effet)
{
  dec = decal;
  rot_dec = decal_rot;
  dec_effet = decal_effet;
};


RWVECTOR
JEU_JOUEUR::get_position ()
{
  return context_objet.contexte.position;
}

float
JEU_JOUEUR::get_vuex_joueur ()
{
  return controle_joueur.angle_corps;
}

float
JEU_JOUEUR::get_vuez_joueur ()
{
  return controle_joueur.angle_arme;
}

float
JEU_JOUEUR::get_effet_mort ()
{
  return effet_mort;
}

float
JEU_JOUEUR::get_effet_vie ()
{
  return effet_vie;
}

float
JEU_JOUEUR::get_effet_degat ()
{
  return effet_degat;
}

float
JEU_JOUEUR::get_effet_option ()
{
  return effet_option;
}

bool
JEU_JOUEUR::get_gagne ()
{
  return donnee_serveur.gagne;
}

void
JEU_JOUEUR::set_gagne ()
{
  donnee_serveur.gagne = true;
}

float
JEU_JOUEUR::get_option (float tab_opt[MAX_OPTION])
{
  for (int i = 0; i != MAX_OPTION; i++)
    tab_opt[i] = donnee_serveur.donnee_option[i];
};

int JEU_JOUEUR::get_cible_lettre()
{
  return donnee_serveur.ID_ennemi_selectionne;
};

bool JEU_JOUEUR::get_fini()
{
  return (compteur_fin == 0.0);
};
