/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "jeu_lettre.h"
#include "jeu_nain.h"
#include "math.h"

void
JEU_LETTRE::gestion_globale (LPBLOCINFO lpblocinfo)
{
  LPELEMENTJEU lpnain = lpblocinfo->lpjeu->get_element (id_track_nain);
  if (!lpnain)
    {
      suicide=true;
      return;
    }    
  context_objet.contexte.position= ((JEU_LETTRE*)lpnain)->context_objet.contexte.position+RWVECTOR(0,0,0.8);

  bool cible_joueur_pour_lettre;
  int lettre_courante;
  bool vie;
  ((JEU_NDJ*)lpnain)->get_info_lettre(cible_joueur_pour_lettre, lettre_courante, vie);
  if (!vie)
    {
      suicide=true;
      return;      
    }

  if (refresh)
    {
      lpanimation->init_animation ();
      BLOCINFO blocinfo2 = *lpblocinfo;
      MOT anim0 ("position");
      blocinfo2.T = position_lettre;
      lpanimation->applique_animation (&anim0, &blocinfo2);

      anim0=MOT("demiteinte");
      if (!cible_joueur_pour_lettre)
	{
	  blocinfo2.T = 0.5;
	}
      else
	{
	  blocinfo2.T = 0.0;
	}
      lpanimation->applique_animation (&anim0, &blocinfo2);

      blocinfo2.T = 0.0;
      if (!cible_joueur_pour_lettre)
	{
	  
	  if (index_lettre >= lettre_courante)
	    anim0=MOT("blanc");
	  else
	    anim0=MOT("jaune");
	}
      else
	{
	  if (index_lettre > lettre_courante)
	    anim0=MOT("rouge");
	  else if (index_lettre == lettre_courante)
	    anim0=MOT("blanc");
	  else
	    anim0=MOT("bleu");
	}
      blocinfo2.T = 0;
      lpanimation->applique_animation (&anim0, &blocinfo2);

      MATRIX t, t3, m;
      t.translation (context_objet.contexte.position);
      RWVECTOR a = context_objet.contexte.position;
      RWVECTOR b = lpblocinfo->lpmoteur->position_camera;
      b = b * (-1.0);
      b = (b - a).normalise ();
      m.translation (a);
      MATRIX m3;
      m3.genere_avec_u (b);
      
      t3 = t * m3;
      lpanimation->fin_animation (lpblocinfo, &t3);
    };
}

void
JEU_LETTRE::lecture (LPBLOCINFO lpblocinfo, STOCK & stock, int &position_stock)
{
}

void
JEU_LETTRE::ecriture (LPBLOCINFO lpblocinfo, STOCK & stock)
{
}

JEU_LETTRE::JEU_LETTRE (LPBLOCINFO lpblocinfo, int id_nain, int idx_lettre):
  ELEMENTJEU (), id_track_nain(id_nain), index_lettre(idx_lettre)
{
  // Positionner quelques variables.
  context_objet.rayon = 0.7;
  context_objet.masse = 80;
  // Chargement d'animation.
  lpanimation = NULL;

  char buffer[128];
  JEU_NDJ* lpnain = (JEU_NDJ*)lpblocinfo->lpjeu->get_element (id_track_nain);
  if (!lpnain)
    {
      suicide=true;
      printf("Gros problme \n");
      return;
    }    
  int lettre=lpnain->get_mot().info[index_lettre] - 33;
  sprintf(buffer,"d_commun/d_ecran/lettre_%i.3da", lettre);
  MOT nom (buffer);
  position_lettre=(float) idx_lettre - lpnain->get_mot().taille * 0.5;
  lpblocinfo->lpbanque_animation->trouve_element ((void *) &nom, lpblocinfo,
						  &lpanimation);

  temps = 0;

}

JEU_LETTRE::~JEU_LETTRE ()
{
}

bool
JEU_LETTRE::serverKill ()
{
  return false;
};
