/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "jeu_nain.h"
#include "jeu_joueur.h"
#include "jeu_lettre.h"
#include "math.h"
#include "dico.h"

void
JEU_NDJ::gestion_globale (LPBLOCINFO lpblocinfo)
{
  if (bloc_ndj.activite != NAIN_ACTIVITE_GLANDOUILLE)
    ELEMENTJEU::gestion_globale (lpblocinfo);

  // Ajouter des lettres  afficher si c'est un client et que ce n'est pas encore fait.
  if ((lpblocinfo->client)&&(lettre_init==false)&&(lpblocinfo->mode_jeu!=MODE_JEU_ARCADE))
    {
      lettre_init=true;     
      for (int taille_mot=0; taille_mot != bloc_ndj.mot_choisi.taille+1 ; taille_mot++)
	{
	  JEU_LETTRE *lettre;
	  lettre = new JEU_LETTRE (lpblocinfo, ID, taille_mot);
	  lpblocinfo->lpjeu->InsererElementJeu (lettre);
	}
    }
  // Si c'est serveur attaquer.
  if (lpblocinfo->serveur)
    {
      if ((bloc_vivant.vie <= 0) && (bloc_ndj.activite != NAIN_ACTIVITE_MORT))
	{
	  bloc_ndj.activite = NAIN_ACTIVITE_MORT;
	  interaction_flag = false;
	}
      if ((temps_avance <= 0.0) && (bloc_ndj.activite != NAIN_ACTIVITE_MORT))
	{
	  temps_avance = NAIN_TEMPS_ATTENTE;
	  bloc_ndj.activite = NAIN_ACTIVITE_GLANDOUILLE;

	  // Regarder si on a un joueur  attaquer dans les parages.
	  int ID_joueur =
	    lpblocinfo->lpjeu->get_joueur_proche (get_position ());
	  LPELEMENTJEU lpjoueur = lpblocinfo->lpjeu->get_element (ID_joueur);
	  if ((ID_joueur != -1) && (lpjoueur))
	    {
	      RWVECTOR pos = lpjoueur->get_position ();
	      RWVECTOR dir = pos - get_position ();
	      float distance = dir.norme ();
	      if (distance < NAIN_DISTANCE_ATTAQUE)
		{
		  bloc_ndj.activite = NAIN_ACTIVITE_ATTAQUE;
		  // Trouver l'angle correspondant.
		  float angle = 0;
		  RWVECTOR pos_angle (0, 0, 0);
		  for (int i = 1; i != 50; i++)
		    {
		      float angle_test = float (i) * 6.28 / 50.0;
		      RWVECTOR dir2 (cos (angle_test), sin (angle_test), 0);
		      if ((dir2 - dir).norme () < (pos_angle - dir).norme ())
			{
			  angle = angle_test;
			  pos_angle = dir2;
			}
		    }
		  bloc_ndj.angle = angle;
		  direction = RWVECTOR (cos (angle), sin (angle), 0);
		  temps_avance = NAIN_TEMPS_ATTAQUE;
		  // Attaquer la cible (quand meme !)
		  lpjoueur->interaction_danger (lpblocinfo,ID,NAIN_TAUX_ATTAQUE,COUP_PHYSIQUE,
						get_position (), dir);
		}
	      else if (distance < NAIN_DISTANCE_MINIMALE)
		{
		  dir = RWVECTOR (dir.x (), dir.y (), 0);
		  dir = dir.normalise ();
		  // Trouver l'angle correspondant.
		  float angle = 0;
		  RWVECTOR pos_angle (0, 0, 0);
		  for (int i = 1; i != 50; i++)
		    {
		      float angle_test = float (i) * 6.28 / 50.0;
		      RWVECTOR dir2 (cos (angle_test), sin (angle_test), 0);
		      if ((dir2 - dir).norme () < (pos_angle - dir).norme ())
			{
			  angle = angle_test;
			  pos_angle = dir2;
			}
		    }
		  // Ajouter une varaiation d'angle alatoiree.
		  float aleat =
		    (float (rand ()) / (float (RAND_MAX))*2.0 - 1.0);
		  angle += aleat * 3.14 / 5.0;
		  bloc_ndj.angle = angle;
		  direction = RWVECTOR (cos (angle), sin (angle), 0);
		  bloc_ndj.activite = NAIN_ACTIVITE_AVANCE;
		  temps_avance = NAIN_TEMPS_ACTION;
		};
	    };
	}
      else
	{
	  //printf("Re4 %i %i %f\n",getID(),activite,temps_avance);
	  // Diminuer temps_avance
	  temps_avance -= lpblocinfo->diff;
	  switch (bloc_ndj.activite)
	    {
	    case NAIN_ACTIVITE_GLANDOUILLE:
	      // On ne fait rien (et du coup, on dcharge un peu le serveur)
	      break;
	    case NAIN_ACTIVITE_ATTAQUE:
	      break;
	    case NAIN_ACTIVITE_MORT:
	      bloc_ndj.ratio_mort += lpblocinfo->diff;
	      if (bloc_ndj.ratio_mort >= 5.0)
		suicide = true;
	      break;
	    case NAIN_ACTIVITE_AVANCE:
	      direction = RWVECTOR (direction.x (), direction.y (), 0.0);
	      context_objet.v_avance = (direction) * 1.0;
	      //context_objet.v_saute=(direction+RWVECTOR(0,0,1.0))*5.0;
	      bloc_ndj.temps_animation_avance += lpblocinfo->diff;
	      if (bloc_ndj.temps_animation_avance >= 1.0)
		bloc_ndj.temps_animation_avance -= 1.0;
	      break;
	    }
	};
    };
  if (lpblocinfo->client)
    {
      // Est-on la cible du joueur ?
      JEU_JOUEUR * joueur=lpblocinfo->lpjeu->get_joueur();
      if (joueur)
	{
	  int id_cible=joueur->get_cible_lettre();
	  cible_joueur_pour_lettre=false;
	  if (ID == id_cible)
	    {
	      cible_joueur_pour_lettre=true;
	    };
	}
    }
  if (refresh)
    {
      lpanimation->init_animation ();
      BLOCINFO blocinfo2 = *lpblocinfo;
      MOT anim0 ("0");
      blocinfo2.T = 0;
      lpanimation->applique_animation (&anim0, &blocinfo2);
      switch (bloc_ndj.activite)
	{
	case NAIN_ACTIVITE_MORT:
	  {
	    MOT anim2 ("mort");
	    blocinfo2.T = bloc_ndj.ratio_mort;
	    lpanimation->applique_animation (&anim2, &blocinfo2);
	  }
	  break;
	case NAIN_ACTIVITE_AVANCE:
	  {
	    MOT anim1 ("avance");
	    blocinfo2.T = bloc_ndj.temps_animation_avance;
	    lpanimation->applique_animation (&anim1, &blocinfo2);
	  }
	  break;
	case NAIN_ACTIVITE_ATTAQUE:
	  {
	    MOT anim1 ("attaque");
	    blocinfo2.T = temps_avance;
	    lpanimation->applique_animation (&anim1, &blocinfo2);
	  }
	  break;
	}
      MATRIX t, t2, t3;
      t.translation (context_objet.contexte.position);
      t2.rotationz (bloc_ndj.angle - 3.14 / 2.0);
      t3 = t * t2;
      lpanimation->fin_animation (lpblocinfo, &t3);
    };
}

void
JEU_NDJ::LectureParamJeu (BUFFER_NOEUD * BF, buffer_noeud * bn,
			  LPBLOCINFO lpblocinfo)
{
  JEU_VIVANT::LectureParamJeu (BF, bn, lpblocinfo);
  lettre_init=false;

  // Chargement specifique....
  // genre, type d'arme, etc...
}

void
JEU_NDJ::lecture (LPBLOCINFO lpblocinfo, STOCK & stock, int &position_stock)
{
  JEU_VIVANT::lecture (lpblocinfo, stock, position_stock);
  bloc_ndj = *((BLOC_NDJ_SERVEUR *) stock.get_posbuffer (position_stock));
  position_stock += sizeof (struct BLOC_NDJ_SERVEUR);
}

void
JEU_NDJ::ecriture (LPBLOCINFO lpblocinfo, STOCK & stock)
{
  JEU_VIVANT::ecriture (lpblocinfo, stock);
  stock.put_buffer ((char *) &bloc_ndj, sizeof (struct BLOC_NDJ_SERVEUR));
}

JEU_NDJ::JEU_NDJ (LPBLOCINFO lpblocinfo):JEU_VIVANT (lpblocinfo)
{
  // Positionner quelques variables.
  context_objet.rayon = 0.7;
  context_objet.masse = 80;
  // Chargement d'animation.
  lpanimation = NULL;

  MOT nom ("d_commun/d_ndj/ndj.3da");
  lpblocinfo->lpbanque_animation->trouve_element ((void *) &nom, lpblocinfo,
						  &lpanimation);

  temps = 0;

  temps_avance = 0;
  bloc_ndj.angle = 0;
  bloc_ndj.ratio_statique_avance = 0;
  bloc_ndj.ratio_attaque = 0;
  bloc_ndj.ratio_mort = 0;
  bloc_ndj.temps_animation_avance = 0;
  bloc_ndj.mot_choisi=lpblocinfo->lpdictionnaire->get_mot_hasard(3,6);
  bloc_ndj.lettre_courante=0;

  bloc_ndj.angle = 0;
  ID_joueur_attaque = -1;
  bloc_ndj.activite = NAIN_ACTIVITE_GLANDOUILLE;

  context_objet.amortissement_xy = 1.0;
  context_objet.k_adherence = 0.9;
  context_objet.v_avance_max = 15.0;
  bloc_vivant.vie = 10;
  cible_joueur_pour_lettre=false;	  
}

JEU_NDJ::~JEU_NDJ ()
{
}

void JEU_NDJ::get_info_lettre(bool& cible_joueur, int& lettre_courante, bool& vie)
{
  cible_joueur=cible_joueur_pour_lettre;
  lettre_courante=bloc_ndj.lettre_courante;
  vie=bloc_vivant.vie;
};

bool JEU_NDJ::envoie_lettre(char lettre)
{
  char vraie_lettre=bloc_ndj.mot_choisi.info[bloc_ndj.lettre_courante];
  if (vraie_lettre == lettre)
    {
      bloc_ndj.lettre_courante++;
      if (bloc_ndj.lettre_courante == bloc_ndj.mot_choisi.taille + 1)
	{
	  bloc_vivant.vie = 0;
	}
      return true;
    }
  return false;
}

bool JEU_NDJ::cible_potentielle_lettre()
{
  return bloc_vivant.vie != 0;
};
