/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef JEU_NAIN_FICHIER
#define JEU_NAIN_FICHIER


#include "jeu.h"
#include "jeu_vivant.h"

// Que les personnes naines se rassurent, je n'ai aucun grief contre elles.
// C'est juste que j'aime pas les nains de jardins. C'est tout.

// Le temps  attendre quand on ne fait rien.
#define NAIN_TEMPS_ATTENTE 0.5

// Le temps pour une action.
#define NAIN_TEMPS_ACTION  1.0

// Le temps pour une attaque.
#define NAIN_TEMPS_ATTAQUE  0.5

// La distance minimale pour "voir" la cible.
#define NAIN_DISTANCE_MINIMALE 15.0

// La distance minimale pour "attaquer" la cible.
#define NAIN_DISTANCE_ATTAQUE 2.0

// Le taux d'attaque d'un nain eleve au petit grain, et bien entretenu.
#define NAIN_TAUX_ATTAQUE  10

// Les diffrentes activits possibles pour les nains.
typedef enum NAIN_ACTIVITE
{
  NAIN_ACTIVITE_AVANCE,
  NAIN_ACTIVITE_ATTAQUE,
  NAIN_ACTIVITE_GLANDOUILLE,
  NAIN_ACTIVITE_MORT
};


typedef struct BLOC_NDJ_SERVEUR
{
  float temps_animation_avance;
  float ratio_statique_avance;
  float ratio_attaque;
  float ratio_mort;
  // Ceci dfinit l'angle de rotation du NDJ selon l'axe Z.
  float angle;
  NAIN_ACTIVITE activite;
  MOT mot_choisi;
  int lettre_courante;
  int id_joueur_accroche;
};

class JEU_NDJ:public JEU_VIVANT
{
  float temps;
  BLOC_NDJ_SERVEUR bloc_ndj;

  // Variables qui servent exclusivement au serveur pour l'AI du Nain.
  RWVECTOR direction;
  float temps_avance;
  int ID_joueur_attaque;

  // Client
  bool lettre_init;
  bool cible_joueur_pour_lettre;

public:

  void get_info_lettre(bool& cible_joueur, int& lettre_courante, bool& vie);

  virtual short int typeElementJeu ()
  {
    return TYPE_NDJ;
  };

  void gestion_globale (LPBLOCINFO lpblocinfo);
  void LectureParamJeu (BUFFER_NOEUD * BF, buffer_noeud * bn,
			LPBLOCINFO lpblocinfo);

  void lecture (LPBLOCINFO lpblocinfo, STOCK & stock, int &position_stock);
  void ecriture (LPBLOCINFO lpblocinfo, STOCK & stock);

  virtual bool envoie_lettre(char lettre);
  virtual bool cible_potentielle_lettre();

  MOT get_mot() { return bloc_ndj.mot_choisi; };

  JEU_NDJ (LPBLOCINFO lpblocinfo);
  ~JEU_NDJ ();

};


#endif
