/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: jeu_option.cpp,v 1.5 2006/12/29 12:30:17 atila Exp $

#include "jeu_option.h"

#include "jeu_joueur.h"


JEU_OPTION::JEU_OPTION (LPBLOCINFO lpblocinfo)
{
  // Positionner quelques variables.
  context_objet.rayon = 0.5;
  context_objet.masse = 100;
  bloc_jeu_option.apparait = 0;
  temps_reapparait = -30;
  context_objet.type = elementinactif;
  context_objet.v_avance_max = 0;
  context_objet.v_avance = RWVECTOR (0, 0, 0);
  context_objet.v_saute = RWVECTOR (0, 0, 0);
  context_objet.v_avance_involontaire = RWVECTOR (0, 0, 0);
  context_objet.amortissement_xy = 0.0;
  context_objet.k_adherence = 0.0;
};

JEU_OPTION::~JEU_OPTION ()
{
};

void
JEU_OPTION::interaction (LPBLOCINFO lpblocinfo, ELEMENTJEU * lpelem)
{
  // Si c'est un joueur : on fait ce qu'il faut.
  // Sinon , on fait rien.
  if ((lpelem->typeElementJeu () == TYPE_JOUEUR)
      && (bloc_jeu_option.apparait == 1.0))
    {
      bloc_jeu_option.apparait = temps_reapparait;
      JEU_JOUEUR *lpj = (JEU_JOUEUR *) lpelem;
      switch (bloc_jeu_option.type_jeu_option)
	{
	case Pigeon:
	  {
	    lpj->ajoute_option (OPTION_PIGEON, 30);
	  }
	  break;
	case Invulnerabilite:
	  {
	    lpj->ajoute_option (OPTION_INVULNERABILITE, 30);
	  }
	  break;
	case Annihilatron:
	  {
	    lpj->ajoute_option (OPTION_ANNIHILATRON, 30);
	  }
	  break;
	case Rapidite:
	  {
	    lpj->ajoute_option (OPTION_RAPIDITE, 30);
	  }
	  break;
	case SuperPuissance:
	  {
	    lpj->ajoute_option (OPTION_SUPERPUISSANCE, 30);
	  }
	  break;
	case Vie:
	  {
	    lpj->ajoute_vie (10);
	  }
	  break;
	case SuperVie:
	  {
	    lpj->ajoute_vie (100);
	  }
	  break;
	case ObjetTransporteur:
	  {
	    lpj->teleporte (cible_transporteur);
	    bloc_jeu_option.apparait = 1;
	  }
	  break;
	case ObjetSortie:
	  {
	    bloc_jeu_option.apparait = 1;
	    lpj->set_gagne ();
	  }
	  break;
	case Armure:
	  {
	    lpj->ajoute_armure (10);
	  }
	  break;
	case SuperArmure:
	  {
	    lpj->ajoute_armure (100);
	  }
	  break;
	case Munition1:
	  {
	    lpj->ajoute_munition (0, 10);
	  }
	  break;
	case Munition2:
	  {
	    lpj->ajoute_munition (0, 50);
	  }
	  break;
	case Munition3:
	  {
	    lpj->ajoute_munition (1, 5);
	  }
	  break;
	case Munition4:
	  {
	    lpj->ajoute_munition (1, 20);
	  }
	  break;
	case Munition5:
	  {
	    lpj->ajoute_munition (2, 5);
	  }
	  break;
	case Munition6:
	  {
	    lpj->ajoute_munition (2, 20);
	  }
	  break;
	case Munition7:
	  {
	    lpj->ajoute_munition (3, 10);
	  }
	  break;
	case Munition8:
	  {
	    lpj->ajoute_munition (3, 100);
	  }
	  break;
	case Munition9:
	  {
	    lpj->ajoute_munition (8, 10);
	  }
	  break;
	case Munition10:
	  {
	    lpj->ajoute_munition (9, 10);
	  }
	  break;
	case Arme1:
	  {
	    lpj->ajoute_arme (0);
	  }
	  break;
	case Arme2:
	  {
	    lpj->ajoute_arme (1);
	  }
	  break;
	case Arme3:
	  {
	    lpj->ajoute_arme (2);
	  }
	  break;
	case Arme4:
	  {
	    lpj->ajoute_arme (3);
	  }
	  break;
	case Arme5:
	  {
	    lpj->ajoute_arme (4);
	  }
	  break;
	case Arme6:
	  {
	    lpj->ajoute_arme (5);
	  }
	  break;
	case Arme7:
	  {
	    lpj->ajoute_arme (6);
	  }
	  break;
	case Arme8:
	  {
	    lpj->ajoute_arme (7);
	  }
	  break;
	case Arme9:
	  {
	    lpj->ajoute_arme (8);
	  }
	  break;
	case Arme10:
	  {
	    lpj->ajoute_arme (9);
	  }
	  break;
	}
    }
};

void
JEU_OPTION::lecture (LPBLOCINFO lpblocinfo, STOCK & stock,
		     int &position_stock)
{
  ELEMENTJEU::lecture (lpblocinfo, stock, position_stock);
  bloc_jeu_option =
    *((BLOC_JEU_OPTION *) stock.get_posbuffer (position_stock));
  position_stock += sizeof (struct BLOC_JEU_OPTION);
};

void
JEU_OPTION::ecriture (LPBLOCINFO lpblocinfo, STOCK & stock)
{
  ELEMENTJEU::ecriture (lpblocinfo, stock);
  stock.put_buffer ((char *) &bloc_jeu_option,
		    sizeof (struct BLOC_JEU_OPTION));
};


void
JEU_OPTION::gestion_globale (LPBLOCINFO lpblocinfo)
{
  if (lpblocinfo->serveur)
    {
      //ELEMENTJEU::gestion_globale (lpblocinfo);
      bloc_jeu_option.apparait = bloc_jeu_option.apparait + lpblocinfo->diff;
      if (bloc_jeu_option.apparait > 1.0)
	bloc_jeu_option.apparait = 1.0;
      /* Pas d'armes en mode clavier */
      if (lpblocinfo->mode_jeu != MODE_JEU_ARCADE)
	{
	  if ( (bloc_jeu_option.type_jeu_option >= Munition1 )
	       &&
	       (bloc_jeu_option.type_jeu_option <= Arme10) )
	    {
	      suicide=true;
	    }
	}
    }
  if (lpblocinfo->client)
    {
      temps += lpblocinfo->T - lpblocinfo->LT;
      if (temps > constante_anim[bloc_jeu_option.type_jeu_option].temps_anim)
	temps -= constante_anim[bloc_jeu_option.type_jeu_option].temps_anim;

      if (refresh)
	{
	  lpanimation->init_animation ();
	  BLOCINFO blocinfo2 = *lpblocinfo;

	  MOT anim1 ("1");
	  blocinfo2.T = bloc_jeu_option.apparait;
	  lpanimation->applique_animation (&anim1, &blocinfo2);


	  MOT anim0 ("0");
	  blocinfo2.T = temps;
	  lpanimation->applique_animation (&anim0, &blocinfo2);

	  MATRIX t;
	  t.translation (context_objet.contexte.position);

	  lpanimation->fin_animation (lpblocinfo, &t);
	};
    }
};

void
JEU_OPTION::init_standard (LPBLOCINFO lpblocinfo)
{
  MOT nom;
  temps = 0;
  nom = MOT (constante_anim[bloc_jeu_option.type_jeu_option].nom_anim);
  int err =
    lpblocinfo->lpbanque_animation->trouve_element ((void *) &nom, lpblocinfo,
						    &lpanimation);
};

void
JEU_OPTION::LectureParamJeu (BUFFER_NOEUD * BF, buffer_noeud * bn,
			     LPBLOCINFO lpblocinfo)
{
  ELEMENTJEU::LectureParamJeu (BF, bn, lpblocinfo);

  // C'est ici qu'on fait le boulot d'init en fait...
  bloc_jeu_option.type_jeu_option = Vie;
  while (bn)
    {
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_VIE)
	bloc_jeu_option.type_jeu_option = Vie;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_SUPERVIE)
	bloc_jeu_option.type_jeu_option = SuperVie;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ARMURE)
	bloc_jeu_option.type_jeu_option = Armure;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_SUPERARMURE)
	bloc_jeu_option.type_jeu_option = SuperArmure;

      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_MUNITION1)
	bloc_jeu_option.type_jeu_option = Munition1;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_MUNITION2)
	bloc_jeu_option.type_jeu_option = Munition2;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_MUNITION3)
	bloc_jeu_option.type_jeu_option = Munition3;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_MUNITION4)
	bloc_jeu_option.type_jeu_option = Munition4;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_MUNITION5)
	bloc_jeu_option.type_jeu_option = Munition5;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_MUNITION6)
	bloc_jeu_option.type_jeu_option = Munition6;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_MUNITION7)
	bloc_jeu_option.type_jeu_option = Munition7;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_MUNITION8)
	bloc_jeu_option.type_jeu_option = Munition8;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_MUNITION9)
	bloc_jeu_option.type_jeu_option = Munition9;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_MUNITION10)
	bloc_jeu_option.type_jeu_option = Munition10;

      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ARME1)
	bloc_jeu_option.type_jeu_option = Arme1;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ARME2)
	bloc_jeu_option.type_jeu_option = Arme2;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ARME3)
	bloc_jeu_option.type_jeu_option = Arme3;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ARME4)
	bloc_jeu_option.type_jeu_option = Arme4;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ARME5)
	bloc_jeu_option.type_jeu_option = Arme5;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ARME6)
	bloc_jeu_option.type_jeu_option = Arme6;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ARME7)
	bloc_jeu_option.type_jeu_option = Arme7;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ARME8)
	bloc_jeu_option.type_jeu_option = Arme8;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ARME9)
	bloc_jeu_option.type_jeu_option = Arme9;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ARME10)
	bloc_jeu_option.type_jeu_option = Arme10;

      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_PIGEON)
	bloc_jeu_option.type_jeu_option = Pigeon;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_ANNIHILATRON)
	bloc_jeu_option.type_jeu_option = Annihilatron;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_RAPIDITE)
	bloc_jeu_option.type_jeu_option = Rapidite;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_INVULNERABILITE)
	bloc_jeu_option.type_jeu_option = Invulnerabilite;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_SUPERPUISSANCE)
	bloc_jeu_option.type_jeu_option = SuperPuissance;
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_SORTIE)
	{
	  bloc_jeu_option.type_jeu_option = ObjetSortie;
	  temps_reapparait = 1.0;
	}
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_TELEPORTEUR)
	{
	  temps_reapparait = 1.0;
	  bloc_jeu_option.type_jeu_option = ObjetTransporteur;
	}
      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_CIBLE)
	cible_transporteur = VERTEX (BF, BF->get_fils (bn)).get_point ();

      if (BF->get_nom (bn) == CONSTANTE_SCRIPT_REAPPARAIT)
	temps_reapparait = -BF->get_float (bn);

      bn = BF->trouve_suivant (bn);
    }
  init_standard (lpblocinfo);
};
