/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: jeu_option.h,v 1.4 2006/12/27 12:03:29 atila Exp $

#ifndef JEU_OPTION_FICHIER
#define JEU_OPTION_FICHIER

#include "jeu.h"

typedef enum TYPE_JEU_OPTION
{
  Vie, SuperVie,
  Armure, SuperArmure,
  Munition1, Munition2, Munition3, Munition4, Munition5, Munition6, Munition7,
  Munition8, Munition9, Munition10,
  Arme1, Arme2, Arme3, Arme4, Arme5, Arme6, Arme7, Arme8, Arme9, Arme10,
  Pigeon, Rapidite, Invulnerabilite, Annihilatron, SuperPuissance,
  ObjetSortie, ObjetTransporteur
};

typedef struct CONSTANTE_ANIM
{
  char *nom_anim;
  float temps_anim;
};


const CONSTANTE_ANIM constante_anim[31] = {
  {"d_commun/d_objet3d/vie.3da", 1.0},
  {"d_commun/d_objet3d/supervie.3da", 1.0},
  {"d_commun/d_objet3d/armure.3da", 1.0},
  {"d_commun/d_objet3d/superarmure.3da", 1.0},

  {"d_commun/d_armes/munition_balle_simple/mbs.3da", 1.0},
  {"d_commun/d_armes/munition_balle_multiple/mbm.3da", 1.0},
  {"d_commun/d_armes/munition_mine_simple/mms.3da", 1.0},
  {"d_commun/d_armes/munition_mine_multiple/mmm.3da", 1.0},
  {"d_commun/d_armes/munition_roquette_simple/mrs.3da", 1.0},
  {"d_commun/d_armes/munition_roquette_multiple/mrm.3da", 1.0},
  {"d_commun/d_armes/munition_plasma/plasma.3da", 1.0},
  {"", 1.0},
  {"", 1.0},
  {"", 1.0},

  {"", 1.0},			// Arme 0
  {"d_commun/d_armes/machinegun/machinegun_simple.3da", 1.0},	// Arme 1
  {"d_commun/d_armes/tromblon/tromblon.3da", 8.0},	// Arme 2
  {"d_commun/d_armes/machinegun/machinegun_complexe.3da", 1.0},	// Arme 3
  {"d_commun/d_armes/lancemine/lancemine.3da", 1.0},	// Arme 4
  {"d_commun/d_armes/lanceroquette/lanceroquette.3da", 1.0},	// Arme 5
  {"d_commun/d_armes/fusilplasma/fusilplasma.3da", 1.0},	// Arme 6
  {"", 1.0},			// Arme 7
  {"", 1.0},			// Arme 8
  {"", 1.0},			// Arme 9


  {"d_commun/d_objet3d/pigeon.3da", 10.0},
  {"d_commun/d_objet3d/rapidite.3da", 1.0},
  {"d_commun/d_objet3d/invulnerabilite.3da", 1.0},
  {"d_commun/d_objet3d/annihilatron.3da", 1.0},
  {"d_commun/d_objet3d/superpuissance.3da", 1.0},

  {"d_commun/d_objet3d/sortie.3da", 5.0},
  {"d_commun/d_objet3d/teleporteur.3da", 1.0}
};

typedef struct BLOC_JEU_OPTION
{
  TYPE_JEU_OPTION type_jeu_option;
  float apparait;
};

class JEU_OPTION:public ELEMENTJEU
{
  BLOC_JEU_OPTION bloc_jeu_option;

  float temps;
  float temps_reapparait;

  RWVECTOR cible_transporteur;

public:

    virtual short int typeElementJeu ()
  {
    return TYPE_OPTION;
  };
  virtual void interaction (LPBLOCINFO lpblocinfo, ELEMENTJEU *);

  void LectureParamJeu (BUFFER_NOEUD * BF, buffer_noeud * bn,
			LPBLOCINFO lpblocinfo);

  JEU_OPTION (LPBLOCINFO lpblocinfo);
  ~JEU_OPTION ();

  void init_standard (LPBLOCINFO lpblocinfo);

  void gestion_globale (LPBLOCINFO lpblocinfo);

  void lecture (LPBLOCINFO lpblocinfo, STOCK & stock, int &position_stock);
  void ecriture (LPBLOCINFO lpblocinfo, STOCK & stock);

};

#endif
