/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "jeu_projectile.h"

#include "jeu_impact.h"

void
JEU_PROJECTILE::eclate (LPBLOCINFO lpblocinfo)
{
  suicide = true;
  RWVECTOR a = context_objet.contexte.position;
  RWVECTOR b = RWVECTOR (0, 0, 0);
  lpblocinfo->lpjeu->explosion (lpblocinfo, source_elem, a, b, 10, 4);
};

void
JEU_PROJECTILE::gestion_globale (LPBLOCINFO lpblocinfo)
{
  ELEMENTJEU::gestion_globale (lpblocinfo);
  if (lpblocinfo->serveur)
    {
      temps_avant_fin -= lpblocinfo->diff;
      if (temps_avant_fin < 0.0)
	eclate (lpblocinfo);
      switch (bloc_projectile.type_projectile)
	{
	case TYPE_PROJECTILE_MISSILE:
	  context_objet.v_avance = bloc_projectile.vitesse_missile;
	  if (context_objet.contexte.contact)
	    {
	      eclate (lpblocinfo);
	    }
	  break;
	case TYPE_PROJECTILE_PLASMA:
	  context_objet.v_avance = bloc_projectile.vitesse_missile;

	  break;
	case TYPE_PROJECTILE_GRENADE:
	  // Gestion du rebond sur un mur.
	  bloc_projectile.temps_rebond += lpblocinfo->diff;
	  if (context_objet.contexte.contact)
	    bloc_projectile.temps_rebond = 0;
	  break;
	};
    };
  if (lpblocinfo->client)
    // Si c'est client, animer.
    {
      if (!lpanimation)
	{
	  MOT nom;
	  // Chercher  charger le bon objet.
	  switch (bloc_projectile.type_projectile)
	    {
	    case TYPE_PROJECTILE_AUCUN:

	      break;
	    case TYPE_PROJECTILE_GRENADE:
	      nom = MOT ("d_commun/d_armes/grenade/grenade.3da");
	      lpblocinfo->lpbanque_animation->trouve_element ((void *) &nom,
							      lpblocinfo,
							      &lpanimation);
	      break;
	    case TYPE_PROJECTILE_MISSILE:
	      nom = MOT ("d_commun/d_armes/missile/missile.3da");
	      lpblocinfo->lpbanque_animation->trouve_element ((void *) &nom,
							      lpblocinfo,
							      &lpanimation);
	      matrice_z_missile.genere_avec_u (bloc_projectile.
					       vitesse_missile);
	      break;
	    case TYPE_PROJECTILE_PLASMA:
	      nom = MOT ("d_commun/d_armes/plasma/plasma.3da");
	      lpblocinfo->lpbanque_animation->trouve_element ((void *) &nom,
							      lpblocinfo,
							      &lpanimation);
	      matrice_z_missile.genere_avec_u (bloc_projectile.
					       vitesse_missile);
	      break;
	    }
	}
      if (lpanimation)
	{

	  lpanimation->init_animation ();
	  BLOCINFO blocinfo2 = *lpblocinfo;

	  MATRIX t;
	  t.translation (context_objet.contexte.position);

	  if (bloc_projectile.type_projectile == TYPE_PROJECTILE_MISSILE)
	    t = t * matrice_z_missile;

	  // L'animation basique de l'objet, varie de 0  1
	  MOT anim_base ("BASE");
	  blocinfo2.T = lpblocinfo->T - ((int) lpblocinfo->T);
	  lpanimation->applique_animation (&anim_base, &blocinfo2);

	  // Le bruit de rebond sr un mur.
	  MOT anim_rebond ("REBOND");
	  blocinfo2.T = bloc_projectile.temps_rebond;
	  lpanimation->applique_animation (&anim_rebond, &blocinfo2);

	  // L'animation pour le plasma.
	  MOT anim_plasma ("PLASMA");
	  blocinfo2.T = temps_plasma;
	  temps_plasma += lpblocinfo->diff;
	  if (temps_plasma > 1.0)
	    temps_plasma = 0;
	  lpanimation->applique_animation (&anim_plasma, &blocinfo2);

	  lpanimation->fin_animation (lpblocinfo, &t);

	  if (bloc_projectile.type_projectile == TYPE_PROJECTILE_MISSILE)
	    {
	      temps_fumee += lpblocinfo->diff;
	      if (temps_fumee > TEMPS_FUMEE_MISSILE)
		{
		  temps_fumee = 0;
		  lpblocinfo->lpjeu->creation_fumee (lpblocinfo,
						     context_objet.contexte.
						     position,
						     RWVECTOR (rand () /
							       (float)
							       RAND_MAX *
							       0.8 - 0.4,
							       rand () /
							       (float)
							       RAND_MAX *
							       0.8 - 0.4,
							       0.5));
		};
	    }

	};
    }
}

void
JEU_PROJECTILE::LectureParamJeu (BUFFER_NOEUD * BF, buffer_noeud * bn,
				 LPBLOCINFO lpblocinfo)
{
  ELEMENTJEU::LectureParamJeu (BF, bn, lpblocinfo);
  // Rien, puisqu'il s'agit en principe d'un lment cr dynamiquement.
  // Chargement spécifique....
  // genre, type d'arme, etc...
}

void
JEU_PROJECTILE::lecture (LPBLOCINFO lpblocinfo, STOCK & stock,
			 int &position_stock)
{
  ELEMENTJEU::lecture (lpblocinfo, stock, position_stock);
  bloc_projectile =
    *((BLOC_PROJECTILE_SERVEUR *) stock.get_posbuffer (position_stock));
  position_stock += sizeof (struct BLOC_PROJECTILE_SERVEUR);
}

void
JEU_PROJECTILE::ecriture (LPBLOCINFO lpblocinfo, STOCK & stock)
{
  ELEMENTJEU::ecriture (lpblocinfo, stock);
  stock.put_buffer ((char *) &bloc_projectile,
		    sizeof (struct BLOC_PROJECTILE_SERVEUR));
}

JEU_PROJECTILE::JEU_PROJECTILE (LPBLOCINFO lpblocinfo)
{
  // Chargement d'animation si c'est un client...
  lpanimation = NULL;

  // Positionner quelques variables.
  context_objet.rayon = 0.01;
  context_objet.masse = 0.1;
  context_objet.type = elementjeumobile;
  context_objet.avance_sans_contact = true;

  // Le temps de paramtrer son auto-destruction.
  temps_avant_fin = 1.0;

  // On suppose que personne n'a tir. Utilser set_source pour mettre en place une valeur.
  source_elem = -1;

  // On supprime tout son de rebond au dmarrage
  bloc_projectile.temps_rebond = 10;

  temps_plasma = 1.0;
  temps_fumee = 0;
}

JEU_PROJECTILE::~JEU_PROJECTILE ()
{
}

void
JEU_PROJECTILE::set_type (TYPE_CORE_PROJECTILE type_proj)
{
  bloc_projectile.type_projectile = type_proj;
  switch (type_proj)
    {
    case TYPE_PROJECTILE_AUCUN:
      break;
    case TYPE_PROJECTILE_GRENADE:
      temps_avant_fin = TEMPS_VIE_MINE;
      context_objet.amortissement_z = 1.8;
      context_objet.amortissement_xy = 0.8;
      context_objet.masse = 100;
      break;
    case TYPE_PROJECTILE_MISSILE:
      temps_avant_fin = TEMPS_VIE_MISSILE;
      break;
    case TYPE_PROJECTILE_PLASMA:
      temps_avant_fin = TEMPS_VIE_PLASMA;
      break;
    };
};

void
JEU_PROJECTILE::set_vitesse (RWVECTOR vit)
{
  bloc_projectile.vitesse_missile = vit;

  if (bloc_projectile.type_projectile == TYPE_PROJECTILE_GRENADE)
    context_objet.contexte.v_impulsion = vit;

  RWVECTOR v2 = vit.normalise ();
};

void
JEU_PROJECTILE::set_source (int source)
{
  source_elem = source;
};

void
JEU_PROJECTILE::interaction (LPBLOCINFO lpblocinfo, ELEMENTJEU * elem)
{
  if (elem->getID () != source_elem)
    if (elem->interaction_danger_possible (COUP_EXPLOSION))
      {
	eclate (lpblocinfo);
      };
}
