/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef JEU_PROJECTILE_FICHIER
#define JEU_PROJECTILE_FICHIER

#include "jeu.h"
#include "controle.h"
#include "animation_texture.h"

typedef enum
{
  TYPE_PROJECTILE_AUCUN,
  TYPE_PROJECTILE_GRENADE,
  TYPE_PROJECTILE_MISSILE,
  TYPE_PROJECTILE_PLASMA
} TYPE_CORE_PROJECTILE;

typedef struct BLOC_PROJECTILE_SERVEUR
{
  TYPE_CORE_PROJECTILE type_projectile;
  RWVECTOR vitesse_missile;

  // Pour grenade, il faut pouvoir grerle bruit du rebond sur le sol. 
  // Ce paramtre est calcul ct serveur puisqu'il n'y a pas d'interpolation ct client 
  // su ce type d'objet.
  float temps_rebond;

};

#define TEMPS_VIE_MISSILE    5
#define TEMPS_VIE_MINE       2
#define TEMPS_VIE_PLASMA     5
#define TEMPS_FUMEE_MISSILE  0.05

class JEU_PROJECTILE:public ELEMENTJEU
{
  BLOC_PROJECTILE_SERVEUR bloc_projectile;

  // Le temps avant l'auo-destruction du projectile.
  float temps_avant_fin;

  // La matrice pour l'orientation du missile.
  MATRIX matrice_z_missile;

  // L'lment qui a fait "ca".
  int source_elem;

  // Le temps de l'anim du plasma
  float temps_plasma;

  // Temps avant faire une fumee. uniquement cote client.
  float temps_fumee;

public:
  void set_type (TYPE_CORE_PROJECTILE type_proj);
  // Une fonction utilise pour metter en place la vitesse d'un missile.
  // il faut passer en paramtre : vitesse du lanceur+vitesse du missile.
  void set_vitesse (RWVECTOR vit);

  void set_source (int source);

  void eclate (LPBLOCINFO lpblocinfo);

  virtual short int typeElementJeu ()
  {
    return TYPE_PROJECTILE;
  };

  void gestion_globale (LPBLOCINFO lpblocinfo);
  void LectureParamJeu (BUFFER_NOEUD * BF, buffer_noeud * bn,
			LPBLOCINFO lpblocinfo);

  void lecture (LPBLOCINFO lpblocinfo, STOCK & stock, int &position_stock);
  void ecriture (LPBLOCINFO lpblocinfo, STOCK & stock);

  virtual void interaction (LPBLOCINFO lpblocinfo, ELEMENTJEU *);

  JEU_PROJECTILE (LPBLOCINFO lpblocinfo);
  ~JEU_PROJECTILE ();

};


#endif
