/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "lumiere.h"

/************************************/
/*******	 		*****/
/*******	 INFO_LUMIERE	*****/
/*******	 		*****/
/************************************/

INFO_LUMIERE::INFO_LUMIERE (BUFFER_NOEUD * BF, buffer_noeud * bf)
{
// Lecture des paramtres... C'est juste une application bestiale des
// paramtres de lumiere de nom_script.
  while (bf)
    {
      switch (BF->get_nom (bf))
	{
	case CONSTANTE_SCRIPT_TL_AMBIANTE:
	  {
	    type_lumiere = LUMIERE_AMBIANTE;
	    break;
	  }
	case CONSTANTE_SCRIPT_TL_AMBIANTE_DIFFUSE:
	  {
	    type_lumiere = LUMIERE_AMBIANTE_DIFFUSE;
	    break;
	  }
	case CONSTANTE_SCRIPT_TL_SPOT:
	  {
	    type_lumiere = LUMIERE_SPOT;
	    break;
	  }
	case CONSTANTE_SCRIPT_TL_CONE:
	  {
	    type_lumiere = LUMIERE_CONE;
	    break;
	  }
	case CONSTANTE_SCRIPT_ZL_OBJET:
	  {
	    zone_lumiere = LUMIERE_OBJET;
	    break;
	  }
	case CONSTANTE_SCRIPT_ZL_ANIMATION:
	  {
	    zone_lumiere = LUMIERE_ANIMATION;
	    break;
	  }
	case CONSTANTE_SCRIPT_ZL_SCENE:
	  {
	    zone_lumiere = LUMIERE_SCENE;
	    break;
	  }
	}
      bf = BF->trouve_suivant (bf);
    }
//printf("TypeLumiere %i ZoneLumiere %i\n",type_lumiere,zone_lumiere);
}

INFO_LUMIERE::INFO_LUMIERE ()
{
// Pas de loupiote par dfaut !
  zone_lumiere = LUMIERE_ABSENTE;
  type_lumiere = LUMIERE_SANS;
}

INFO_LUMIERE::~INFO_LUMIERE ()
{

}

/************************************/
/*******	 		*****/
/*******	 VALEUR_LUMIERE	*****/
/*******	 		*****/
/************************************/

VALEUR_LUMIERE::VALEUR_LUMIERE (BUFFER_NOEUD * BN, buffer_noeud * bn)
{
  A = 0.0;
  R = 0.0;
  G = 0.0;
  B = 0.0;
  rayon = 0;
  intensite = 0;
  while (bn)
    {
      switch (BN->get_nom (bn))
	{
	case CONSTANTE_SCRIPT_LUMIERE_R:
	  R = BN->get_float (bn);
	  break;
	case CONSTANTE_SCRIPT_LUMIERE_G:
	  G = BN->get_float (bn);
	  break;
	case CONSTANTE_SCRIPT_LUMIERE_B:
	  B = BN->get_float (bn);
	  break;
	case CONSTANTE_SCRIPT_LUMIERE_A:
	  A = BN->get_float (bn);
	  break;
	case CONSTANTE_SCRIPT_INTENSITELUMIERE:
	  intensite = BN->get_float (bn);
	  break;
	case CONSTANTE_SCRIPT_RAYONLUMIERE:
	  rayon = BN->get_float (bn);
	  break;
	}
      bn = BN->trouve_suivant (bn);
    }
//printf("R %f G %f B %f Rayon\n",R,G,B,rayon);
}

VALEUR_LUMIERE::VALEUR_LUMIERE ()
{
  R = 0;
  G = 0;
  B = 0;
  A = 0;
  intensite = 0.0;
  rayon = 0.0;
}

VALEUR_LUMIERE::VALEUR_LUMIERE (float r, float g, float b, float a, float ra,
				float i):
R (r),
G (g),
B (b),
A (a),
rayon (ra),
intensite (i)
{
};

VALEUR_LUMIERE::VALEUR_LUMIERE (float r, float g, float b, float a):
R (r),
G (b),
B (b),
A (a)
{
  intensite = 0.0;
  rayon = 0.0;
};


VALEUR_LUMIERE::~VALEUR_LUMIERE ()
{
}

void
VALEUR_LUMIERE::mix (VALEUR_LUMIERE & v1, VALEUR_LUMIERE & v2, float T1,
		     float T2, float T)
{
  float x = (T - T1) / (T2 - T1);
  R = x * (v2.R - v1.R) + v1.R;
  G = x * (v2.G - v1.G) + v1.G;
  B = x * (v2.B - v1.B) + v1.B;
  A = x * (v2.A - v1.A) + v1.A;
//printf("R %f G %f B %f T %f T1 %f T2 %f\n",R,G,B,T,T1,T2);
  intensite = x * (v2.intensite - v1.intensite) + v1.intensite;
  rayon = x * (v2.rayon - v1.rayon) + v1.rayon;
}

void
VALEUR_LUMIERE::somme (VALEUR_LUMIERE & v, float poids)
{
  R = poids * v.R + R;
  G = poids * v.G + G;
  B = poids * v.B + B;
  A = poids * v.A + A;
// Ce qui suit n'a  priori aucun sens.
  intensite = max (poids * v.intensite, intensite);
  rayon = max (poids * v.rayon, rayon);
}

VALEUR_LUMIERE
VALEUR_LUMIERE::operator* (float mult)
{
  return VALEUR_LUMIERE (R * mult, G * mult, B * mult, A * mult, rayon,
			 intensite);
};

VALEUR_LUMIERE
VALEUR_LUMIERE::operator+ (VALEUR_LUMIERE vl)
{
  return VALEUR_LUMIERE (R + vl.R, G + vl.G, B + vl.B, A + vl.A, rayon,
			 intensite);
};
