/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: menu.cpp,v 1.3 2006/12/21 18:18:14 atila Exp $
#define GL_GLEXT_PROTOTYPES
#include "menu.h"
#include "option.h"
#include "local_glu.h"
#include "win3d.h"

void init_video (bool fs, int resolution);

void
MENU::get_info_niveau ()
{
  INFO_NIVEAU info2;
  info_niveau = info2;

  NIVEAU niv;
  MOT nom_fichier = liste_niveau[niveau_num];
  niv.donne_info_niveau (&nom_fichier, lpblocinfo, &info_niveau);
}


MOT
set_opt (LPFICHIER_OPTION lpfichier_option, char *opt, char *defaut,
	 bool upper)
{
  MOT result;
  if (lpfichier_option->get_option (opt, result))
    {
      if (upper)
	result.upper ();
      return result;
    }
  else
    {
      lpfichier_option->put_option (opt, defaut);
      return MOT (defaut);
    }

};


void
MENU::init ()
{
  niveau_num = 0;
  choix_courant = MENU_JEU_CREERSERVEUR;
  cb_musique = -1;
  read_options ();
  edit_mode = false;
  mouse_x = 0;
  mouse_y = 0;
}

void
MENU::read_options ()
{
  lpblocinfo->lpfichier_option->read_option ();

  nom_joueur =
    set_opt (lpblocinfo->lpfichier_option, "playername", "NONAME", true);
  lpblocinfo->lpcontrole->set_avance (lpblocinfo->lpcontrole->
				      get_touche (set_opt
						  (lpblocinfo->
						   lpfichier_option,
						   "move_in",
						   lpblocinfo->lpcontrole->
						   get_avance ().info,
						   true)));
  lpblocinfo->lpcontrole->set_recule (lpblocinfo->lpcontrole->
				      get_touche (set_opt
						  (lpblocinfo->
						   lpfichier_option,
						   "move_out",
						   lpblocinfo->lpcontrole->
						   get_recule ().info,
						   true)));
  lpblocinfo->lpcontrole->set_strafe_gauche (lpblocinfo->lpcontrole->
					     get_touche (set_opt
							 (lpblocinfo->
							  lpfichier_option,
							  "move_strafe_left",
							  lpblocinfo->
							  lpcontrole->
							  get_strafe_gauche
							  ().info, true)));
  lpblocinfo->lpcontrole->set_strafe_droite (lpblocinfo->lpcontrole->
					     get_touche (set_opt
							 (lpblocinfo->
							  lpfichier_option,
							  "move_strafe_right",
							  lpblocinfo->
							  lpcontrole->
							  get_strafe_droite
							  ().info, true)));
  lpblocinfo->lpcontrole->set_saute (lpblocinfo->lpcontrole->
				     get_touche (set_opt
						 (lpblocinfo->
						  lpfichier_option,
						  "move_jump",
						  lpblocinfo->lpcontrole->
						  get_saute ().info, true)));
  lpblocinfo->lpcontrole->set_tir (lpblocinfo->lpcontrole->
				   get_touche (set_opt
					       (lpblocinfo->lpfichier_option,
						"fire",
						lpblocinfo->lpcontrole->
						get_tir ().info, true)));
  lpblocinfo->lpcontrole->set_texte (lpblocinfo->lpcontrole->
				     get_touche (set_opt
						 (lpblocinfo->
						  lpfichier_option, "talk",
						  lpblocinfo->lpcontrole->
						  get_texte ().info, true)));
  lpblocinfo->lpcontrole->set_action (lpblocinfo->lpcontrole->
				      get_touche (set_opt
						  (lpblocinfo->
						   lpfichier_option, "action",
						   lpblocinfo->lpcontrole->
						   get_action ().info,
						   true)));
  lpblocinfo->lpcontrole->set_vue (lpblocinfo->lpcontrole->
				   get_touche (set_opt
					       (lpblocinfo->lpfichier_option,
						"view",
						lpblocinfo->lpcontrole->
						get_vue ().info, true)));
  MOT inverse = set_opt (lpblocinfo->lpfichier_option,
			 "mouse_invert",
			 "TRUE",
			 true);
  if (inverse == "FALSE")
    lpblocinfo->lpcontrole->set_inverse (false);
  else
    lpblocinfo->lpcontrole->set_inverse (true);

  MOT sensib = set_opt (lpblocinfo->lpfichier_option,
			"mouse_sensib",
			"0.5",
			true);
  float res;
  sscanf (sensib.info, "%f", &res);
  lpblocinfo->lpcontrole->set_sensibilite (res);

  for (int i = 0; i != 10; i++)
    {
      char buff[100];
      sprintf (buff, "arme_%i", i);
      lpblocinfo->lpcontrole->set_arme (i,
					lpblocinfo->lpcontrole->
					get_touche (set_opt
						    (lpblocinfo->
						     lpfichier_option, buff,
						     lpblocinfo->lpcontrole->
						     get_arme (i).info,
						     true)));
    }

  MOT fullscreen = set_opt (lpblocinfo->lpfichier_option,
			    "fullscreen",
			    "TRUE",
			    true);
  if (fullscreen == "FALSE")
    lpblocinfo->blocecran.fullscreen = false;
  else
    lpblocinfo->blocecran.fullscreen = true;

  MOT resolution = set_opt (lpblocinfo->lpfichier_option,
			    "resolution",
			    "0",
			    true);
  int iresolution;
  sscanf (resolution.info, "%i", &iresolution);
  lpblocinfo->blocecran.resolution = iresolution;

  MOT lumiere = set_opt (lpblocinfo->lpfichier_option,
			 "lumiere",
			 "0",
			 true);
  int ilumiere;
  sscanf (lumiere.info, "%i", &ilumiere);
  lpblocinfo->blocecran.lumiere = (TypeLumiere) ilumiere;

  lpblocinfo->lpfichier_option->write_option ();

  init_video (lpblocinfo->blocecran.fullscreen,
	      lpblocinfo->blocecran.resolution);
};


void
MENU::write_options ()
{
  lpblocinfo->lpfichier_option->put_option ("playername", nom_joueur);
  lpblocinfo->lpfichier_option->put_option ("move_in",
					    lpblocinfo->lpcontrole->
					    get_avance ());
  lpblocinfo->lpfichier_option->put_option ("move_out",
					    lpblocinfo->lpcontrole->
					    get_recule ());
  lpblocinfo->lpfichier_option->put_option ("move_strafe_left",
					    lpblocinfo->lpcontrole->
					    get_strafe_gauche ());
  lpblocinfo->lpfichier_option->put_option ("move_strafe_right",
					    lpblocinfo->lpcontrole->
					    get_strafe_droite ());
  lpblocinfo->lpfichier_option->put_option ("view",
					    lpblocinfo->lpcontrole->
					    get_vue ());
  lpblocinfo->lpfichier_option->put_option ("action",
					    lpblocinfo->lpcontrole->
					    get_action ());
  lpblocinfo->lpfichier_option->put_option ("fire",
					    lpblocinfo->lpcontrole->
					    get_tir ());
  lpblocinfo->lpfichier_option->put_option ("talk",
					    lpblocinfo->lpcontrole->
					    get_texte ());
  lpblocinfo->lpfichier_option->put_option ("move_jump",
					    lpblocinfo->lpcontrole->
					    get_saute ());
  for (int i = 0; i != 10; i++)
    {
      char buff[100];
      sprintf (buff, "arme_%i", i);
      lpblocinfo->lpfichier_option->put_option (buff,
						lpblocinfo->lpcontrole->
						get_arme (i));
    }
  if (lpblocinfo->lpcontrole->get_inverse ())
    lpblocinfo->lpfichier_option->put_option ("mouse_invert", "TRUE");
  else
    lpblocinfo->lpfichier_option->put_option ("mouse_invert", "FALSE");
  char buff[100];
  sprintf (buff, "%f", lpblocinfo->lpcontrole->get_sensibilite ());
  lpblocinfo->lpfichier_option->put_option ("mouse_sensib", buff);

  if (lpblocinfo->blocecran.fullscreen)
    lpblocinfo->lpfichier_option->put_option ("fullscreen", "TRUE");
  else
    lpblocinfo->lpfichier_option->put_option ("fullscreen", "FALSE");
  lpblocinfo->lpbanque_texture->recharge ();
  lpblocinfo->lpaffiche_texte->init_client (lpblocinfo->lpbanque_texture,
					    lpblocinfo->lpbdd, true);

  char buff2[100];
  sprintf (buff2, "%i", lpblocinfo->blocecran.resolution);
  lpblocinfo->lpfichier_option->put_option ("resolution", buff2);

  sprintf (buff2, "%i", lpblocinfo->blocecran.lumiere);
  lpblocinfo->lpfichier_option->put_option ("lumiere", buff2);

  lpblocinfo->lpfichier_option->write_option ();
};

MENU::MENU (LPBLOCINFO lpb):lpblocinfo (lpb)
{
  choix_courant = MENU_JEU_CREERSERVEUR;
  mouse_x = 0;
  mouse_y = 0;
  anime_affiche = 0.0;
  MOT
    result;

  nom_machine = MOT ("LOCALHOST");
  port = MOT ("2007");
  liste_skin =
    lpblocinfo->lpbdd->liste_fichier_speciaux (MOT ("d_skin/"), MOT (".pcx"));
  skin_num = 0;
  liste_niveau =
    lpblocinfo->lpbdd->liste_fichier_speciaux (MOT (""), MOT (".niv"));
  niveau_num = 0;
  get_info_niveau ();

  init ();

  dessin = 0;
  DESCRIPTEUR_TEXTURE
    desc;
  desc.nom = MOT ("d_commun/d_ecran/titre.pcx");
  desc.blend_type = 0;
  desc.blend = 0;
  dessin =
    lpblocinfo->lpbanque_texture->trouve_texture (&desc, lpblocinfo->lpbdd);

  lpjoueur = new ANIMATION ();
  MOT
  nom ("d_commun/d_warrior/warrior.3da");
  lpjoueur->charge_animation (&nom, lpblocinfo);

  lpblocinfo->mode_jeu = MODE_JEU_ARCADE;
  lpblocinfo->mode_mouvement = MODE_MOUVEMENT_CONTRAINT;
  update_nom_mode ();
}

void
MENU::update_nom_mode ()
{
  switch (lpblocinfo->mode_jeu)
    {
    case MODE_JEU_ARCADE:
      nom_mode = MOT ("ARCADE");
      break;
    case MODE_JEU_CLAVIER:
      nom_mode = MOT ("FRAPPE AU CLAVIER");
      break;
    case MODE_JEU_CALCUL:
      nom_mode = MOT ("CALCUL MENTAL");
      break;
    }
  switch (lpblocinfo->mode_mouvement)
    {
    case MODE_MOUVEMENT_LIBRE:
      nom_mouvement = MOT ("LIBRE");
      break;
    case MODE_MOUVEMENT_CONTRAINT:
      nom_mouvement = MOT ("CONTRAINT");
      break;
    }
}

MENU::~MENU ()
{
  delete lpjoueur;
}

void
MENU::test_chaine (bool carac, bool chiffre, MOT * m)
{
  char l = lpblocinfo->lpcontrole->lettre_appuyee ();
  if (l && carac)
    {
      char b[2];
      b[0] = l;
      b[1] = 0;
      MOT m2 (b);
      *m = *m + m2;
    }
  l = lpblocinfo->lpcontrole->chiffre_appuyee ();
  if (l && chiffre)
    {
      char b[2];
      b[0] = l;
      b[1] = 0;
      MOT m2 (b);
      *m = *m + m2;
    }
  if (lpblocinfo->lpcontrole->efface_appuyee ())
    {
      m->dec ();
    };
};

void
MENU::affiche_dynamique (char *texte, int position, int numero)
{
  MOT m (texte);
  if (numero != choix_courant)
    lpblocinfo->lpaffiche_texte->affiche_texte (lpblocinfo, m, -10, position,
						20, 0);
  else
    lpblocinfo->lpaffiche_texte->affiche_texte (lpblocinfo, m,
						-10.0 +
						fabs (sin (anime_affiche)),
						position, 20, 0);
}

void
MENU::affiche_dynamique3 (MOT m, int px, int py)
{
  m.upper ();
  lpblocinfo->lpaffiche_texte->affiche_texte (lpblocinfo, m, py - 10, px, 30,
					      0);
}

void
MENU::affiche_dynamique2 (char *texte, MOT m, int position, int numero)
{
  char nom[500];
  if (choix_courant == numero)
    {
      sprintf (nom, "%s: %s*", texte, m.info);
      if (edit_mode)
	{
	  sprintf (nom, "%s: ***", texte);
	  MOT m (texte);
	  lpblocinfo->lpaffiche_texte->affiche_texte (lpblocinfo, m,
						      -10.0 +
						      fabs (sin
							    (anime_affiche)),
						      position, 20, 1, 0, 0,
						      0.7);
	  return;
	};
    }
  else
    {
      sprintf (nom, "%s: %s", texte, m.info);
    }
  affiche_dynamique (nom, position, numero);
}

extern int width, height;

void
MENU::affiche_courant ()
{
  lpblocinfo->lpmoteur->init_affichage (lpblocinfo, RWVECTOR (0, 0, 0),
					0, 0, width / height);
  lpblocinfo->lpmoteur->switch_mode_clip (false);
  anime_affiche += lpblocinfo->diff * 5;

  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  gluPerspective (60.0, (GLfloat) width / (GLfloat) height, 0.01, 300.0);
  glMatrixMode (GL_MODELVIEW);
  glLoadIdentity ();
  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  ETAT_MULTITEXTURE em;

  em.texture = dessin;
  em.actif = true;
  lpblocinfo->lpetat_texture->active_etat (1, em);
  em.actif = false;
  lpblocinfo->lpetat_texture->active_etat (0, em);

  VALEUR_LUMIERE vl (1, 1, 1, 0);
  lpblocinfo->lpetat_texture->set_color (0, vl);
  lpblocinfo->lpetat_texture->set_color (1, vl);


  glDepthMask (GL_FALSE);
  glMatrixMode (GL_MODELVIEW);
  glTranslatef (-0.5, .4, -.65);

  glBegin (GL_POLYGON);

  glMultiTexCoord2fARB_local (GL_TEXTURE1_ARB, 1, 1);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, 1, 1);
  glVertex3f (1, -1, 0);

  glMultiTexCoord2fARB_local (GL_TEXTURE1_ARB, 0, 1);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, 0, 1);
  glVertex3f (0, -1, 0);

  glMultiTexCoord2fARB_local (GL_TEXTURE1_ARB, 0, 0);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, 0, 0);
  glVertex3f (0, 0, 0);

  glMultiTexCoord2fARB_local (GL_TEXTURE1_ARB, 1, 0);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, 1, 0);
  glVertex3f (1, 0, 0);

  glEnd ();

  glDepthMask (GL_TRUE);


  switch (choix_courant)
    {
    case MENU_EXIT:
    case MENU_JEU_CREERSERVEUR:
    case MENU_JEU_JOINDRESERVEUR:
    case MENU_CONTROLE:
    case MENU_OPTION:
    case MENU_CREDITS:
      affiche_dynamique ("CREER LE SERVEUR", 1, MENU_JEU_CREERSERVEUR);
      affiche_dynamique ("JOINDRE LE SERVEUR", 2, MENU_JEU_JOINDRESERVEUR);
      affiche_dynamique ("CONTROLES", 3, MENU_CONTROLE);
      affiche_dynamique ("OPTIONS", 4, MENU_OPTION);
      affiche_dynamique ("CREDITS", 5, MENU_CREDITS);
      affiche_dynamique ("QUITTER", 6, MENU_EXIT);
      break;

    case MENU_SERVEUR:
    case MENU_PORT:
    case MENU_GO:
    case MENU_2BACK:
      affiche_dynamique2 ("SERVEUR", nom_machine, 1, MENU_SERVEUR);
      affiche_dynamique2 ("PORT", port, 2, MENU_PORT);
      affiche_dynamique ("GO GO GO ! ", 3, MENU_GO);
      affiche_dynamique ("RETOUR", 4, MENU_2BACK);
      break;

    case MENU_CARTE:
    case MENU_MODE:
    case MENU_MOUVEMENT:
    case MENU_MAX_JOUEUR:
    case MENU_CREER:
    case MENU_1BACK:
      {
	MOT nom_niv = info_niveau.nom_niveau;
	nom_niv.upper ();
	affiche_dynamique2 ("CARTE:", nom_niv, 1, MENU_CARTE);
	affiche_dynamique2 ("MODE", nom_mode, 2, MENU_MODE);
	affiche_dynamique2 ("MOUVEMENT", nom_mouvement, 3, MENU_MOUVEMENT);
	affiche_dynamique ("MAXIMUM DE JOUEURS", 4, MENU_MAX_JOUEUR);
	affiche_dynamique ("CREER !", 5, MENU_CREER);
	affiche_dynamique ("RETOUR", 6, MENU_1BACK);

	for (int i = 0; i < info_niveau.info.size (); i++)
	  affiche_dynamique3 (info_niveau.info[i], 10 + i, -10);
      }
      break;

    case MENU_SKIN:
    case MENU_NOM:
    case MENU_FULLSCREEN:
    case MENU_RESOLUTION:
    case MENU_LUMIERE_SOFT:
    case MENU_4BACK:
      {
	affiche_dynamique ("< SKIN >", 1, MENU_SKIN);
	affiche_dynamique2 ("NOM", nom_joueur, 2, MENU_NOM);
	MOT full ("NON");
	if (lpblocinfo->blocecran.fullscreen)
	  full = MOT ("OUI");
	affiche_dynamique2 ("PLEIN ECRAN", full, 3, MENU_FULLSCREEN);
	MOT res ("PROBLEME!");
	switch (lpblocinfo->blocecran.resolution)
	  {
	  case RESOLUTION_320_240:
	    res = MOT ("320-240");
	    break;
	  case RESOLUTION_640_480:
	    res = MOT ("640-480");
	    break;
	  case RESOLUTION_800_600:
	    res = MOT ("800-600");
	    break;
	  case RESOLUTION_1024_768:
	    res = MOT ("1024-768");
	    break;
	  }
	affiche_dynamique2 ("RESOLUTION", res, 4, MENU_RESOLUTION);
	MOT tl ("SANS");
	switch (lpblocinfo->blocecran.lumiere)
	  {
	  case TypeLumiereSansLumiere:
	    tl = MOT ("AUCUNE");
	    break;
	  case TypeLumiereVertex:
	    tl = MOT ("VERTEX");
	    break;
	  case TypeLumiereComplete:
	    tl = MOT ("COMPLETE");
	    break;
	  }
	affiche_dynamique2 ("LUMIERE SOFT", tl, 5, MENU_LUMIERE_SOFT);
	affiche_dynamique ("RETOUR", 6, MENU_4BACK);

	// Afficher un joli joueur a cote pour choisir la skin...
	MATRIX t, t2, t3, t4, t5;
	t.translation (RWVECTOR (2, -0.5, -4).T_VECTOR ());
	t2.rotationx (3.14 / 2);
	t4.rotationy (3.14);
	t5.rotationz (anime_affiche / 4);
	t3 = t * t2 * t4 * t5;

	BLOCINFO blocinfo = *lpblocinfo;
	blocinfo.T = 0.1;
	lpjoueur->init_animation ();

	MOT anim_final ("FINAL");
	lpjoueur->applique_animation (&anim_final, &blocinfo);

	MOT anim ("LUMIERE");
	blocinfo.T = anime_affiche / 5;
	while (blocinfo.T > 2.0)
	  blocinfo.T -= 2.0;
	lpjoueur->applique_animation (&anim, &blocinfo);

	lpjoueur->fin_animation (&blocinfo, &t3);

	DESCRIPTEUR_TEXTURE desc;
	desc.nom = MOT (liste_skin[skin_num]);
	desc.blend_type = 0;
	desc.blend = 0;
	skin_dessin =
	  blocinfo.lpbanque_texture->trouve_texture (&desc, blocinfo.lpbdd);
	lpjoueur->set_texture_animation (skin_dessin);

	lpjoueur->trace_animation (&blocinfo);

      }

      break;

    case MENU_AVANCE:
    case MENU_RECULE:
    case MENU_STRAFE_GAUCHE:
    case MENU_STRAFE_DROITE:
    case MENU_TIR:
    case MENU_SAUTE:
    case MENU_ARME1:
    case MENU_ARME2:
    case MENU_ARME3:
    case MENU_ARME4:
    case MENU_ARME5:
    case MENU_ARME6:
    case MENU_ARME7:
    case MENU_ARME8:
    case MENU_ARME9:
    case MENU_ARME10:
    case MENU_VUE:
    case MENU_TEXTE:
    case MENU_ACTION:
    case MENU_SENSIBILITE:
    case MENU_SOURISINVERSE:
    case MENU_RETOURMENU:
    case MENU_3BACK:
      {
	int decale = choix_courant - 4 - MENU_AVANCE;
	if (decale < 0)
	  decale = 0;
	if (decale > 22 - 8)
	  decale = 22 - 8;
	//printf("Test ---------\n");
	for (int i = 1; i != 10; i++)
	  {
	    int affiche = i + decale;
	    //printf("Test %i %i\n",i,affiche);
	    char buff_sensib[10];
	    sprintf (buff_sensib, "%f",
		     lpblocinfo->lpcontrole->get_sensibilite ());
	    char buff_inv[10];
	    if (lpblocinfo->lpcontrole->get_inverse ())
	      sprintf (buff_inv, "OUI");
	    else
	      sprintf (buff_inv, "NON");
	    switch (affiche - 1)
	      {
	      case 0:
		affiche_dynamique2 ("AVANCE",
				    lpblocinfo->lpcontrole->get_avance (), i,
				    MENU_AVANCE);
		break;
	      case 1:
		affiche_dynamique2 ("RECULE",
				    lpblocinfo->lpcontrole->get_recule (), i,
				    MENU_RECULE);
		break;
	      case 2:
		affiche_dynamique2 ("PAS CHASSE GAUCHE",
				    lpblocinfo->lpcontrole->
				    get_strafe_gauche (), i,
				    MENU_STRAFE_GAUCHE);
		break;
	      case 3:
		affiche_dynamique2 ("PAS CHASSE DROITE",
				    lpblocinfo->lpcontrole->
				    get_strafe_droite (), i,
				    MENU_STRAFE_DROITE);
		break;
	      case 4:
		affiche_dynamique2 ("TIR", lpblocinfo->lpcontrole->get_tir (),
				    i, MENU_TIR);
		break;
	      case 5:
		affiche_dynamique2 ("SAUTE",
				    lpblocinfo->lpcontrole->get_saute (), i,
				    MENU_SAUTE);
		break;
	      case 6:
		affiche_dynamique2 ("POING",
				    lpblocinfo->lpcontrole->get_arme (0), i,
				    MENU_ARME1);
		break;
	      case 7:
		affiche_dynamique2 ("GATLING",
				    lpblocinfo->lpcontrole->get_arme (1), i,
				    MENU_ARME2);
		break;
	      case 8:
		affiche_dynamique2 ("TROMBLON",
				    lpblocinfo->lpcontrole->get_arme (2), i,
				    MENU_ARME3);
		break;
	      case 9:
		affiche_dynamique2 ("MEGA GATLING",
				    lpblocinfo->lpcontrole->get_arme (3), i,
				    MENU_ARME4);
		break;
	      case 10:
		affiche_dynamique2 ("LANCE MINE",
				    lpblocinfo->lpcontrole->get_arme (4), i,
				    MENU_ARME5);
		break;
	      case 11:
		affiche_dynamique2 ("LANCE ROQUETTE",
				    lpblocinfo->lpcontrole->get_arme (5), i,
				    MENU_ARME6);
		break;
	      case 12:
		affiche_dynamique2 ("PLASMA",
				    lpblocinfo->lpcontrole->get_arme (6), i,
				    MENU_ARME7);
		break;
	      case 13:
		affiche_dynamique2 ("ALIEN1",
				    lpblocinfo->lpcontrole->get_arme (7), i,
				    MENU_ARME8);
		break;
	      case 14:
		affiche_dynamique2 ("ALIEN2",
				    lpblocinfo->lpcontrole->get_arme (8), i,
				    MENU_ARME9);
		break;
	      case 15:
		affiche_dynamique2 ("ALIEN3",
				    lpblocinfo->lpcontrole->get_arme (9), i,
				    MENU_ARME10);
		break;
	      case 16:
		affiche_dynamique2 ("VUE", lpblocinfo->lpcontrole->get_vue (),
				    i, MENU_VUE);
		break;
	      case 17:
		affiche_dynamique2 ("TEXTE",
				    lpblocinfo->lpcontrole->get_texte (), i,
				    MENU_TEXTE);
		break;
	      case 18:
		affiche_dynamique2 ("ACTION",
				    lpblocinfo->lpcontrole->get_action (), i,
				    MENU_ACTION);
		break;
	      case 19:
		affiche_dynamique2 ("TOUCHERETOUR",
				    lpblocinfo->lpcontrole->get_action (), i,
				    MENU_RETOURMENU);
		break;
	      case 20:
		affiche_dynamique2 ("SENSIBILITE SOURIS", buff_sensib, i,
				    MENU_SENSIBILITE);
		break;
	      case 21:
		affiche_dynamique2 ("INVERSE SOURIS", buff_inv, i,
				    MENU_SOURISINVERSE);
		break;
	      case 22:
		affiche_dynamique ("RETOUR", i, MENU_3BACK);
		break;
	      }
	  }
      }
      break;

    case MENU_5BACK:
      affiche_dynamique3 ("CONCEPT     : ATILA ", -5, -5);
      affiche_dynamique3 ("CODE        : ATILA", -3, -5);
      affiche_dynamique3 ("              RZR", -2, -5);
      affiche_dynamique3 ("ART/3D      : ATILA", 0, -5);
      affiche_dynamique3 ("              GODSLAYER", 1, -5);
      affiche_dynamique3 ("PAQUETAGE   : RZR", 3, -5);
      affiche_dynamique3 ("              GODSLAYER", 4, -5);
      affiche_dynamique3 ("(SKINS DE QUAKE WORLD)", 6, -5);

      affiche_dynamique ("RETOUR", 7, MENU_5BACK);
      break;

    }
  lpblocinfo->lpmoteur->fin_affiche (lpblocinfo);
  MOT cible ("d_commun/d_ecran/crossair.pcx");
  lpblocinfo->lpmoteur->affiche_cible (cible, lpblocinfo, mouse_x, mouse_y);

  lpblocinfo->lpmoteur->swap_end ();
}

bool
MENU::gestion_courante ()
{
  affiche_courant ();
  float old_mouse_x = mouse_x;
  float old_mouse_y = mouse_y;
  mouse_x = lpblocinfo->lpcontrole->get_raw_x_view () / 500;
  mouse_y = lpblocinfo->lpcontrole->get_raw_y_view () / 500;
  if (mouse_x >= 0.5)
    mouse_x = 0.5;
  if (mouse_y >= 0.5)
    mouse_y = 0.5;
  if (mouse_x <= -0.5)
    mouse_x = -0.5;
  if (mouse_y <= -0.3)
    mouse_y = -0.3;
  bool souris_bouge = false;
  if ((old_mouse_x != mouse_x) || (old_mouse_y != mouse_y))
    souris_bouge = true;
  int choix_souris = int ((-mouse_y - 0.01) * 41) + 2;

  int ancien_choix_courant = choix_courant;
  switch (choix_courant)
    {
    case MENU_EXIT_FINAL:
      write_options ();
      return true;
      break;
    case MENU_EXIT:
    case MENU_JEU_CREERSERVEUR:
    case MENU_JEU_JOINDRESERVEUR:
    case MENU_CONTROLE:
    case MENU_OPTION:
    case MENU_CREDITS:
      if (souris_bouge)
	{
	  int choix_bis = choix_souris + MENU_JEU_CREERSERVEUR;
	  if ((choix_bis <= MENU_EXIT)
	      && (choix_bis >= MENU_JEU_CREERSERVEUR))
	    choix_courant = choix_bis;
	};

      if (lpblocinfo->lpcontrole->haut ())
	choix_courant--;
      if (lpblocinfo->lpcontrole->bas ())
	choix_courant++;
      if (choix_courant > MENU_EXIT)
	choix_courant = MENU_JEU_CREERSERVEUR;
      if (choix_courant < MENU_JEU_CREERSERVEUR)
	choix_courant = MENU_EXIT;
      if (lpblocinfo->lpcontrole->entree ())
	{
	  switch (choix_courant)
	    {
	    case MENU_EXIT:
	      choix_courant = MENU_EXIT_FINAL;
	      break;
	    case MENU_JEU_CREERSERVEUR:
	      choix_courant = MENU_CARTE;
	      break;
	    case MENU_JEU_JOINDRESERVEUR:
	      choix_courant = MENU_SERVEUR;
	      break;
	    case MENU_CONTROLE:
	      choix_courant = MENU_AVANCE;
	      break;
	    case MENU_OPTION:
	      choix_courant = MENU_SKIN;
	      break;
	    case MENU_CREDITS:
	      choix_courant = MENU_5BACK;
	      break;
	    }
	};
      break;

    case MENU_SERVEUR:
    case MENU_PORT:
    case MENU_GO:
    case MENU_2BACK:
      if (souris_bouge)
	{
	  int choix_bis = choix_souris + MENU_SERVEUR;
	  if ((choix_bis <= MENU_2BACK) && (choix_bis >= MENU_SERVEUR))
	    choix_courant = choix_bis;
	};
      if (lpblocinfo->lpcontrole->haut ())
	choix_courant--;
      if (lpblocinfo->lpcontrole->bas ())
	choix_courant++;
      if (choix_courant > MENU_2BACK)
	choix_courant = MENU_SERVEUR;
      if (choix_courant < MENU_SERVEUR)
	choix_courant = MENU_2BACK;

      if (choix_courant == MENU_PORT)
	test_chaine (false, true, &port);
      if (choix_courant == MENU_SERVEUR)
	test_chaine (true, true, &nom_machine);


      if (lpblocinfo->lpcontrole->entree ())
	{
	  if (choix_courant == MENU_2BACK)
	    choix_courant = 2;
	  if (choix_courant == MENU_GO)
	    {
	      lpblocinfo->lpmixer->termine_son (cb_musique);
	      write_options ();
	      return true;
	    }
	};
      break;

    case MENU_CARTE:
    case MENU_MODE:
    case MENU_MOUVEMENT:
    case MENU_MAX_JOUEUR:
    case MENU_CREER:
    case MENU_1BACK:
      {
	if (souris_bouge)
	  {
	    int choix_bis = choix_souris + MENU_CARTE;
	    if ((choix_bis <= MENU_1BACK) && (choix_bis >= MENU_CARTE))
	      choix_courant = choix_bis;
	  };
	if (lpblocinfo->lpcontrole->haut ())
	  choix_courant--;
	if ((lpblocinfo->lpcontrole->bas ()))
	  choix_courant++;
	if (choix_courant > MENU_1BACK)
	  choix_courant = MENU_CARTE;
	if (choix_courant < MENU_CARTE)
	  choix_courant = MENU_1BACK;
	if (lpblocinfo->lpcontrole->entree ())
	  {
	    if (choix_courant == MENU_1BACK)
	      choix_courant = 1;
	    if (choix_courant == MENU_MODE)
	      {
		switch (lpblocinfo->mode_jeu)
		  {
		  case MODE_JEU_CALCUL:
		    lpblocinfo->mode_jeu = MODE_JEU_ARCADE;
		    break;
		  case MODE_JEU_CLAVIER:
		    lpblocinfo->mode_jeu = MODE_JEU_CALCUL;
		    break;
		  case MODE_JEU_ARCADE:
		    lpblocinfo->mode_jeu = MODE_JEU_CLAVIER;
		    break;
		  }
		update_nom_mode ();
	      };
	    if (choix_courant == MENU_MOUVEMENT)
	      {
		if (lpblocinfo->mode_mouvement == MODE_MOUVEMENT_CONTRAINT)
		  {
		    lpblocinfo->mode_mouvement = MODE_MOUVEMENT_LIBRE;
		  }
		else
		  {
		    lpblocinfo->mode_mouvement = MODE_MOUVEMENT_CONTRAINT;
		  }
		update_nom_mode ();
	      };
	    if (choix_courant == MENU_CREER)
	      {
		lpblocinfo->lpmixer->termine_son (cb_musique);
		write_options ();
		return true;
	      }
	  };
	int niv2 = niveau_num;
	if ((lpblocinfo->lpcontrole->gauche ()
	     || (lpblocinfo->lpcontrole->entree ()))
	    && (choix_courant == MENU_CARTE))
	  niveau_num++;
	if ((lpblocinfo->lpcontrole->droite ())
	    && (choix_courant == MENU_CARTE))
	  niveau_num--;
	if (niveau_num < 0)
	  niveau_num = liste_niveau.size () - 1;
	if (niveau_num > liste_niveau.size () - 1)
	  niveau_num = 0;
	if (niv2 != niveau_num)
	  get_info_niveau ();
      }
      break;

    case MENU_AVANCE:
    case MENU_RECULE:
    case MENU_STRAFE_GAUCHE:
    case MENU_STRAFE_DROITE:
    case MENU_TIR:
    case MENU_SAUTE:
    case MENU_ARME1:
    case MENU_ARME2:
    case MENU_ARME3:
    case MENU_ARME4:
    case MENU_ARME5:
    case MENU_ARME6:
    case MENU_ARME7:
    case MENU_ARME8:
    case MENU_ARME9:
    case MENU_ARME10:
    case MENU_VUE:
    case MENU_TEXTE:
    case MENU_ACTION:
    case MENU_SENSIBILITE:
    case MENU_SOURISINVERSE:
    case MENU_RETOURMENU:
    case MENU_3BACK:
      if (edit_mode)
	{
	  int touche;
	  if (lpblocinfo->lpcontrole->getControleActif (touche))
	    {
	      switch (choix_courant)
		{
		case MENU_AVANCE:
		  lpblocinfo->lpcontrole->set_avance (touche);
		  break;
		case MENU_RECULE:
		  lpblocinfo->lpcontrole->set_recule (touche);
		  break;
		case MENU_STRAFE_GAUCHE:
		  lpblocinfo->lpcontrole->set_strafe_gauche (touche);
		  break;
		case MENU_STRAFE_DROITE:
		  lpblocinfo->lpcontrole->set_strafe_droite (touche);
		  break;
		case MENU_TIR:
		  lpblocinfo->lpcontrole->set_tir (touche);
		  break;
		case MENU_SAUTE:
		  lpblocinfo->lpcontrole->set_saute (touche);
		  break;
		case MENU_ARME1:
		case MENU_ARME2:
		case MENU_ARME3:
		case MENU_ARME4:
		case MENU_ARME5:
		case MENU_ARME6:
		case MENU_ARME7:
		case MENU_ARME8:
		case MENU_ARME9:
		case MENU_ARME10:
		  lpblocinfo->lpcontrole->set_arme (choix_courant -
						    MENU_ARME1, touche);
		  break;
		case MENU_VUE:
		  lpblocinfo->lpcontrole->set_vue (touche);
		  break;
		case MENU_TEXTE:
		  lpblocinfo->lpcontrole->set_texte (touche);
		  break;
		case MENU_ACTION:
		  lpblocinfo->lpcontrole->set_action (touche);
		  break;
		case MENU_RETOURMENU:
		  lpblocinfo->lpcontrole->set_action (touche);
		  break;
		};
	      edit_mode = false;
	    };
	}
      else
	{
	  if (lpblocinfo->lpcontrole->haut ())
	    choix_courant--;
	  if (lpblocinfo->lpcontrole->bas ())
	    choix_courant++;
	  if (choix_courant > MENU_3BACK)
	    choix_courant = MENU_AVANCE;
	  if (choix_courant < MENU_AVANCE)
	    choix_courant = MENU_3BACK;
	  if (lpblocinfo->lpcontrole->entree ())
	    {
	      if (choix_courant == MENU_3BACK)
		choix_courant = 3;
	      if (choix_courant == MENU_SOURISINVERSE)
		lpblocinfo->lpcontrole->set_inverse (!lpblocinfo->lpcontrole->
						     get_inverse ());
	      if ((choix_courant <= MENU_RETOURMENU)
		  && (choix_courant >= MENU_AVANCE))
		edit_mode = true;
	    }
	  if (lpblocinfo->lpcontrole->gauche ())
	    {
	      if (choix_courant == MENU_SENSIBILITE)
		lpblocinfo->lpcontrole->set_sensibilite (lpblocinfo->
							 lpcontrole->
							 get_sensibilite () /
							 1.1);
	    }
	  if (lpblocinfo->lpcontrole->droite ())
	    {
	      if (choix_courant == MENU_SENSIBILITE)
		lpblocinfo->lpcontrole->set_sensibilite (lpblocinfo->
							 lpcontrole->
							 get_sensibilite () *
							 1.1);
	    }
	};
      break;

    case MENU_SKIN:
    case MENU_NOM:
    case MENU_FULLSCREEN:
    case MENU_RESOLUTION:
    case MENU_LUMIERE_SOFT:
    case MENU_4BACK:
      if (souris_bouge)
	{
	  int choix_bis = choix_souris + MENU_SKIN;
	  if ((choix_bis <= MENU_4BACK) && (choix_bis >= MENU_SKIN))
	    choix_courant = choix_bis;
	};
      if (lpblocinfo->lpcontrole->haut ())
	choix_courant--;
      if (lpblocinfo->lpcontrole->bas ())
	choix_courant++;
      if (choix_courant > MENU_4BACK)
	choix_courant = MENU_SKIN;
      if (choix_courant < MENU_SKIN)
	choix_courant = MENU_4BACK;
      if (lpblocinfo->lpcontrole->entree ())
	{
	  if (choix_courant == MENU_4BACK)
	    choix_courant = 4;
	  if (choix_courant == MENU_FULLSCREEN)
	    {
	      lpblocinfo->blocecran.fullscreen =
		!lpblocinfo->blocecran.fullscreen;
	      init_video (lpblocinfo->blocecran.fullscreen,
			  lpblocinfo->blocecran.resolution);
	    };
	  if (choix_courant == MENU_RESOLUTION)
	    {
	      lpblocinfo->blocecran.resolution++;
	      if (lpblocinfo->blocecran.resolution > RESOLUTION_1024_768)
		lpblocinfo->blocecran.resolution = RESOLUTION_320_240;
	      init_video (lpblocinfo->blocecran.fullscreen,
			  lpblocinfo->blocecran.resolution);
	    };
	  if (choix_courant == MENU_LUMIERE_SOFT)
	    {
	      lpblocinfo->blocecran.lumiere =
		(TypeLumiere) ((int) lpblocinfo->blocecran.lumiere + 1);
	      if (lpblocinfo->blocecran.lumiere > TypeLumiereComplete)
		lpblocinfo->blocecran.lumiere = TypeLumiereSansLumiere;
	    };
	};
      if (choix_courant == MENU_NOM)
	test_chaine (true, true, &nom_joueur);
      if ((lpblocinfo->lpcontrole->gauche ())
	  || (lpblocinfo->lpcontrole->entree ()))
	if (choix_courant == MENU_SKIN)
	  skin_num++;
      if ((lpblocinfo->lpcontrole->droite ()) && (choix_courant == MENU_SKIN))
	skin_num--;
      if (skin_num < 0)
	skin_num = liste_skin.size () - 1;
      if (skin_num > liste_skin.size () - 1)
	skin_num = 0;
      break;

    case MENU_5BACK:
      if (lpblocinfo->lpcontrole->entree ())
	choix_courant = 5;
      break;

    };
  if (choix_courant != ancien_choix_courant)
    {
      char buffer[100];
      sprintf (buffer, "d_commun/d_menu/menu%i.ogg", rand () % 9 + 1);
      MOT son (buffer);
      if (choix_courant / 10 != ancien_choix_courant / 10)
	{
	  son = MOT ("d_commun/d_menu/menu10.ogg");
	};
      lpblocinfo->lpmixer->lance_son (son, -1);
    }
  lpblocinfo->lpcontrole->gestion_globale ();
  if (lpblocinfo->lpmixer)
    lpblocinfo->lpmixer->gestion ();
  if (lpblocinfo->lpmixer->fin_son (cb_musique))
    {
      MOT musique ("d_commun/d_menu/intro.ogg");
      cb_musique = lpblocinfo->lpmixer->lance_son (musique, -1);
    }
  return false;
}

bool
MENU::quit ()
{
  return (choix_courant == MENU_EXIT_FINAL);
}

void
MENU::info (MOT & nom, MOT & skin)
{
  nom = nom_joueur;
  skin = liste_skin[skin_num];
  return;
}

bool
MENU::jeu_local (MOT & carte, int &maxj)
{
  carte = liste_niveau[niveau_num];
  //maxj=
  return (choix_courant == MENU_CREER);
}

bool
MENU::jeu_distant (MOT & serveur, int &p)
{
  p = atoi (port.info);
  serveur = nom_machine;
  return (choix_courant == MENU_GO);
}
