/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: menu.h,v 1.3 2006/12/21 18:18:14 atila Exp $

#ifndef FICHIER_MENU_H
#define FICHIER_MENU_H


#include "controle.h"
#include "affiche_texte.h"
#include "animation.h"
#include "niveau.h"
#include "snd_mixer.h"

#define MENU_JEU_CREERSERVEUR	1
#define MENU_JEU_JOINDRESERVEUR	2
#define MENU_CONTROLE		3
#define MENU_OPTION		4
#define MENU_CREDITS		5
#define MENU_EXIT		6

#define MENU_SERVEUR		21
#define MENU_PORT 		22
#define MENU_GO 		23
#define MENU_2BACK		24

#define MENU_CARTE		11
#define MENU_MODE		12
#define MENU_MOUVEMENT		13
#define MENU_MAX_JOUEUR		14
#define MENU_CREER		15
#define MENU_1BACK		16

#define MENU_AVANCE		31
#define MENU_RECULE		32
#define MENU_STRAFE_GAUCHE	33
#define MENU_STRAFE_DROITE	34
#define MENU_TIR		35
#define MENU_SAUTE		36
#define MENU_ARME1		37
#define MENU_ARME2		38
#define MENU_ARME3		39
#define MENU_ARME4		40
#define MENU_ARME5		41
#define MENU_ARME6		42
#define MENU_ARME7		43
#define MENU_ARME8		44
#define MENU_ARME9		45
#define MENU_ARME10		46
#define MENU_VUE		47
#define MENU_TEXTE		48
#define MENU_ACTION		49
#define MENU_RETOURMENU		50
#define MENU_SENSIBILITE	51
#define MENU_SOURISINVERSE	52
#define MENU_3BACK		53

#define MENU_SKIN		101
#define MENU_NOM		102
#define MENU_FULLSCREEN		103
#define MENU_RESOLUTION         104
#define MENU_LUMIERE_SOFT  	105
#define MENU_4BACK		106

#define MENU_5BACK		111

#define MENU_EXIT_FINAL		1000


class MENU
{
  float mouse_x, mouse_y;

  int choix_courant;
  float anime_affiche;
  GLuint dessin;

  MOT nom_joueur;
  MOT nom_machine;
  MOT port;
  MOT nom_mode;
  MOT nom_mouvement;

  INFO_NIVEAU info_niveau;

  void affiche_courant ();
  void affiche_dynamique (char *texte, int position, int numero);
  void affiche_dynamique2 (char *texte, MOT m, int position, int numero);
  void affiche_dynamique3 (MOT m, int px, int py);

  void test_chaine (bool carac, bool chiffre, MOT * m);

  void get_info_niveau ();

  void write_options ();
  void read_options ();

  void update_nom_mode ();

  LPBLOCINFO lpblocinfo;
  LPANIMATION lpjoueur;

  LISTE_NOM liste_skin;
  int skin_num;
  GLuint skin_dessin;

  LISTE_NOM liste_niveau;
  int niveau_num;

  int cb_musique;

  // Est-on dans le mode d'dition des touches ?
  bool edit_mode;

public:  bool gestion_courante ();

    MENU (LPBLOCINFO lpb);
   ~MENU ();

  // Pour savoir l'état dans lequel on se trouve.
  bool quit ();
  void info (MOT & nom, MOT & skin);
  bool jeu_local (MOT & carte, int &maxj);
  bool jeu_distant (MOT & serveur, int &port);

  // Réinitialisation : positionner l'état courant.
  void init ();
};

#endif
