/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#define GL_GLEXT_PROTOTYPES

#include "lecture.h"
#include "win3d.h"
#include "GL/gl.h"
#include "moteur3d.h"
#include "SDL/SDL.h"
#include "local_glu.h"
#include "animation.h"

extern int width, height;

void
ecran_cone ()
{
  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  gluPerspective (60.0, (GLfloat) width / (GLfloat) height, 0.01, 300.0);
  glMatrixMode (GL_MODELVIEW);
  glLoadIdentity ();

  glDepthMask (GL_FALSE);
  glDisable (GL_DEPTH_TEST);
  glMatrixMode (GL_MODELVIEW);
  glTranslatef (-0.5, .4, -.65);
}

void
MOTEUR::switch_mode_clip (bool s)
{
  mode_clip = s;
}

void
MOTEUR::init_affichage (LPBLOCINFO lpblocinfo,
			RWVECTOR position,
			float Oz, float Ox, float hauteur_vue)
{
  init_affichage (lpblocinfo,
		  position,
		  RWVECTOR (0, 0, 0), RWVECTOR (0, 0, 0),
		  Oz, Ox, hauteur_vue);
};

void
MOTEUR::init_affichage (LPBLOCINFO lpblocinfo,
			RWVECTOR position,
			RWVECTOR decal, RWVECTOR rot_decal,
			float Oz, float Ox, float hauteur_vue)
{
  objet_horsmoteur.clear ();
  mode_clip = true;
  if (lpblocinfo->client)
    {
      unsigned int desc;
      MOT nom = MOT ("d_commun/d_objet3d/halo.ani");
      LPANIMATION_TEXTURE lpanimation_texture =
	lpblocinfo->
	lpbanque_animation_texture->
	trouve_animation_texture_brutal (lpblocinfo,
					 nom);
      desc = 1;
      BLOCINFO bi = *lpblocinfo;
      MATRIX m;
      bi.T = 0;
      bi.LT = 0;
      lpanimation_texture->gestion_locale (&bi, m, desc);
      desc_image_lumiere = desc;
      lpblocinfo->texture_halo = desc_image_lumiere;

      if (dessin_degat == 0)
	{
	  DESCRIPTEUR_TEXTURE dt;
	  dt.nom = MOT ("d_commun/d_ecran/sang.pcx");
	  dt.blend_type = 2;
	  dessin_degat =
	    lpblocinfo->lpbanque_texture->trouve_texture (&dt,
							  lpblocinfo->lpbdd);
	  if (!dessin_degat)
	    dessin_degat = 1;
	}
      if (dessin_mort == 0)
	{
	  DESCRIPTEUR_TEXTURE dt;
	  dt.nom = MOT ("d_commun/d_ecran/gameover.pcx");
	  dt.blend_type = 2;
	  dessin_mort =
	    lpblocinfo->lpbanque_texture->trouve_texture (&dt,
							  lpblocinfo->lpbdd);
	  if (!dessin_mort)
	    dessin_mort = 1;
	}
      if (dessin_gagne == 0)
	{
	  DESCRIPTEUR_TEXTURE dt;
	  dt.nom = MOT ("d_commun/d_ecran/gagnant.pcx");
	  dt.blend_type = 2;
	  dessin_gagne =
	    lpblocinfo->lpbanque_texture->trouve_texture (&dt,
							  lpblocinfo->lpbdd);
	  if (!dessin_gagne)
	    dessin_gagne = 1;
	}
    }

  // Construction de la matrice, etc...

  float rotx = 0;
  float roty = 0;
  float rotxp = 0;
  RWVECTOR x (1, 0, 0);
  if (lpblocinfo->blocoption.typeVue == TypeVueInterne)
    {
      rotx = Ox + rot_decal.x ();
      roty = Oz + rot_decal.y ();
    };
  if (lpblocinfo->blocoption.typeVue == TypeVueExterneDos)
    {
      rotx = Ox;
      roty = Oz;
    }
  MATRIX tr, tr2, tr3, tr4;
  tr.rotationy (-rotx + 3.14 / 2);
  tr2.rotationx (roty);
  tr3.rotationz (rot_decal.z ());
  tr4.rotationx (-3.14 / 2);

  positionnement_relatif = tr3 * tr2 * tr * tr4;
  positionnement_relatif_inverse = positionnement_relatif.inverse ();

  position_camera = position;
  switch (lpblocinfo->blocoption.typeVue)
    {
    case TypeVueExterneDos:
      {
	RWVECTOR aff (positionnement_relatif_inverse.
		      transforme (RWVECTOR (0, 0, -1)));
	position_camera =
	  position_camera + (aff * (-lpblocinfo->blocoption.vueDistance)) +
	  RWVECTOR (0, 0, hauteur_vue);
      }
      break;
    case TypeVueExterneFixe:
      {
	RWVECTOR position_vue (0, 0, 1);
	position_camera = position_camera +
	  positionnement_relatif_inverse.transforme (position_vue) *
	  (lpblocinfo->blocoption.vueDistance) + RWVECTOR (0, 0, hauteur_vue);
      }
      break;
    case TypeVueInterne:
      {
	position_camera =
	  position_camera + RWVECTOR (0, 0,
				      hauteur_vue) +
	  positionnement_relatif_inverse.transforme (decal);
      }
      break;
    }

  glMatrixMode (GL_MODELVIEW);
  glLoadIdentity ();

  position_camera = position_camera * (-1.0);
  MATRIX tr_translation;
  tr_translation.translation (position_camera);
  positionnement_absolu = tr_translation * positionnement_relatif;

  // Si il s'agit d'une position contrainte...
  /*
     //if (lpblocinfo->mode_jeu!=0)
     {
     printf("Contrainte \n");
     positionnement_absolu=lpblocinfo->position_camera;
     positionnement_absolu.imprime_test();

     position_camera=lpblocinfo->position_camera.extrait_origine()*(-1);
     tr_translation=MATRIX();
     tr_translation.translation(position_camera);

     positionnement_relatif=tr_translation * positionnement_absolu;
     positionnement_relatif_inverse=positionnement_relatif.inverse ();

     tr_translation.translation (position_camera);
     positionnement_absolu = tr_translation * positionnement_relatif;
     }
   */
  glMatrixMode (GL_PROJECTION);
  glLoadIdentity ();
  gluPerspective (60.0, (GLfloat) width / (GLfloat) height, 0.01, 50.0);
  MATRIX m2 = positionnement_relatif.special_OpenGL ();

  glMultMatrixf ((const GLfloat *) &m2);
  glTranslatef (position_camera.x (), position_camera.y (),
		position_camera.z ());

  positionnement_absolu_inverse = positionnement_absolu.inverse ();


  glMatrixMode (GL_MODELVIEW);
  glDepthMask (GL_TRUE);
  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glHint (GL_POLYGON_SMOOTH_HINT, GL_FASTEST);
  glHint (GL_LINE_SMOOTH_HINT, GL_FASTEST);
  glHint (GL_FOG_HINT, GL_FASTEST);

  glDisable (GL_FOG);

  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		   GL_LINEAR_MIPMAP_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

  glDepthMask (GL_TRUE);
  glEnable (GL_DEPTH_TEST);
  glDepthFunc (GL_LEQUAL);

  position_camera_standard = position_camera * (-1);
  positionnement_camera =
    tr_translation.inverse () * positionnement_relatif_inverse;
}

void
MOTEUR::update_facette_portal (OBJET_PORTAL & op)
{
//printf("    TRAITEMENT PORTAL SALLE %s \n",op.nom_objet.info);
  for (int i = 0; i != op.liste_portal.size (); i++)
    {
      // Mise  jour de chaque objet en connexion avec celui-ci.
      // Si la facette de vue n'est pas visible
      // (ou pas dans le bon sens), on ne visite pas l'objet.
      PORTAL & p = op.liste_portal[i];
      if (p.lpobjet)
	{
	  LPFACETTE_PORTAL & fp = p.facette_portal;
	  // Creer et mettre  jour si necessaire
	  //printf("      Une facette portal %s -> %s\n",op.nom_objet.info,p.nom_objet.info);
	  if (!fp)
	    {
	      fp = new FACETTE_PORTAL (p.facette);
	      fp->calcule_trame (op.objet->repere_global,
				 position_camera_standard);
	    }

	  // Regarder si elle est dans le "bon sens".
	  if (fp->sens (position_camera_standard))
	    {
	      //printf("         Bon sens %s -> %s\n",op.nom_objet.info,p.nom_objet.info);
	      LPFACETTE_PORTAL facette_portal_trans = fp->copie ();
	      facette_portal_trans->MAJ_plan (position_camera_standard);
	      // Tronquer par notre portal courant (op)
	      facette_portal_trans->tronquer (op.facette_contenant);
	      // Mettre a jour.
	      facette_portal_trans->MAJ_plan (position_camera_standard);
	      // Si elle existe encore, ajouter l'espace visible a son conteneur,
	      // reiterer sur le portal conteneur recursivement.
	      if (facette_portal_trans->existe ())
		{
		  OBJET_PORTAL & op_cible = liste_objet_portal[p.num];
		  if (op_cible.facette_contenant)
		    {
		      //printf("         Extension du conteneur\n");
		      op_cible.facette_contenant->
			ajoute (facette_portal_trans);
		      op_cible.facette_contenant->
			MAJ_plan (position_camera_standard);
		    }
		  else
		    {
		      // sinon creer le conteneur, avec la facette_trans comme valeur.
		      //printf("         Creation du conteneur\n");
		      op_cible.facette_contenant =
			facette_portal_trans->copie ();
		    }
		  update_facette_portal (op_cible);
		}
	      delete facette_portal_trans;
	    };

	}
    }
//printf("    FIN TRAITEMENT PORTAL SALLE %s \n",op.nom_objet.info);
}

void
MOTEUR::insertion_indice (LISTE_INDICE_PORTAL & lip, int i)
{
  LISTE_INDICE_PORTAL::iterator position = lip.begin ();
  int lip_size = lip.size ();
  while (position != lip.end ())
    {
      int lip_position = *position;
      if (lip_position > i)
	{
	  lip.insert (position, i);
	  return;
	};
      if (lip_position == i)
	return;
      position++;
    }
  lip.insert (lip.end (), i);
};

void
MOTEUR::trouve_liste_portal (LISTE_INDICE_PORTAL & liste, float rayon,
			     RWVECTOR centre)
{
  int liste_objet_portal_size = liste_objet_portal.size ();
  for (int i_portal = 0; i_portal != liste_objet_portal_size; i_portal++)
    {
      OBJET_PORTAL & objet_portal = liste_objet_portal[i_portal];
      OBJET & objet_portal_reel = *objet_portal.objet;
      // On le teste uniquement s'il est visible.
      if (objet_portal.facette_contenant)
	if (objet_portal.facette_contenant->existe ())
	  {
	    BOITE b = objet_portal_reel.get_boite ();
	    if (b.
		distance (objet_portal_reel.repere_global_inverse.
			  transforme (centre)) < rayon)
	      {
		insertion_indice (liste, i_portal);
	      }
	  }
    }
}

void
MOTEUR::fin_affiche (LPBLOCINFO lpblocinfo)
{
  // Pour chaque objet visible, appliquer tous les objets lumineux qui le concernent
  // dans l'ordre: scene,animation,lui-mme.

  temps_lumiere += lpblocinfo->diff;
  if (temps_lumiere > MAX_TEMPS_LUMIERE)
    {
      temps_lumiere = 0;
      frame_lumiere++;
    }

  for (int i = 0; i != liste_animation.size (); i++)
    {
      ANIMATION & got = *(liste_animation[i]);
      for (int j = 0; j != got.lpliste_objet.size (); j++)
	{
	  OBJET & objet_courant = *(got.lpliste_objet[j]);
	  if (lpblocinfo->blocecran.lumiere == TypeLumiereSansLumiere)
	    {
	      // Appliquer une lumiere blanche.
	      objet_courant.ajoute_lumiere_blanche ();
	    }
	  else if (objet_courant.frame_lumiere != frame_lumiere)
	    {
	      objet_courant.nettoie_impact_sphere_lumiere ();
	      objet_courant.frame_lumiere = frame_lumiere;
	      bool applique = false;
	      for (int k = 0; k != liste_objet_lumiere_scene.size (); k++)
		{
		  LPOBJET lols = liste_objet_lumiere_scene[k];
		  objet_courant.lumiere (lols, lpblocinfo->blocecran.lumiere);
		  if (lols == &objet_courant)
		    applique = true;
		};
	      for (int k = 0;
		   k != got.lpliste_objet_lumiere_animation.size (); k++)
		{
		  LPOBJET lola = got.lpliste_objet_lumiere_animation[k];
		  objet_courant.lumiere (lola, lpblocinfo->blocecran.lumiere);
		  if (lola == &objet_courant)
		    applique = true;
		}
	      if (!applique)
		objet_courant.lumiere (&objet_courant,
				       lpblocinfo->blocecran.lumiere);
	      objet_courant.fin_lumiere ();
	    }
	}
    }

  // Reinitialiser les portals.
  //printf("Reinit portal\n");

  int liste_objet_portal_size = liste_objet_portal.size ();
  for (int i = 0; i != liste_objet_portal_size; i++)
    {
      OBJET_PORTAL & op = liste_objet_portal[i];
      OBJET & objet = *(op.objet);
      objet.calcul_matrices_inverse ();
      int objet_portal_facette_size = op.liste_portal.size ();
      for (int j = 0; j != objet_portal_facette_size; j++)
	{
	  PORTAL & portal = op.liste_portal[j];
	  if (portal.facette_portal)
	    {
	      delete portal.facette_portal;
	      portal.facette_portal = NULL;
	    }
	}
      if (op.facette_contenant)
	delete op.facette_contenant;
      op.facette_contenant = NULL;
    }

  // Calculer facette_portal_ecran qui correspond a une facette portal
  // qui contient tout l'ecran.

  FACETTE_PORTAL facette_portal_ecran (facette_base);
  facette_portal_ecran.calcule_trame (positionnement_camera,
				      position_camera_standard);

  // Retrouver dans quel portal(s) on se trouve.
  // et dresser la hierarchie de portals + les facettes qui les contiennent.
  for (int i = 0; i != liste_objet_portal.size (); i++)
    {
      OBJET_PORTAL & op = liste_objet_portal[i];
      OBJET & objet = *(op.objet);
      RWVECTOR camera =
	objet.repere_global_inverse.transforme (position_camera_standard);
      if (objet.get_boite ().distance (camera) == 0.0)
	{
	  //printf("   Dedans %i %s %s\n",i,op.nom_animation.info,op.nom_objet.info);
	  // Mise a jour des facettes portal.
	  if (op.facette_contenant)
	    {
	      // Residu a detruire puisque notre portal va contenir au moins tout l'ecran.
	      delete op.facette_contenant;
	    }
	  op.facette_contenant = facette_portal_ecran.copie ();
	  op.facette_contenant->MAJ_plan (position_camera_standard);
	  update_facette_portal (op);
	}
    };
  //printf("Hierarchie terminee\n");


  // Nettoyage de la liste d'affichage
  liste_affichage.clear (liste_objet_portal_size);

  // inserer le portal lui-meme dans les listes a afficher
  for (int i_portal = 0; i_portal != liste_objet_portal_size; i_portal++)
    {
      OBJET_PORTAL & objet_portal = liste_objet_portal[i_portal];
      OBJET & objet_portal_reel = *objet_portal.objet;
      // On le teste uniquement s'il est visible.
      if (objet_portal.facette_contenant)
	if (objet_portal.facette_contenant->existe ())
	  {
	    // (il n'est pas dans la liste des objets.
	    liste_affichage.insert_portal (&objet_portal_reel, i_portal,
					   objet_portal.facette_contenant);
	  }
    }

  // Nettoyage de l'assignation aux objets d'une liste de portal, si necessaire
  // (parametre refreshFrame).
  // ET Assignation des portals a chaque groupe ou objet.
  // Ceci est TRES couteux et ne devrait etre fait au pire que 10x/sec
  //printf("Avant assignation\n");
  int liste_animation_size = liste_animation.size ();
  for (int i_got = 0; i_got != liste_animation_size; i_got++)
    {
      ANIMATION & at = *(liste_animation[i_got]);
      if (at.ensemble)
	{
	  at.indice_portal.clear ();
	  RWVECTOR centre = at.matrice_fin_affiche.transforme (at.centre);
	  trouve_liste_portal (at.indice_portal, at.rayon, centre);
	}
      else
	{
	  int liste_objet_individuel_size = at.lpliste_objet.size ();
	  for (int i_loi = 0; i_loi != liste_objet_individuel_size; i_loi++)
	    {
	      OBJET & oi = *(at.lpliste_objet[i_loi]);
	      oi.indice_portal.clear ();
	      if ((oi.activation < 0) || (oi.is_portal))
		continue;
	      RWVECTOR centre =
		oi.repere_global.transforme (oi.get_boite ().centre ());
	      float rayon = oi.get_boite ().maxDim ();
	      trouve_liste_portal (oi.indice_portal, rayon, centre);
	    }
	}
    }

  // Tracer ...
  for (int i = 0; i != 16; i++)
    {
      glDisable (GL_CLIP_PLANE0 + i);
    }

  liste_affichage.trace (lpblocinfo);

  // ancienne methode de trace...
  glDepthMask (GL_TRUE);
  for (int i = 0; i != 16; i++)
    {
      glDisable (GL_CLIP_PLANE0 + i);
    }
  for (int test_transp = 0; test_transp != 2; test_transp++)
    for (int i = 0; i != liste_animation_size; i++)
      {
	ANIMATION & got = *(liste_animation[i]);
	bool ensemble = got.ensemble;
	if ((got.indice_portal.size () == 0) && (ensemble))
	  continue;
	for (int j = 0; j != got.lpliste_objet.size (); j++)
	  {
	    OBJET & objet_courant = *(got.lpliste_objet[j]);
	    if ((ensemble || objet_courant.indice_portal.size ())
		&& (objet_courant.activation >= 0))
	      {
		if (test_transp)
		  {
		    glDepthMask (GL_FALSE);
		    objet_courant.trace_objet_final_transparent (lpblocinfo);
		  }
		else
		  {
		    glDepthMask (GL_TRUE);
		    objet_courant.trace_objet_final (lpblocinfo);
		  }
	      }
	  }
      }

  glDepthMask (GL_FALSE);
  for (int j = 0; j != objet_horsmoteur.size (); j++)
    {
      OBJET & objet_courant = *(objet_horsmoteur[j]);
      objet_courant.init_lumiere ();
      objet_courant.ajoute_lumiere_blanche ();
      objet_courant.fin_lumiere ();
      objet_courant.trace_objet_final (lpblocinfo);
      objet_courant.trace_objet_final_transparent (lpblocinfo);
    }
  glDepthMask (GL_FALSE);
  glDisable (GL_DEPTH_TEST);
  glColor4f (1, 1, 1, 1);
};

void
MOTEUR::polygone_ecran (LPBLOCINFO lpblocinfo, float alpha, int dessin,
			float coeff, float depx, float depy)
{
  ETAT_MULTITEXTURE em;
  em.texture = dessin;
  em.actif = false;
  em.additif = 0;
  lpblocinfo->lpetat_texture->active_etat (1, em);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  em.actif = true;
  lpblocinfo->lpetat_texture->active_etat (0, em);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  VALEUR_LUMIERE vl (1, 1, 1, 1.0 - alpha);
  lpblocinfo->lpetat_texture->set_color (0, vl);
  lpblocinfo->lpetat_texture->set_color (1, vl);
  glBegin (GL_POLYGON);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, 1, 1);
  glVertex3f (0.5 + coeff + depx, -0.5 - coeff + depy, 0);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, 0, 1);
  glVertex3f (0.5 - coeff + depx, -0.5 - coeff + depy, 0);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, 0, 0);
  glVertex3f (0.5 - coeff + depx, -0.5 + coeff + depy, 0);
  glMultiTexCoord2fARB_local (GL_TEXTURE0_ARB, 1, 0);
  glVertex3f (0.5 + coeff + depx, -0.5 + coeff + depy, 0);
  glEnd ();
}

void
MOTEUR::effet (LPBLOCINFO lpblocinfo, bool gagne, float effet_vie,
	       float effet_option, float effet_degat, float effet_mort)
{
  ecran_cone ();
  if (gagne)
    {
      polygone_ecran (lpblocinfo, 0.8, dessin_gagne);
      return;
    }

  if (effet_degat != 0)
    {
      polygone_ecran (lpblocinfo, effet_degat, dessin_degat);
    }
  if (effet_mort != 0)
    {
      polygone_ecran (lpblocinfo, effet_mort, dessin_mort);
    }
};

void
MOTEUR::swap_end ()
{
  SDL_GL_SwapBuffers ();
}

void
MOTEUR::fin_animation (LPANIMATION lpa)
{
  LISTE_ANIMATION liste_trans = liste_animation;
  liste_animation.clear ();
  for (int i = 0; i != liste_trans.size (); i++)
    if (liste_trans[i] != lpa)
      liste_animation.insert (liste_animation.end (), liste_trans[i]);

  LISTE_LPOBJET liste_trans2 = liste_objet_lumiere_scene;
  liste_objet_lumiere_scene.clear ();
  for (int i = 0; i != liste_trans2.size (); i++)
    {
      LPOBJET lpobj = liste_trans2[i];
      bool found = false;
      for (int j = 0; j != lpa->lpliste_objet.size (); j++)
	{
	  if (lpobj == lpa->lpliste_objet[j])
	    {
	      found = true;
	      break;
	    };
	}
      if (!found)
	liste_objet_lumiere_scene.insert (liste_objet_lumiere_scene.begin (),
					  lpobj);
    }
}

void
MOTEUR::nouvelle_animation (LPANIMATION lpa)
{
  liste_animation.insert (liste_animation.begin (), lpa);
  for (int j = 0; j != lpa->lpliste_objet.size (); j++)
    {
      OBJET & objet_courant = *(lpa->lpliste_objet[j]);
      switch (objet_courant.get_zone_lumiere ())
	{
	case LUMIERE_SCENE:
	  liste_objet_lumiere_scene.insert (liste_objet_lumiere_scene.end (),
					    &objet_courant);
	  break;
	case LUMIERE_ANIMATION:
	  lpa->lpliste_objet_lumiere_animation.insert (lpa->
						       lpliste_objet_lumiere_animation.
						       end (),
						       &objet_courant);
	  break;
	};
    }
};

MOTEUR::MOTEUR (LPBLOCINFO lpblocinfo)
{
  temps_lumiere = 0;
  frame_lumiere = 0;
  facette_base = new FACETTE ();
  LPVERTEX lpvertex;

  lpvertex = new VERTEX (RWVECTOR (-0.8, 0.6, -1));
  facette_base->ajoute_vertex (lpvertex);
  lpvertex = new VERTEX (RWVECTOR (0.8, 0.6, -1));
  facette_base->ajoute_vertex (lpvertex);

  lpvertex = new VERTEX (RWVECTOR (0.8, -0.6, -1));
  facette_base->ajoute_vertex (lpvertex);
  lpvertex = new VERTEX (RWVECTOR (-0.8, -0.6, -1));
  facette_base->ajoute_vertex (lpvertex);

  dessin_degat = 0;
  dessin_mort = 0;
  dessin_option = 0;
  dessin_vie = 0;
  dessin_gagne = 0;
  desc_image_cible = 0;
};

MOTEUR::~MOTEUR ()
{
  delete facette_base;
};

void
MOTEUR::insert_portal (LPOBJET lpobj, MOT & anim, MOT & obj,
		       LISTE_PORTAL & lp)
{
  struct OBJET_PORTAL objet_portal;
  objet_portal.liste_portal = lp;
  objet_portal.nom_animation = anim;
  objet_portal.nom_objet = obj;
  objet_portal.objet = lpobj;
  objet_portal.facette_contenant = NULL;
  for (int i = 0; i != objet_portal.liste_portal.size (); i++)
    {
      objet_portal.liste_portal[i].facette_portal = NULL;
    };
  liste_objet_portal.insert (liste_objet_portal.begin (), objet_portal);
};

void
MOTEUR::solve_portal ()
{
// pour chaque facette de chaque portal, le resoudre en indice dans la table des objets portal.
  MOT suivant_strict ("+");
  MOT precedent_strict ("-");
  MOT precedent_precedent ("-:");
  MOT suivant_suivant ("+:");
  for (int i = 0; i != liste_objet_portal.size (); i++)
    {
      OBJET_PORTAL & objet_portal = liste_objet_portal[i];
      objet_portal.facette_contenant = NULL;
      MOT & nom_animation_courant = objet_portal.nom_animation;
      for (int j = 0; j != objet_portal.liste_portal.size (); j++)
	{
	  PORTAL & portal_courant = objet_portal.liste_portal[j];
	  portal_courant.facette_portal = NULL;
	  MOT & nom_objet = portal_courant.nom_objet;
	  int &cible_objet = portal_courant.num;
	  cible_objet = -1;
	  LPOBJET & cible_lpobjet = portal_courant.lpobjet;
	  cible_lpobjet = NULL;
	  if (nom_objet.taille >= 0)
	    {
	      if (nom_objet == suivant_strict)
		{
		  cible_objet = i + 1;
		  if (cible_objet != liste_objet_portal.size ())
		    {
		      cible_lpobjet = liste_objet_portal[cible_objet].objet;
		    }
		  else
		    cible_objet = -1;
		}
	      else if (nom_objet == precedent_strict)
		{
		  cible_objet = i - 1;
		  if (cible_objet >= 0)
		    {
		      cible_lpobjet = liste_objet_portal[cible_objet].objet;
		    }
		  else
		    cible_objet = -1;
		}
	      else if (nom_objet == suivant_suivant)
		{
		  // trouver le premier objet de l'animation suivante.
		  int recherche = i + 1;
		  while ((recherche != liste_objet_portal.size ()) &&
			 (!(nom_animation_courant ==
			    liste_objet_portal[recherche].nom_animation)))
		    recherche++;
		  if (recherche != liste_objet_portal.size ())
		    {
		      cible_objet = recherche;
		      cible_lpobjet = liste_objet_portal[cible_objet].objet;
		    }
		}
	      else if (nom_objet == precedent_precedent)
		{
		  // trouver le dernier objet de l'animation precedente.
		  int recherche = i - 1;
		  while ((recherche >= 0) &&
			 (!(nom_animation_courant ==
			    liste_objet_portal[recherche].nom_animation)))
		    recherche--;
		  if (recherche != liste_objet_portal.size ())
		    {
		      cible_objet = recherche;
		      cible_lpobjet = liste_objet_portal[cible_objet].objet;
		    }
		}
	      else
		{
		  // verifier si c'est un nom compos ANIM:OBJET
		  bool tdp = false;
		  MOT obj;
		  MOT anim;
		  for (int rec = 0; rec <= nom_objet.taille; rec++)
		    {
		      if (nom_objet[rec] == ':')
			{
			  tdp = true;
			}
		      else
			{
			  if (tdp)
			    obj = obj + nom_objet[rec];
			  else
			    anim = anim + nom_objet[rec];
			}
		    }
		  if (!tdp)
		    {
		      anim = nom_animation_courant;
		      obj = nom_objet;
		    };
		  // effectuer la recherche sur obj/anim
		  for (int rec = 0; rec != liste_objet_portal.size (); rec++)
		    {
		      OBJET_PORTAL & objet_portal_rec =
			liste_objet_portal[rec];
		      //printf("REC %s %s\n",
		      //    objet_portal_rec.nom_animation.info,
		      //    objet_portal_rec.nom_objet.info);
		      if ((anim == objet_portal_rec.nom_animation)
			  && (obj == objet_portal_rec.nom_objet))
			{
			  cible_objet = rec;
			  cible_lpobjet =
			    liste_objet_portal[cible_objet].objet;
			  //printf("TRouv portal....%i %s %s\n",rec,obj.info,anim.info);
			};
		    }
		};
	      /*
	         if (portal_courant.num!=-1)
	         printf("    PORTAL %i - FACETTE %i %i - OBJET %s - CIBLE %s -> PORTAL %i OBJET %s\n",
	         i,
	         j,portal_courant.facette_portal,
	         liste_objet_portal[i].nom_objet.info,
	         nom_objet.info,
	         portal_courant.num,
	         liste_objet_portal[portal_courant.num].nom_objet.info);
	         else
	         printf("UNR PORTAL %i - FACETTE %i - OBJET %s - CIBLE %s\n",
	         i,
	         j,
	         liste_objet_portal[i].nom_objet.info,
	         nom_objet.info);
	       */
	    };
	};
    };
//exit(0);
};


FACETTE_PORTAL::FACETTE_PORTAL (FACETTE * src):source (src)
{
  if (src)
    for (int i = 0; i != src->liste.size (); i++)
      {
	liste.insert (liste.end (), new VERTEX (*(src->liste[i])));
      }
};

FACETTE_PORTAL::FACETTE_PORTAL ():source (NULL)
{
};

void
FACETTE_PORTAL::calcule_trame (MATRIX & trans, RWVECTOR & position)
{
  LISTE_VERTEX & lst = source->liste;
  // Calcul des nouveaux points
  int taille = liste.size ();
  RWVECTOR p0 = (trans.transforme (RWVECTOR (0, 0, 0)));
  for (int i = 0; i != taille; i++)
    {
      liste[i]->point = trans.transforme (lst[i]->point);
    };
  MAJ_plan (position);
};

void
FACETTE_PORTAL::MAJ_plan (RWVECTOR & position)
{
  // MAJ des nouveaux plans.
  int taille = liste.size ();
  if (taille < 3)
    return;
  RWVECTOR *P = &(liste[0]->point);
  for (int i = 0; i != taille; i++)
    {
      RWVECTOR *P1 = &(liste[i]->point);
      RWVECTOR *P2 = P;
      if (i != taille - 1)
	P2 = &(liste[i + 1]->point);
      liste[i]->plan.calcul_PLAN (position, *P2, *P1);
    };
  // Avec au moins 3 points, on calcule le plan global.
  plan.calcul_PLAN (liste[2]->point, liste[1]->point, liste[0]->point);
};

FACETTE_PORTAL::~FACETTE_PORTAL ()
{
    for (int i = 0; i != liste.size (); i++)
      {
  	delete liste[i];
      };
    liste.clear();
}

void
bloque_plan (PLAN & p, int num)
{
  glEnable (GL_CLIP_PLANE0 + num);
  double plan[4] = {
    -p.u.x (),
    -p.u.y (),
    -p.u.z (),
    p.u.produit_scalaire (p.P)
  };
  glClipPlane (GL_CLIP_PLANE0 + num, plan);
}

void
FACETTE_PORTAL::trace_cone_visualisation ()
{
  int taille = liste.size ();
  for (int i = 0; i != taille; i++)
    {
      bloque_plan ((liste[i])->plan, i);
    };
};

FACETTE_PORTAL *
FACETTE_PORTAL::copie ()
{
  FACETTE_PORTAL *fp = new FACETTE_PORTAL ();
  int taille = liste.size ();
  for (int i = 0; i != taille; i++)
    {
      fp->liste.insert (fp->liste.end (), new VERTEX (*(liste[i])));
    };
  fp->plan = plan;
  return fp;
};

bool
FACETTE_PORTAL::sens (RWVECTOR & position)
{
  return (plan.COTE (position, 0)) && (existe ());
}

bool
FACETTE_PORTAL::existe ()
{
  return liste.size () >= 3;
}

void
FACETTE_PORTAL::troncature (PLAN & p)
{
  LISTE_VERTEX liste2;
  for (LISTE_VERTEX::iterator i = liste.begin (); i != liste.end (); i++)
    {
      LPVERTEX v1 = *i;
      LPVERTEX v2;
      if ((i + 1) == liste.end ())
	v2 = (*(liste.begin ()));
      else
	v2 = (*(i + 1));
      RWVECTOR p1 = v1->point;
      RWVECTOR p2 = v2->point;
      if (!(p.COTE (p1, 0)))
	{
	  liste2.insert (liste2.end (), new VERTEX (*v1));
	  if ((p.COTE (p2, 0)))
	    {
	      // Calcul d'intersection, etc...
	      RWVECTOR inter;
	      float k;
	      p.intersection (p1, p2, &inter, k);
	      LPVERTEX v3 = new VERTEX (inter, 0, 0);
	      liste2.insert (liste2.end (), v3);
	    }
	}
      else
	{
	  if (!(p.COTE (p2, 0)))
	    {
	      // Calcul d'intersection, etc...
	      RWVECTOR inter;
	      float k;
	      p.intersection (p1, p2, &inter, k);
	      LPVERTEX v3 = new VERTEX (inter, 0, 0);
	      liste2.insert (liste2.end (), v3);
	    }
	}
    };
  // Destruction de liste.
  for (LISTE_VERTEX::iterator i = liste.begin (); i != liste.end (); i++)
    {
      delete (*i);
    };
  liste = liste2;
}

void
FACETTE_PORTAL::tronquer (LPFACETTE_PORTAL trunc)
{
  for (LISTE_VERTEX::iterator i = trunc->liste.begin ();
       i != trunc->liste.end (); i++)
    {
      troncature ((*i)->plan);
    };
};

void
FACETTE_PORTAL::ajoute (LPFACETTE_PORTAL)
{
}

void
FACETTE_PORTAL::print ()
{
  printf ("---- FACETTEPORTAL\n");
  for (LISTE_VERTEX::iterator i = liste.begin (); i != liste.end (); i++)
    {
      VERTEX & v = *(*i);
      printf ("%f %f %f --- %f %f %f -- %f %f %f\n",
	      v.point.x (), v.point.y (), v.point.z (),
	      v.plan.u.x (), v.plan.u.y (), v.plan.u.z (),
	      v.plan.P.x (), v.plan.P.y (), v.plan.P.z ());
    };
  printf ("**** FACETTEPORTAL\n");

}

LISTE_AFFICHAGE::LISTE_AFFICHAGE ()
{
  lpfacette_affichage = NULL;
  nb_portal = 0;
};

LISTE_AFFICHAGE::~LISTE_AFFICHAGE ()
{
  if (lpfacette_affichage)
    delete lpfacette_affichage;
  lpfacette_affichage = NULL;
  sous_liste_affichage.clear ();
};

void
LISTE_AFFICHAGE::clear (int nb)
{
  sous_liste_affichage.clear ();
  nb_portal = nb;
  LISTE_AFFICHAGE la;
  sous_liste_affichage.insert (sous_liste_affichage.end (), nb_portal, la);
};

void
LISTE_AFFICHAGE::insert_liste_objet (LISTE_LPOBJET & liste_objet,
				     LISTE_INDICE_PORTAL & liste_indice)
{
  LISTE_AFFICHAGE *current_la = this;
  LISTE_AFFICHAGE *last_current_la = NULL;

  LISTE_INDICE_PORTAL li = liste_indice;
  while (li.size ())
    {
      int level = li[0];
      printf ("Liste Level %i\n", level);
      if (current_la->sous_liste_affichage.size () != nb_portal)
	{
	  // Manque un niveau. On l'ajoute.
	  printf ("Manque le niveau\n");
	  current_la->clear (nb_portal);
	  current_la->nb_portal = nb_portal;
	  current_la->lpfacette_affichage =
	    last_current_la->lpfacette_affichage->copie ();
	  // Rajouter la facette correspondante du niveau0.
	  current_la->lpfacette_affichage->
	    ajoute (sous_liste_affichage[level].lpfacette_affichage);
	}
      last_current_la = current_la;
      current_la = &(current_la->sous_liste_affichage[level]);
      li.erase (li.begin (), li.begin () + 1);
    }
  // Rajouter la liste d'objets
  int liste_objet_size = liste_objet.size ();
  for (int i = 0; liste_objet_size; i++)
    current_la->a_tracer.insert (a_tracer.end (), liste_objet[i]);
};

void
LISTE_AFFICHAGE::insert_portal (LPOBJET lpobjet,
				int indice, LPFACETTE_PORTAL lpfacette_portal)
{
  LISTE_AFFICHAGE & la = sous_liste_affichage[indice];
  la.lpfacette_affichage = lpfacette_portal->copie ();
  la.a_tracer.insert (la.a_tracer.end (), lpobjet);
  la.nb_portal = nb_portal;
};

void
LISTE_AFFICHAGE::trace (LPBLOCINFO lpblocinfo)
{
  if (a_tracer.size () != 0)
    {
      // Trace recursivement.
      // D'abord borner l'ecran par la facette_portal.

      lpfacette_affichage->trace_cone_visualisation ();

      // Tracer ...
      glDepthMask (GL_TRUE);
      for (int i = 0; i != a_tracer.size (); i++)
	{
	  OBJET & objet_courant = *(a_tracer[i]);
	  objet_courant.trace_objet_final (lpblocinfo);
	}
      // Pour les facettes transparentes.
      glDepthMask (GL_FALSE);
      for (int i = 0; i != a_tracer.size (); i++)
	{
	  OBJET & objet_courant = *(a_tracer[i]);
	  objet_courant.trace_objet_final_transparent (lpblocinfo);
	}
      for (int i = 0; i != 16; i++)
	{
	  glDisable (GL_CLIP_PLANE0 + i);
	}
    }
  for (int i = 0; i != sous_liste_affichage.size (); i++)
    {
      sous_liste_affichage[i].trace (lpblocinfo);
    }
};

void
MOTEUR::affiche_cible (MOT & fichier_cible, LPBLOCINFO lpblocinfo,
		       float decal_x, float decal_y)
{
  if ((!(cible == fichier_cible)) || (desc_image_cible == 0))
    {
      DESCRIPTEUR_TEXTURE dt;
      dt.nom = fichier_cible;
      dt.blend_type = 2;
      desc_image_cible =
	lpblocinfo->lpbanque_texture->trouve_texture (&dt, lpblocinfo->lpbdd);
      cible = fichier_cible;
    };
  if (desc_image_cible != 0)
    {
      ecran_cone ();
      polygone_ecran (lpblocinfo, 0.8, desc_image_cible, 0.05, decal_x,
		      decal_y);
    };
}
