/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: niveau.h,v 1.3 2006/12/21 18:18:14 atila Exp $

#ifndef NIVEAU_H_CONST
#define NIVEAU_H_CONST

#include "context_objet.h"
#include "salle.h"
#include "reseau.h"
#include "jeu.h"
#include <stdio.h>
#include <vector>
#include <math.h>
#include <sys/time.h>
#include <unistd.h>

#define LPNIVEAU NIVEAU*

#define LISTE_SALLE deque<SALLE*>

typedef struct _INFO_NIVEAU
{
  vector < MOT > info;
  MOT nom_niveau;
  MOT screenshot;
} INFO_NIVEAU;

class NIVEAU
{
  LISTE_SALLE liste_salle;
  int musique_handler;
  MOT musique;

  bool test_marche (RWVECTOR position, RWVECTOR direction,
		    float rayon,
		    float &hauteur_max,
		    LPFACETTE lpfacette, LISTE_LPFACETTE_PROCHE &);
  void interaction_mur (LOCAL_CALC_CONTEXT_OBJET & lcco, LPOBJET lpobj,
			LPFACETTE lpfacette, CONTEXT_OBJET & co, RWVECTOR & n,
			float diff);
  bool renvoie_intersection_lineaire (RWVECTOR & P0, RWVECTOR & P1,
				      float rayon, LPFACETTE & lpfacette,
				      LPFACETTE_PROCHE & lpf,
				      RWVECTOR & normale, RWVECTOR & pcourant,
				      LISTE_LPFACETTE_PROCHE & liste);

public:

  void deplacement (LPCONTEXT_OBJET lpco, LPBLOCINFO lpblocinfo);
  void ajoute_facette_proche (LISTE_LPFACETTE_PROCHE &, float, RWVECTOR);

  void gestion_deplacement_objet (LPCONTEXT_OBJET lpco);
  void gestion_globale (LPBLOCINFO);
  void affichage (LPBLOCINFO);
  void charge_niveau (MOT *, LPBLOCINFO);
  void donne_info_niveau (MOT *, LPBLOCINFO, INFO_NIVEAU * info);
    NIVEAU ();
    NIVEAU (MOT *, LPBLOCINFO);
   ~NIVEAU ();

  bool impact (RWVECTOR & a, RWVECTOR & b, LPFACETTE * touche, LPOBJET * lpo);

  void impact_sphere (RWVECTOR & point, float distance,
		      float distance_facette, int ID, LPLISTE_OBJET & liste,
		      float temps);

};

#endif
