/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "option.h"

void
FICHIER_OPTION::dump ()
{
  for (LISTE_OPTION::iterator i = liste.begin (); i != liste.end (); i++)
    printf ("%s=%s\n", (*i).nom.info, (*i).valeur.info);
}

FICHIER_OPTION::FICHIER_OPTION (MOT fichier)
{
  nom_fichier = fichier;
};

void
FICHIER_OPTION::read_option ()
{
  // Relecture de toutes les options.
  liste.erase (liste.begin (), liste.end ());
  FILE *fic = fopen (nom_fichier.info, "r");
  bool fin = false;
  if (fic)
    while (!fin)
      {
	bool deb = true;
	char c;
	MOT d, f;
	do
	  {
	    c = fgetc (fic);
	    if ((c == '=') && (deb))
	      deb = false;
	    else if ((c != EOF) && (c != '\n'))
	      {
		if (deb)
		  d = d + c;
		else
		  f = f + c;
	      };
	  }
	while ((c != EOF) && (c != '\n'));
	OPTION opti;
	opti.nom = d;
	opti.valeur = f;
	if (c == EOF)
	  fin = true;
	else
	  liste.insert (liste.end (), opti);
      }
  if (fic)
    fclose (fic);
};

void
FICHIER_OPTION::write_option ()
{
  FILE *fic = fopen (nom_fichier.info, "w+");
  if (fic)
    for (LISTE_OPTION::iterator i = liste.begin (); i != liste.end (); i++)
      fprintf (fic, "%s=%s\n", (*i).nom.info, (*i).valeur.info);
  if (fic)
    fclose (fic);
};

bool
FICHIER_OPTION::get_option (MOT op, MOT & val)
{
  for (LISTE_OPTION::iterator i = liste.begin (); i != liste.end (); i++)
    if (op == (*i).nom)
      {
	val = (*i).valeur;
	return true;
      }
  val = MOT ("");
  return false;
};

void
FICHIER_OPTION::put_option (MOT op, MOT val)
{
  for (LISTE_OPTION::iterator i = liste.begin (); i != liste.end (); i++)
    if (op == (*i).nom)
      {
	(*i).valeur = val;
	return;
      }
  OPTION opti;
  opti.nom = op;
  opti.valeur = val;
  liste.insert (liste.end (), opti);
};

FICHIER_OPTION::~FICHIER_OPTION ()
{
};
