/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: reseau.cpp,v 1.3 2006/12/21 18:18:14 atila Exp $

#include "reseau.h"

RESEAU::RESEAU ()
{
  ecoute_tcp = NULL;
  lpconnexion = NULL;
  recup_client = NULL;
  bloc_info_jeu.nom_map = MOT ("");
  bloc_info_jeu.max_joueur = 0;
  bloc_info_jeu.nb_joueur = 0;
  ID_connexion_client = 0;
  num_connexion = 1;
  bloc_carac_joueur.ID_connexion = -1;
}

RESEAU::~RESEAU ()
{
// Detruit toutes les informations / Tous les threads...
  for (int i = 0; i < vector_lpconnexion.size (); i++)
    {
      delete vector_lpconnexion[i];
    }
  for (int i = 0; i < info_traitement_joueur.size (); i++)
    {
      delete info_traitement_joueur[i];
    }
  if (ecoute_tcp)
    delete ecoute_tcp;
  if (recup_client)
    delete recup_client;
  if (lpconnexion)
    delete lpconnexion;
}

int
RESEAU::init_serveur (LPBLOCINFO lpblocinfo)
{
// Mise en route d'un serveur local.
  int erreur = 0;
  num_port = 2007;
  ecoute_tcp = new TCP ();
#ifdef linux
  while (!erreur)
    if (ecoute_tcp->ouverture_socket_ecoute (num_port) != 0)
      {
	printf ("SERVEUR : erreur ouverture socket ecoute sur port %i\n",
		num_port);
	num_port += 100;
      }
    else
      erreur = 1;
#endif
// Preparer une recuperation de connexion;
  printf ("SERVEUR : ouverture socket ecoute sur port %i\n", num_port);
  recup_client = new TCP ();
};

void
RESEAU::get_UDP (int CANAL, unsigned int *taille, void **buffer)
{
  *buffer = NULL;
  *taille = 0;
  if (lpconnexion)
    lpconnexion->recuperer_canal_UDP (CANAL, taille, buffer);
}

void
RESEAU::get_UDP (int CANAL, unsigned int *taille, void **buffer,
		 int no_connexion_client)
{
// Retrouver le canal correspondant...
  int numero = -1;

  *buffer = NULL;
  *taille = 0;

  for (int i = 0; i < vector_lpconnexion.size (); i++)
    if ((vector_lpconnexion[i])->ID_connexion == no_connexion_client)
      numero = i;

  if (numero != -1)
    vector_lpconnexion[numero]->recuperer_canal_UDP (CANAL, taille, buffer);
  else
    {
      printf
	("SERVEUR : RESEAU : WARNING! Numero de connexion client non-trouve...\n");
    }
}

void
RESEAU::put_UDP (int CANAL, unsigned int taille, void *buffer)
{
// pour un client comme pour un serveur...
  if (lpconnexion)
    lpconnexion->ecrire_canal_UDP (CANAL, taille, buffer);
  for (int i = 0; i < vector_lpconnexion.size (); i++)
    {
      //printf("%i\n",vector_lpconnexion.size());
      vector_lpconnexion[i]->ecrire_canal_UDP (CANAL, taille, buffer);
    }

}

void
RESEAU::gestion_globale (LPBLOCINFO lpblocinfo)
{
  if (lpblocinfo->serveur)
    {
      if (ecoute_tcp->ecoute_connection (recup_client) == 1)
	{
	  LPCONNEXION nconnexion = new CONNEXION (false);
	  printf
	    ("SERVEUR : connexion recue ... Engagement processus de traitement\n");

	  void *bloc_jeu = malloc (sizeof (BLOC_INFO_JEU));
	  int taille_bloc_jeu = sizeof (BLOC_INFO_JEU);

	  *(BLOC_INFO_JEU *) bloc_jeu = bloc_info_jeu;

	  printf ("SERVEUR : INFO_JEU : MAP %s \n",
		  (*(BLOC_INFO_JEU *) bloc_jeu).nom_map.info);

	  bloc_carac_joueur.ID_connexion = num_connexion;
	  void *bloc_cj = malloc (sizeof (BLOC_CARAC_JOUEUR));
	  int taille_cj = sizeof (BLOC_CARAC_JOUEUR);

	  (*(BLOC_CARAC_JOUEUR *) bloc_cj) = bloc_carac_joueur;

	  nconnexion->set_bloc_jeu (bloc_jeu, taille_bloc_jeu);
	  nconnexion->set_carac_joueur (bloc_cj, taille_cj);

	  if (nconnexion->recup_connexion (recup_client) != 0)
	    {
	      printf ("SERVEUR : oups recup connexion\n");
	      exit (1);
	    };
	  nconnexion->ID_connexion = num_connexion;

	  // On ajoute à la liste.
	  vector_lpconnexion.insert (vector_lpconnexion.begin (), nconnexion);
	  recup_client = new TCP ();

	  printf ("SERVEUR : Nombre de connexions %i\n",
		  vector_lpconnexion.size ());

	  LPAFFICHE_TEXTE lpaff = lpblocinfo->lpaffiche_texte;
	  if (lpaff)
	    {
	      MOT m ("NOUVEAU JOUEUR CONNECTE...");
	      lpaff->print (m, lpblocinfo);
	    }
	  num_connexion++;
	}
      VECTOR_LPCONNEXION::iterator i = vector_lpconnexion.begin ();
      while (i != vector_lpconnexion.end ())
	{
	  int ID = (*i)->ID_connexion;
	  ETAT_CONNEXION e = (*i)->recup_etat ();
	  if ((e == CONNEXION_REFUSE) || (e == CONNEXION_ERREUR)
	      || (e == CONNEXION_FIN))
	    {
	      delete (*i);
	      VECTOR_LPCONNEXION::iterator i2 = i;
	      i2++;
	      vector_lpconnexion.erase (i, i2);
	      TABLEAU_JOUEUR::iterator tj = info_connexion.begin ();
	      while (tj != info_connexion.end ())
		{
		  TABLEAU_JOUEUR::iterator tj2 = tj;
		  tj2++;
		  if ((*tj)->ID_connexion == ID)
		    {
		      free (*tj);
		      info_connexion.erase (tj, tj2);
		      tj = info_connexion.end ();
		    }
		  else
		    tj++;
		};
	      i = vector_lpconnexion.begin ();
	    }
	  else
	    i++;
	}
      for (VECTOR_LPCONNEXION::iterator i = vector_lpconnexion.begin ();
	   i != vector_lpconnexion.end (); i++)
	{
	  (*i)->gestion_tour (lpblocinfo->diff);
	}
      for (VECTOR_LPCONNEXION::iterator i = vector_lpconnexion.begin ();
	   i != vector_lpconnexion.end (); i++)
	{
	  bool found = false;
	  int ID = (*i)->ID_connexion;
	  for (TABLEAU_JOUEUR::iterator tj = info_connexion.begin ();
	       tj != info_connexion.end (); tj++)
	    {
	      if ((*tj)->ID_connexion == ID)
		found = true;
	    };
	  if (!found)
	    {
	      // A-t-il donné ses infos ?
	      void *b;
	      int t;
	      if ((*i)->get_info_joueur_ok ())
		{
		  (*i)->get_info_joueur (&b, &t);
		  JOUEUR_CONNECTE *jc =
		    (JOUEUR_CONNECTE *) malloc (sizeof (JOUEUR_CONNECTE));
		  jc->ID_connexion = ID;
		  jc->bloc_info = *(BLOC_INFO_JOUEUR *) b;
		  free (b);
		  printf ("SERVEUR : Nouveau client enregistre\n");

		  char buf[1000];
		  sprintf (buf, "NOUVEAU JOUEUR ACTIF : %s",
			   jc->bloc_info.nom.info);
		  MOT m (buf);
		  lpblocinfo->lpaffiche_texte->print (m, lpblocinfo);

		  info_connexion.insert (info_connexion.begin (), jc);
		};
	    }
	}
    }
  else
    {
      // Regarder si on a recu une info de la part du serveur...
      if (lpconnexion)
	{
	  lpconnexion->gestion_tour (lpblocinfo->diff);
	  if (lpconnexion->get_bloc_jeu_ok ())
	    {
	      void *bloc;
	      int taille;
	      lpconnexion->get_bloc_jeu (&bloc, &taille);
	      bloc_info_jeu = *((BLOC_INFO_JEU *) bloc);
	    }
	  if (lpconnexion->get_carac_joueur_ok ())
	    {
	      void *bloc;
	      int taille;
	      lpconnexion->get_carac_joueur (&bloc, &taille);
	      bloc_carac_joueur = *(BLOC_CARAC_JOUEUR *) bloc;
	      ID_connexion_client = bloc_carac_joueur.ID_connexion;
	      printf ("CLIENT : Carac joueur recues. Je suis le numero %i\n",
		      ID_connexion_client);
	    }
	}
    }
}

int
RESEAU::connecte_client (LPBLOCINFO lpblocinfo, MOT & nom)
{
  lpconnexion = new CONNEXION (true);
  lpconnexion->set_info_jeu (true);
  void *bloc_ij = malloc (sizeof (BLOC_INFO_JOUEUR));
  int taille_ij = sizeof (BLOC_INFO_JOUEUR);
  *((BLOC_INFO_JOUEUR *) bloc_ij) = bloc_info_joueur;
  lpconnexion->set_info_joueur (bloc_ij, taille_ij);
// On fait une 10aine de tentatives avant de conclure à un échec.
  num_port = 2007;
  while (lpconnexion->connexion (num_port, nom.info) && (num_port < 5000))
    {
      printf ("CLIENT : recherche connexion sur %i ECHEC\n", num_port);
      num_port += 100;
    };
  printf ("CLIENT : connexion etablie %i\n", num_port);
}

void
RESEAU::set_info_jeu (int max_joueur, MOT * nom_map)
{
  bloc_info_jeu.nom_map = *nom_map;
  bloc_info_jeu.max_joueur = max_joueur;
  bloc_info_jeu.nb_joueur = 0;
}

bool
RESEAU::get_info_jeu (int &max_joueur, MOT & nom_map)
{
  if (ID_connexion_client != 0)
    {
      max_joueur = bloc_info_jeu.max_joueur;
      nom_map = bloc_info_jeu.nom_map;
      return true;
    }
  return false;
};

void
RESEAU::set_info_joueur (MOT * nom, MOT * fichier_skin)
{
  bloc_info_joueur.nom = *nom;
  bloc_info_joueur.fichier_skin = *fichier_skin;
};


bool
RESEAU::fin_jeu ()
{
  return false;
}
