/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: reseau.h,v 1.2 2004/06/02 17:14:29 atila Exp $

#ifndef RESEAU_FICHIER_H
#define RESEAU_FICHIER_H
#include <vector>
#include "connexion.h"
#include "bloc_info.h"
#include "affiche_texte.h"

typedef char NOM_JOUEUR[30];

#define CANAL_CONTROLE		0
#define CANAL_NIVEAU		1
#define	CANAL_OBJET		2
#define CANAL_MESSAGE		3
#define CANAL_COMMANDE		4

typedef struct _BLOC_INFO_JEU
{
  MOT nom_map;
  unsigned short int max_joueur;
  unsigned short int nb_joueur;
}
BLOC_INFO_JEU;

typedef struct _BLOC_INFO_JOUEUR
{
  MOT fichier_skin;
  MOT nom;
}
BLOC_INFO_JOUEUR;

typedef struct joueur_connecte
{
  int ID_connexion;
  BLOC_INFO_JOUEUR bloc_info;
} JOUEUR_CONNECTE;

typedef vector < JOUEUR_CONNECTE * >TABLEAU_JOUEUR;
typedef TABLEAU_JOUEUR *LPTABLEAU_JOUEUR;

typedef CONNEXION *LPCONNEXION;
typedef vector < LPCONNEXION > VECTOR_LPCONNEXION;


typedef struct _BLOC_CARAC_JOUEUR
{
  int ID_connexion;
}
BLOC_CARAC_JOUEUR;

class RESEAU
{
  int num_connexion;
  int num_port;


  // Côté client ET serveur
  BLOC_INFO_JEU bloc_info_jeu;

  // Côté client.
  BLOC_INFO_JOUEUR bloc_info_joueur;
  BLOC_CARAC_JOUEUR bloc_carac_joueur;

public:

  int connecte_client (LPBLOCINFO lpblocinfo, MOT & nom);

  TABLEAU_JOUEUR info_connexion;
  TABLEAU_JOUEUR info_traitement_joueur;

  int ID_connexion_client;

  // Pour le serveur
  VECTOR_LPCONNEXION vector_lpconnexion;
  TCP *ecoute_tcp;
  TCP *recup_client;
  int init_serveur (LPBLOCINFO lpblocinfo);

  // Pour le client :
  LPCONNEXION lpconnexion;
  // prendre à partir du serveur.
  void get_UDP (int CANAL, unsigned int *taille, void **buffer);
  void set_info_joueur (MOT * nom, MOT * fichier_skin);

  // Serveur : prendre à partir d'un client précis.
  void get_UDP (int CANAL, unsigned int *taille, void **buffer,
		int no_connexion_client);
  void set_info_jeu (int max_joueur, MOT * nom_map);
  bool get_info_jeu (int &max_joueur, MOT & nom_map);

  // Pour client ou serveur... Mettre sur 1 ou plusieurs canaux.
  void put_UDP (int CANAL, unsigned int taille, void *buffer);

    RESEAU ();
   ~RESEAU ();

  //Boucle réelle.
  void gestion_globale (LPBLOCINFO lpblocinfo);

  bool fin_jeu ();
};

#endif
