/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: salle.cpp,v 1.3 2006/12/21 18:18:14 atila Exp $

#include "salle.h"

/************************ SALLE ***********************************************************/

SALLE::SALLE ()
{
  premier_mouvement = -2;
};

void
SALLE::gestion_globale (LPBLOCINFO lpblocinfo)
{
  LPACTION_SALLE laction;

  bool change = premier_mouvement < 0;

  for (LISTE_ACTION_SALLE::iterator actioniterator =
       liste_action_salle.begin ();
       actioniterator != liste_action_salle.end (); actioniterator++)
    {
      laction = *actioniterator;
      float ltime = laction->position_actuelle;
      float val = laction->position_suivante (lpblocinfo->diff);
      laction->valide_position (val);
      laction->lposition_actuelle = ltime;
      if (laction->lposition_actuelle != laction->position_actuelle)
	change = true;
    };

  if (change)
    {
      init_animation ();
      for (LISTE_ACTION_SALLE::iterator actioniterator =
	   liste_action_salle.begin ();
	   actioniterator != liste_action_salle.end (); actioniterator++)
	{
	  laction = *actioniterator;
	  BLOCINFO bli = *lpblocinfo;
	  bli.T = laction->position_actuelle;
	  bli.LT = laction->lposition_actuelle;
	  applique_animation (&laction->nom_anim, &bli);
	};
      fin_animation (lpblocinfo, NULL);
    };

  // Si c'est un client, on gre les facettes dynamiques.
  for (int i = 0; i < lpliste_objet.size (); i++)
    {
      (lpliste_objet[i])->set_T (lpblocinfo->diff);
    };
  if (premier_mouvement < 0)
    premier_mouvement++;
};

void
SALLE::charge_salle (MOT * nom_fichier, LPBLOCINFO lpblocinfo)
{
  BUFFER_NOEUD BF (lpblocinfo->lpbdd, nom_fichier);
  buffer_noeud *bf;
  bf = BF.ROOT ();
  charge_salle (&BF, bf, lpblocinfo);
};

void
SALLE::charge_salle (BUFFER_NOEUD * BF, buffer_noeud * bf,
		     LPBLOCINFO lpblocinfo)
{
  while (bf)
    {
      if (BF->get_nom (bf) == CONSTANTE_SCRIPT_NOUVELLEANIMATION)
	{
	  LPACTION_SALLE lpas;
	  lpas = new ACTION_SALLE ();
	  lpas->lecture_action (BF, BF->get_fils (bf));
	  liste_action_salle.insert (liste_action_salle.end (), lpas);
	}
      if (BF->get_nom (bf) == CONSTANTE_SCRIPT_NOM)
	{
	  nom_salle = BF->get_MOT (bf);
	}
      bf = BF->trouve_suivant (bf);
    }
};

SALLE::~SALLE ()
{
  for (LISTE_ACTION_SALLE::iterator actioniterator =
       liste_action_salle.begin ();
       actioniterator != liste_action_salle.end (); actioniterator++)
    {
      delete (*actioniterator);
    }
};

void
SALLE::ecriture (LPBLOCINFO lpblocinfo, STOCK & stock)
{
  LPACTION_SALLE laction;
  for (LISTE_ACTION_SALLE::iterator actioniterator =
       liste_action_salle.begin ();
       actioniterator != liste_action_salle.end (); actioniterator++)
    {
      laction = *actioniterator;
      laction->ecriture (stock);
    }
}

void
SALLE::lecture (LPBLOCINFO lpblocinfo, STOCK & stock, int &curseur)
{
  LPACTION_SALLE laction;
  for (LISTE_ACTION_SALLE::iterator actioniterator =
       liste_action_salle.begin ();
       actioniterator != liste_action_salle.end (); actioniterator++)
    {
      laction = *actioniterator;
      laction->lecture (stock, curseur);
    }
}

void
SALLE::applique_action (LPACTION_SALLE lpaction)
{
  LPACTION_SALLE laction;
  for (LISTE_ACTION_SALLE::iterator actioniterator =
       liste_action_salle.begin ();
       actioniterator != liste_action_salle.end (); actioniterator++)
    {
      laction = *actioniterator;
      if (laction->nom_anim == lpaction->nom_anim)
	{
	  laction->applique_action (*lpaction);
	}
    }
};

MOT
SALLE::get_nom_salle ()
{
  return nom_salle;
};

void
SALLE::connecte_moteur3d (LPBLOCINFO lpblocinfo)
{
  for (int i = 0; i < lpliste_objet.size (); i++)
    {
      (lpliste_objet[i])->connecte_moteur3d (nom_salle, lpblocinfo);
    }
}
