/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: script.cpp,v 1.4 2006/12/21 18:18:14 atila Exp $

#include "script.h"

/****************************************************
Fonctions sur les noeuds.
****************************************************/

double
NoeudAtof (noeud * noeud_voulu)
{
  int i;
  char *str;
  double res;
  if (!noeud_voulu)
    return 0;
  str = (char *) malloc (noeud_voulu->vfin - noeud_voulu->vdebut + 1);
  for (i = 0; i < noeud_voulu->vfin - noeud_voulu->vdebut; i++)
    str[i] = noeud_voulu->buffer[noeud_voulu->vdebut + i];
  str[noeud_voulu->vfin - noeud_voulu->vdebut] = 0;
  res = atof (str);
  free (str);
  return res;
};

// Testage.
int
dump_arbre (noeud * courant, int niveau)
{
  while (courant)
    {
      for (int i = 0; i < niveau; i++)
	printf (" ");
      for (int i = courant->tdebut; i < courant->tfin; i++)
	printf ("%c", courant->buffer[i]);
      printf (" = ");
      switch (courant->vtype)
	{
	case VALEUR:
	  printf (" %f ", courant->valeur);
	  break;
	case TEXTE:
	  for (int i = courant->vdebut; i < courant->vfin; i++)
	    printf ("%c", courant->buffer[i]);
	};
      printf ("\n");
      dump_arbre (courant->fils, niveau + 1);
      courant = courant->frere;
    };
};


void
NettoieNoeud (noeud * liste)
{
/*
  noeud *liste2;
  while (liste)
    {
      NettoieNoeud (liste->fils);
      liste2 = liste;
      liste = liste->frere;
      //if (liste2->buffer_perso) free(liste2->buffer);
      free (liste2);
    };
    */
}


noeud *
TrouveToken (noeud * frere, char *buffer, int debut, int fin)
{
  noeud *trouve = NULL;
  int i;
  while ((!trouve) && (frere))
    {
      trouve = NULL;
      if (fin - debut == frere->tfin - frere->tdebut)
	{
	  trouve = frere;
	  for (i = 0; i < fin - debut; i++)
	    if (buffer[i + debut] != frere->buffer[frere->tdebut + i])
	      trouve = NULL;
	};
      frere = frere->frere;
    };
  return trouve;
};

noeud *
DupliqueNoeud (noeud * dup)
{
  noeud *dernier;
  noeud *resultat = (noeud *) malloc (sizeof (noeud));
  *resultat = *dup;
  resultat->fils = NULL;
  resultat->frere = NULL;
  dernier = NULL;
  for (noeud * sub = dup->fils; sub; sub = sub->frere)
    {
      noeud *sous = DupliqueNoeud (sub);
      sous->frere = NULL;
      if (dernier)
	{
	  dernier->frere = sous;
	}
      else
	{
	  resultat->fils = sous;
	};
      dernier = sous;
    };
  return resultat;
};

/****************************************************
FIN DES FONCTIONS DE NOEUDS.
****************************************************/

int
FICHIER_SCRIPT::pre_buffer (char *buffer_fic, int taille_fic, BUFFER * bligne)
{
  int position = 0;
  int ligne = 1;
  while (position < taille_fic)
    {
      if (buffer_fic[position] == '\n')
	{
	  position++;
	  ligne++;
	}
      else
	{
	  if (buffer_fic[position] == '"')
	    {
	      do
		{
		  if (buffer_fic[position] != '\n')
		    bligne->put_buffer (buffer_fic[position], ligne);
		  else
		    ligne++;
		  position++;
		}
	      while ((position < taille_fic)
		     && (buffer_fic[position] != '"'));
	      if (position >= taille_fic)
		{
		  printf ("SCRIPT Erreur : Commentaire mal termin\n");
		  exit (1);
		};
	      bligne->put_buffer (buffer_fic[position], ligne);
	      position++;
	    }
	  else
	    {
	      if ((buffer_fic[position] != '\t') &&
		  (buffer_fic[position] != ' '))
		if (buffer_fic[position] != '\n')
		  {
		    bligne->put_buffer (buffer_fic[position], ligne);
		  }
		else
		  ligne++;
	      position++;
	    };
	};
    };

};

int
compare_chaine (char *c1, char *c2, int d1, int f1, int d2, int f2)
{
  if ((!c1) || (!c2))
    return 0;
  if (f1 - d1 != f2 - d2)
    return 0;
  for (int i = 0; i < f2 - d2; i++)
    if (c1[i + d1] != c2[i + d2])
      return 0;
  return 1;
};

int
test_equivalence (char *buffer, int debut, int fin,
		  char *buffer2, int debut2, int fin2)
{
  int i;
  int bon;
  if (fin - debut == fin2 - debut2)
    {
      bon = 1;
      for (i = 0; i < fin - debut; i++)
	if (buffer[i + debut] != buffer2[i + debut2])
	  bon = 0;
      return bon;
    }
  else
    return 0;
};


// genere l'arbre avant le traitement des regexp.
int
FICHIER_SCRIPT::genere_arbre (char *buffer, int *ligne, int taille_fic)
{
  int fin;
  fin = 0;
  genere_arbre_point (buffer, ligne, taille_fic, 0, &fin, 1, &pere);
};

int
lecture_mot (char *buffer, int debut, int taille, int *fin)
{
  *fin = debut;
  if (*fin == taille)
    {
      printf ("Lecture de Nom de variable  la fin de l'expr...\n");
      return -1;
    };
  if (buffer[*fin] == '$')
    (*fin)++;
  while ((*fin < taille) &&
	 (((buffer[*fin] >= '0') && (buffer[*fin] <= '9')) ||
	  ((buffer[*fin] >= 'a') && (buffer[*fin] <= 'z')) ||
	  ((buffer[*fin] >= 'A') && (buffer[*fin] <= 'Z')) ||
	  (buffer[*fin] == '_')))
    {
      (*fin)++;
    };
  return 0;
};

// Lecture du nom d'une variable.
int
lecture_nom (char *buffer, int *ligne, int taille_fic, int debut, int *fin)
{
  *fin = debut;
  if (buffer[*fin] == '$')
    (*fin)++;
  while ((*fin < taille_fic) &&
	 (((buffer[*fin] >= '0') && (buffer[*fin] <= '9')) ||
	  ((buffer[*fin] >= 'a') && (buffer[*fin] <= 'z')) ||
	  ((buffer[*fin] >= 'A') && (buffer[*fin] <= 'Z')) ||
	  (buffer[*fin] == '_')))
    {
      (*fin)++;
    };
  if (*fin == taille_fic)
    {
      printf
	("Nom de variable non-termine  la fin du fichier... debut ligne %i... ';' MANQUANT ?\n",
	 ligne[debut]);
      return -1;
    };
  return 0;
};

noeud *bloc_noeud = NULL;
int position_noeud;
#define BLOCNOEUD 100000

noeud *
get_nouveau_noeud ()
{
  if ((position_noeud >= BLOCNOEUD) || (!bloc_noeud))
    {
      bloc_noeud = (noeud *) malloc (sizeof (noeud) * BLOCNOEUD);
      position_noeud = 0;
    }
  noeud *ret = &(bloc_noeud[position_noeud]);
  position_noeud++;
  return ret;
}

// genere l'arbre avant le traitement des regexp, en partant d'un point prcis.
int
FICHIER_SCRIPT::genere_arbre_point (char *buffer, int *ligne,
				    int taille_fic,
				    int debut, int *fin,
				    int racine, noeud ** fils)
{
  noeud *courant, *sous_fils, *dernier;
  *fils = NULL;
  int erreur;

  int debut2;
  int fin2;
  dernier = NULL;
  while (*fin != taille_fic)
    {
      if (buffer[*fin] == '}')
	{
	  if (racine)
	    {
	      printf
		("GENERE ARBRE : } INATTENDUE A LA RACINE (ligne %i) !!!\n",
		 ligne[*fin]);
	      return -1;
	    }
	  else
	    {
	      (*fin)++;
	      return 0;
	    };
	};
      debut = *fin;
      if (lecture_nom (buffer, ligne, taille_fic, debut, fin))
	return -1;
      if (*fin == debut)
	{
	  printf ("Nom de variable trop court (ligne %i) \n", ligne[*fin]);
	  return -1;
	};

      //for (int i=debut;i<*fin;i++) printf("%c",buffer[i]);
      //printf("\n");

      courant = (noeud *) get_nouveau_noeud ();
      courant->buffer = buffer;
      courant->buffer_perso = false;
      courant->tdebut = debut;
      courant->tfin = *fin;
      courant->vtype = NONE;
      courant->vdebut = 0;
      courant->vfin = 0;
      courant->frere = NULL;
      courant->fils = NULL;

      if (dernier)
	{
	  dernier->frere = courant;
	  dernier = courant;
	}
      else
	{
	  dernier = courant;
	  *fils = courant;
	};

      switch (buffer[*fin])
	{
	case '{':
	  (*fin)++;
	  courant->vtype = FILS;
	  sous_fils = (noeud *) malloc (sizeof (noeud));
	  if (genere_arbre_point
	      (buffer, ligne, taille_fic, *fin, fin, 0, &sous_fils))
	    return -1;
	  courant->fils = sous_fils;
	  break;
	case '=':
	  (*fin)++;
	  debut2 = *fin;
	  fin2 = *fin;
	  if (buffer[*fin] == '"')
	    {
	      courant->vtype = TEXTE;
	      debut2++;
	      (*fin)++;
	      while ((*fin != taille_fic) && (buffer[*fin] != '"'))
		(*fin)++;
	      if (*fin == taille_fic)
		{
		  printf
		    ("Fin de fichier inattendue dans la lecture de la valeur texte  (ligne %i) \n",
		     ligne[*fin]);
		  return -1;
		};
	      fin2 = *fin;
	      (*fin)++;
	    }
	  else
	    {
	      courant->vtype = VALEUR;
	      while ((*fin != taille_fic) && (buffer[*fin] != ';'))
		(*fin)++;
	      if (*fin == taille_fic)
		{
		  printf
		    ("Fin de fichier inattendue dans la lecture de la valeur texte  (ligne %i) \n",
		     ligne[*fin]);
		  return -1;
		};
	      fin2 = *fin;
	    };
	  if (buffer[*fin] != ';')
	    {
	      printf ("';' attendu (ligne %i) ... Trouv : %c\n",
		      ligne[*fin], buffer[*fin]);
	      return -1;
	    };
	  (*fin)++;
	  courant->vdebut = debut2;
	  courant->vfin = fin2;
	  break;
	case ';':
	  (*fin)++;
	  break;
	default:
	  printf ("Caractre inattendu (ligne %i) %c \n", ligne[*fin],
		  buffer[*fin]);
	  return -1;
	  break;
	};


    };
  return 0;
};



int
FICHIER_SCRIPT::arbre_final (noeud * courant, noeud ** courant_final)
{
  (*courant_final) = NULL;
  noeud *dernier = NULL;
  for (noeud * parcours = courant; parcours; parcours = parcours->frere)
    {
      if (parcours->buffer[parcours->tdebut] != '$')
	{
	  // Ajout.
	  noeud *nouveau = (noeud *) malloc (sizeof (noeud));
	  *nouveau = *parcours;
	  nouveau->frere = NULL;
	  nouveau->fils = NULL;
	  if (dernier)
	    {
	      dernier->frere = nouveau;
	      dernier = nouveau;
	    }
	  else
	    {
	      dernier = nouveau;
	      *courant_final = nouveau;
	    };
	  if (parcours->fils)
	    {
	      arbre_final (parcours->fils, &(nouveau->fils));
	    };
	};
    };
  return 0;
};

int
FICHIER_SCRIPT::buffer_final (noeud * debut)
{
  static int inconnu = MAX_ASSOCIATION + 1;
//srprintf("nouveau\n");

  for (noeud * courant = debut; courant; courant = courant->frere)
    {
      // Ecriture des infos du noeud...
      int position = data.get_size ();
      buffer_noeud node, *pnode;

      node.type_noeud = courant->vtype;

      // Trouver son nom.
      int resultat = -1;
      for (int i = 0; i < MAX_ASSOCIATION; i++)
	if (tableau_association[i] != NULL)
	  {
	    if (compare_chaine
		(courant->buffer, (char *) tableau_association[i],
		 courant->tdebut, courant->tfin, 0,
		 strlen (tableau_association[i])))
	      {
		resultat = i;
	      };
	  };
      if (resultat == -1)
	resultat = inconnu++;
      node.nom_noeud = resultat;
      //      printf("Token %i\n",node.nom_noeud);

      data.put_buffer ((char *) &node, NULL, sizeof (node));
      switch (courant->vtype)
	{
	case VALEUR:
	  float val;
	  val = atof (&(courant->buffer[courant->vdebut]));
	  data.put_buffer ((char *) &val, NULL, sizeof (float));
	  break;
	case TEXTE:
	  data.put_buffer ((char *) &(courant->buffer[courant->vdebut]),
			   NULL, courant->vfin - courant->vdebut);
	  data.put_buffer ((char *) "", NULL, 1);
	  break;
	case FILS:
	  if (courant->fils)
	    {
	      unsigned int position =
		data.get_size () + sizeof (unsigned int);
	      data.put_buffer ((char *) &position, NULL, sizeof (int));
	      buffer_final (courant->fils);
	    }
	  else
	    {
	      unsigned int position = 0;
	      data.put_buffer ((char *) &position, NULL, sizeof (int));
	    };
	  break;
	};
      pnode = (buffer_noeud *) data.get_posbuffer (position);
      if (courant->frere)
	{
	  pnode->frere_noeud = (buffer_noeud *) data.get_size ();
	}
      else
	pnode->frere_noeud = 0;
      // ecriture du frere...

    };
};


int
FICHIER_SCRIPT::parse_buffer (char *init_buffer, int init_taille,
			      char **buffer, int *taille)
{
  char *init_buffer2;
  int *init_ligne2;
  int init_taille2;
  BUFFER *pre_buff = new BUFFER ();
  BUFFER *pre_buff2 = new BUFFER ();
  pre_buffer (init_buffer, init_taille, pre_buff);
  pre_buff->get_buffer (&init_buffer2, &init_ligne2, &init_taille2);
  genere_arbre (init_buffer2, init_ligne2, init_taille2);
  arbre_final (pere, &pere_final);
  delete pre_buff2;
  delete pre_buff;
  buffer_final (pere_final);
  int *ligne;
  data.get_buffer (buffer, &ligne, taille);

  free (ligne);
};

FICHIER_SCRIPT::FICHIER_SCRIPT ()
{
  pere = NULL;
};

FICHIER_SCRIPT::~FICHIER_SCRIPT ()
{
  NettoieNoeud (pere);
};
