/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: script.h,v 1.2 2004/06/02 17:14:29 atila Exp $

#ifndef SCRIPT_FICHIER
#define SCRIPT_FICHIER

#include "stdlib.h"
#include <ctype.h>
#include "buffer.h"
#include <string.h>
#include <math.h>

#include "script_nom.h"
#include "buffer_noeud.h"

enum VTYPE
{ NONE, VALEUR, TEXTE, FILS };

struct _noeud
{
  char *buffer;
  bool buffer_perso;

  int tdebut;
  int tfin;

  VTYPE vtype;
  int vdebut;
  int vfin;
  float valeur;

  struct _noeud *frere, *fils;
};

#define noeud struct _noeud

#define FOR_EACH_NOEUD(x,y) for(x=y;x;x=x->frere)

int dump_arbre (noeud * courant, int niveau);

class FICHIER_SCRIPT
{
  BUFFER data;
  noeud *pere;
  noeud *pere_final;

public:

  // Rcupration d'un buffer, 
  // insrer les numros de lignes,
  // supprimer les commentaires
  // traiter les include.
  int pre_buffer (char *buffer_fic, int taille_fic, BUFFER * bout);

  // genere l'arbre avant le traitement des regexp.
  int genere_arbre (char *buffer, int *ligne, int taille_fic);
  int genere_arbre_point (char *buffer, int *ligne,
			  int taille_fic,
			  int debut, int *fin, int racine, noeud ** fils);

  int arbre_final (noeud * courant, noeud ** courant_final);

  int buffer_final (noeud * courant);
  // Tout le processus de prcompilation  partir d'un buffer.
  int parse_buffer (char *init_buffer, int init_taille, char **buffer,
		    int *taille);



    FICHIER_SCRIPT ();
   ~FICHIER_SCRIPT ();
};


#endif
