/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef SND_MIXER_FILE
#define SND_MIXER_FILE


using namespace std;
#include "bloc_info.h"
#include <deque>
#include "lecture.h"
#include "mathsRWvsNDJ.h"

#include "bdd.h"

#include <sys/types.h>
#include <unistd.h>

void init_son();

/*******************************
 Ce truc sert a stocker des donnees d'un fichier son MP3 dans 
un buffer kivabien.
*******************************/

class SOUND_BUFFER
{
  char *data;
  int taille;
  MOT fichier;

public:

    SOUND_BUFFER (MOT & fic, LPBDD lpbdd);
   ~SOUND_BUFFER ();
  bool operator == (MOT &);
  char *get_ptr (int &t);
};

class SOUND_CONTROL
{
  SOUND_BUFFER *sound_buffer;
  int sound_number;
  int channel;

  // Si controle_position est activ, il faut revoir le volume en fonction de la position.
  bool controle_position;
  RWVECTOR position;
public:
    SOUND_CONTROL (int i, SOUND_BUFFER * snd_buff);
   ~SOUND_CONTROL ();
  bool operator == (int i);
  bool fin ();
  void termine_son ();
  int setVolume (int);
  void set_position (RWVECTOR position_actuelle);
  int gestion (RWVECTOR position_courante);

};

class MIXER
{
  int compteur;

  LPBDD lpbdd;

    deque < SOUND_CONTROL * >sound_control_list;
    deque < SOUND_BUFFER * >sound_buffer_list;

  SOUND_BUFFER *trouve_buffer_son (MOT & son);

  SOUND_CONTROL *trouve_sound_control (int son);
public:

  int lance_son (MOT & son, int volume);
  int controle_son (int son, int volume);
  int controle_position_son (int son, RWVECTOR position);
  bool fin_son (int son);
  void termine_son (int son);
  void gestion ();
  void gestion (RWVECTOR position);
  int set_volume (int son, int volume);

    MIXER (LPBDD bdd);
   ~MIXER ();
};


#endif
