/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: stock.cpp,v 1.2 2004/06/02 17:14:29 atila Exp $

#include "stock.h"

STOCK::STOCK (unsigned int taille)
{
  buffer = NULL;
  taille_reelle = 0;
  taille_donnees = 0;
  expand (taille);
};

STOCK::~STOCK ()
{
  if (buffer)
    free (buffer);
};

char *
STOCK::get_posbuffer (int position)
{
  return &(buffer[position]);
};

int
STOCK::get_info (int i, char *c)
{
  if (i < taille_donnees)
    {
      *c = buffer[i];
      return 0;
    }
  else
    return -1;
};

unsigned int
STOCK::get_size ()
{
  return taille_donnees;
};

void
STOCK::expand (int n)
{
  char *temp = (char *) malloc (taille_reelle + n);
  memcpy (temp, buffer, taille_donnees);
  if (buffer)
    free (buffer);
  buffer = temp;
  taille_reelle = taille_reelle + n;
};

int
STOCK::get_buffer (char **breq, int *treq)
{
  if ((buffer) && (get_size () != 0))
    {
      *breq = (char *) malloc (taille_donnees);
      *treq = taille_donnees;
      memcpy (*breq, buffer, taille_donnees);
    }
  else
    {
      *breq = NULL;
      *treq = 0;
    }
};

int
STOCK::put_buffer (char c)
{
  if (taille_donnees + 1 > taille_reelle)
    expand (TAILLE_INIT);
  buffer[taille_donnees] = c;
  taille_donnees++;
};



int
STOCK::put_buffer (char *b, int i)
{
  if (taille_donnees + i > taille_reelle)
    expand (i + TAILLE_INIT);
  memcpy (&(buffer[taille_donnees]), b, i);
  taille_donnees += i;
};
