/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// $Id: def_texture.cpp,v 1.4 2006/12/21 18:18:14 atila Exp $
#define GL_GLEXT_PROTOTYPES
#include "def_texture.h"
#include "local_glu.h"
#include "win3d.h"
/**********************************************************
 *
 *		DESCRIPTEUR_TEXTURE
 *
 **********************************************************/

DESCRIPTEUR_TEXTURE::~DESCRIPTEUR_TEXTURE ()
{
};

void
DESCRIPTEUR_TEXTURE::RAZ ()
{
  nom = MOT ("");
  nom_fichier_gestion = MOT ("");
  blend_type = 0;
  blend = 255;
  nom_fichier_blending = MOT ("");
};

DESCRIPTEUR_TEXTURE::DESCRIPTEUR_TEXTURE ()
{
  RAZ ();
};

DESCRIPTEUR_TEXTURE::DESCRIPTEUR_TEXTURE (BUFFER_NOEUD * BF,
					  buffer_noeud * bn)
{
  // Remplissage tout bte...
  RAZ ();
  buffer_noeud *bn2;
  nom = BF->get_MOT (BF->trouve_suivant (bn, CONSTANTE_SCRIPT_FICHIER));

  if ((bn2 =
       BF->trouve_suivant (bn, CONSTANTE_SCRIPT_BLENDINGAPPROPRIE)) != NULL)
    {
      blend_type = 1;
      blend = 255;
    }
  else if ((bn2 = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_BLENDINGZERO)) !=
	   NULL)
    {
      blend_type = 2;
      blend = (int) BF->get_float (bn2);
    }
  else if ((bn2 = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_BLENDINGFIXE)) !=
	   NULL)
    {
      blend_type = 3;
      blend = (int) BF->get_float (bn2);
    }
  else if ((bn2 = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_BLENDINGFIXE2)) !=
	   NULL)
    {
      blend_type = 4;
      blend = (int) BF->get_float (bn2);
    }
  else if ((bn2 = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_BLENDINGFIXE3)) !=
	   NULL)
    {
      blend_type = 5;
      blend = (int) BF->get_float (bn2);
    }
  else if ((bn2 = BF->trouve_suivant (bn, CONSTANTE_SCRIPT_BLENDINGFICHIER))
	   != NULL)
    {
      blend_type = 6;
      nom_fichier_blending = BF->get_MOT (bn2);
    }
  else
    if ((bn2 =
	 BF->trouve_suivant (bn,
			     CONSTANTE_SCRIPT_BLENDINGFICHIERZERO)) != NULL)
    {
      blend_type = 7;
      blend = 128;
      nom_fichier_blending = BF->get_MOT (bn2);
    };
}

bool
DESCRIPTEUR_TEXTURE::operator== (DESCRIPTEUR_TEXTURE & d2)
{
  if ((nom == d2.nom) && (blend_type == d2.blend_type))
    {
      if (blend_type == 3)
	{
	  if (blend == d2.blend)
	    return true;
	  else
	    return false;
	}
      if (blend_type == 6)
	{
	  if (nom_fichier_blending == d2.nom_fichier_blending)
	    return true;
	  else
	    return false;
	}
      return true;
    }
  else
    return false;
};

/**********************************************************
 *
 *		ELEMENT_TEXTURE
 *
 **********************************************************/

bool
ELEMENT_TEXTURE::transparent ()
{
  return (descripteur.blend);
};

// Il FAUT exploiter le Blending ALPHA.
int
ELEMENT_TEXTURE::conversionRGB_24 ()
{
  unsigned char *nouveau_buffer =
    (unsigned char *) malloc(sizeof(unsigned char)*((TailleX+1) * (TailleY+1) * 4));
  unsigned char *buffer_tmp = nouveau_buffer;
  unsigned char *image_tmp = (unsigned char *) lptexture;
  for (int y = TailleX; y; y--)
    for (int x = TailleY; x; x--)
      {
	unsigned char r = (*image_tmp++);
	unsigned char g = (*image_tmp++);
	unsigned char b = (*image_tmp++);
	// ATTENTION : Bit de transparence  0 ii...
	(*buffer_tmp++) = 255 - r;
	(*buffer_tmp++) = 255 - g;
	(*buffer_tmp++) = 255 - b;
	(*buffer_tmp++) = 255;
      };
  free (lptexture);
  lptexture = (unsigned char *) nouveau_buffer;
  return 0;
};

GLuint
ELEMENT_TEXTURE::get_GLdesc ()
{
  return GLdesc;
};

bool
ELEMENT_TEXTURE::chek_ID (DESCRIPTEUR_TEXTURE & desc)
{
  return (descripteur == desc);
};


GLuint
ELEMENT_TEXTURE::chargement (DESCRIPTEUR_TEXTURE * desc, BDD * bdd)
{
  try
  {
    descripteur.nom.remplace_info (&desc->nom);
    descripteur.blend = desc->blend;
    descripteur.blend_type = desc->blend_type;
    lptexture = NULL;
    LoadFromPCXFile (&descripteur.nom, bdd);
    if (lptexture == NULL)
      throw (0);
    else
      conversionRGB_24 ();
    if (desc->blend_type != 0)
      {

	unsigned char *lpimage3 = NULL;
	// pour les fichiers avec blending disjoints ...
	ELEMENT_TEXTURE elem3;
	//printf("Chargement du fichier ... %s %i %i\n",desc->nom.info,desc->blend_type,desc->blend);
	if (desc->blend_type >= 6)
	  {
	    // il faut rcuprer l'info sur le blending; 
	    DESCRIPTEUR_TEXTURE desc2;
	    desc2.nom = desc->nom_fichier_blending;
	    desc2.blend_type = 0;
	    //printf("Avant bis\n");
	    elem3.chargement (&desc2, bdd);
	    //printf("APRES bis %i %i -- %i %i \n",elem3.TailleX,elem3.TailleY,TailleX,TailleY);
	    lpimage3 = elem3.lptexture;
	    if (lpimage3 == NULL)
	      throw (0);
	  };
	for (int j = 0; j < TailleX; j++)
	  for (int k = 0; k < TailleY; k++)
	    // traitement de base
	    {
	      int i = j + k * TailleX;
	      unsigned char R, G, B;
	      R = lptexture[i * 4];
	      G = lptexture[i * 4 + 1];
	      B = lptexture[i * 4 + 2];
	      bool noir = !(R || B || G);

	      int R2 = R, G2 = G, B2 = B;
	      int mo = (R2 + G2 + B2) / 3;
	      unsigned char moy = mo;

	      if (lpimage3)
		{
		  int i2, j2, k2;
		  j2 = ((long int) j) * elem3.TailleX / TailleX;
		  k2 = ((long int) k) * elem3.TailleY / TailleY;
		  i2 = (j2 * elem3.TailleX) + k2;
		  R = lpimage3[i2 * 4];
		  G = lpimage3[i2 * 4 + 1];
		  B = lpimage3[i2 * 4 + 2];
		  mo = ((int) R + (int) G + (int) B) / 3;
		}

	      switch (desc->blend_type)
		{
		case 1:
		  lptexture[i * 4 + 3] = 255 - (unsigned char) moy;
		  break;
		case 2:
		  if (noir)
		    lptexture[i * 4 + 3] = 0;
		  else
		    lptexture[i * 4 + 3] = desc->blend;
		  break;
		case 3:
		  lptexture[i * 4 + 3] = desc->blend;
		  break;
		case 4:
		  if (noir)
		    lptexture[i * 4 + 3] = 0;
		  else
		    lptexture[i * 4 + 3] = desc->blend;
		  break;
		case 5:
		  if (noir)
		    lptexture[i * 4 + 3] = desc->blend;
		  break;
		case 6:
		  lptexture[i * 4 + 3] = mo;
		  break;
		};
	    };
      };
  }
  catch (int)
  {
    printf
      ("Fichier texture non-trouv. Chargement fichier par dfaut '%s'\n",
       desc->nom.info);

    MOT not_found ("texture_not_found.pcx");
    LoadFromPCXFile (&not_found, bdd);
    if (!lptexture)
      {
	printf
	  ("ERREUR IRRECUPERABLE : FICHIER TEXTURE_NOT_FOUND.PCX NON-TROUVE ...\n ");
	exit (0);
      };
    conversionRGB_24 ();
  };

  // Cration d'objet OpenGL... (La, on sent la diffrence sur DX :) )
  glDisable (GL_TEXTURE);
  glGenTextures (1, &GLdesc);
  //printf("TEXTURE %i %s\n",GLdesc,desc->nom.info);
  glBindTexture (GL_TEXTURE_2D, GLdesc);

  //glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,TailleX,TailleY,0,GL_RGBA,GL_UNSIGNED_BYTE,lptexture);
  int ret = gluBuild2DMipmaps (GL_TEXTURE_2D, GL_RGBA, TailleX, TailleY,
			       GL_RGBA, GL_UNSIGNED_BYTE, lptexture);
  //printf("%s %i %i\n",desc->nom.info,ret,GLdesc);
  glEnable (GL_TEXTURE);
  return GLdesc;

};


typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;

void
stop (bool b, char *texte)
{
  if (b)
    {
      printf ("CRASH : PROBLEME CHARGEMENT DE FICHIERS PCX--- %s\n", texte);
      // exit (1);
    };
};

void
ELEMENT_TEXTURE::LoadFromPCXFile (MOT * filename, BDD * bdd)
{
  char *buffer_fichier;
  int ln;
  bdd->extrait_fichier_buffer (filename, &buffer_fichier, &ln);

  if (!buffer_fichier)
    return;

  int TX, TY;
  int bytes_per_pixel = 3;
  unsigned char *image = NULL;
  {
    struct
    {
      byte manufacturer, version, encoding, bits_per_pixel;
      word x0, y0, x1, y1, hdpi, vdpi;
      byte colormap[48];
      byte reserved, nplanes;
      word bytes_per_line;
      word palette_info;
      byte filler[70];
    } header;


    // recuperation de la taille du fichier
    unsigned long length_of_file = ln;
    stop (length_of_file < 128, "bitmap::LoadFromPCXFile - corrupted file 1");
    // lecture de l'entete
    memcpy (&header, buffer_fichier, 128);
    // mise a jour des valeurs
    TX = header.x1 - header.x0 + 1;
    TY = header.y1 - header.y0 + 1;
    bytes_per_pixel = header.nplanes;

    //    printf("TX %i TY %i\n",TX,TY);

    unsigned long remaining_size = length_of_file - 128;

    byte *image_rle = (byte*)malloc(sizeof(byte)*(remaining_size));
    stop (!image_rle, "bitmap::LoadFromPCXFile - image_rle - out of memory");
    memcpy (image_rle, &(buffer_fichier[128]), remaining_size);

    image = (byte*)malloc(sizeof(byte)*((TX+1) * (TY+1) * bytes_per_pixel));
    stop (!image, "bitmap::LoadFromPCXFile - image - out of memory");

    if (header.encoding)
      {
	byte *image_tmp = (byte *) image;
	byte *image_rle_tmp = image_rle;
	word y = TY;
	while (y--)
	  {
	    word plan = header.nplanes;
	    while (plan--)
	      {
		word x = 0;
		while (x < header.bytes_per_line)
		  {
		    stop (remaining_size == 0,
			  "bitmap::LoadFromPCXFile - corrupted file 2");
		    byte a = *image_rle_tmp++;
		    remaining_size--;
		    if (a > 0xc0)
		      {
			stop (remaining_size == 0,
			      "bitmap::LoadFromPCXFile - corrupted file 3");
			byte b = *image_rle_tmp++;
			remaining_size--;
			for (byte c = 0xc0; c < a; c++)
			  if (x++ < TX)
			    *image_tmp++ = b;
		      }
		    else if (x++ < TX)
		      *image_tmp++ = a;
		  }
	      }
	  }
      }
    else
      {
	//      stop(remaining_size < TX * TY * bytes_per_pixel,"bitmap::LoadFromPCXFile - corrupted file");
	memcpy (image, image_rle, TX * TY * bytes_per_pixel);
      }

    free(image_rle);

    if (header.nplanes == 3)
      {
	// reordonnancement de l'image R...RG...GB...B -> RGB...RGB
	byte *buffer = (byte*)malloc(sizeof(byte)*((TX+1) * header.nplanes));
	stop (!buffer, "bitmap::LoadFromPCXFile - buffer - out of memory");
	byte *image_tmp = (byte *) image;
	for (word y = TY; y; y--)
	  {
	    memcpy (buffer, image_tmp, TX * 3);
	    byte *buffer_tmp = buffer;
	    for (word x = TX; x; x--)
	      {
		*image_tmp++ = *buffer_tmp;
		*image_tmp++ = *(buffer_tmp + TX);
		*image_tmp++ = *(buffer_tmp + (TX << 1));
		buffer_tmp++;
	      }
	  }
	free(buffer);
      }
  }
  free(buffer_fichier);
  lptexture = image;
  TailleX = TX;
  TailleY = TY;
}

ELEMENT_TEXTURE::~ELEMENT_TEXTURE ()
{
  if (lptexture != NULL)
    free(lptexture);
  lptexture=NULL;
};

ELEMENT_TEXTURE::ELEMENT_TEXTURE ()
{
  lptexture = NULL;
  GLdesc = 0;
};

bool
ELEMENT_TEXTURE::operator== (void *data)
{
  DESCRIPTEUR_TEXTURE *data_desc = (DESCRIPTEUR_TEXTURE *) data;
  return (*data_desc == descripteur);
};

int
ELEMENT_TEXTURE::charge_avec_fichier (void *data, LPBLOCINFO lpblocinfo)
{
  chargement ((DESCRIPTEUR_TEXTURE *) data, lpblocinfo->lpbdd);
};

CLASSE_MODELE *
ELEMENT_TEXTURE::duplique_element ()
{
  // Rien de spcial, sinon passer un handler sur l'lment courant.
  // Cette fonction n'a au fond aucun intert et ne devrait jamais tre appel.
  // puisque la duplication des textures n'apporte rien !
  ELEMENT_TEXTURE *elem = new ELEMENT_TEXTURE ();
  *elem = *this;
  elem->lptexture = NULL;
  return elem;
};


/**********************************************************
 *
 *		BANQUE_TEXTURE
 *
 **********************************************************/


BANQUE_TEXTURE::BANQUE_TEXTURE ()
{
};

BANQUE_TEXTURE::~BANQUE_TEXTURE ()
{
};

GLuint
BANQUE_TEXTURE::trouve_texture (DESCRIPTEUR_TEXTURE * desc, BDD * bdd)
{
  return (trouve_texture_brutal (desc, bdd))->get_GLdesc ();
};

ELEMENT_TEXTURE *
BANQUE_TEXTURE::trouve_texture_brutal (DESCRIPTEUR_TEXTURE * desc, BDD * bdd)
{
  // Trouver ou charger puis renvoyer SANS COPIE !
  BLOCINFO bloc;
  bloc.lpbdd = bdd;
  ELEMENT_TEXTURE *elem;
  renvoie_element ((void *) desc, &bloc, &elem, false);
  return elem;
};

GLuint
  BANQUE_TEXTURE::trouve_texture (BDD * bdd, BUFFER_NOEUD * BF,
				  buffer_noeud * bn)
{
  DESCRIPTEUR_TEXTURE desc (BF, bn);
  return trouve_texture (&desc, bdd);
};

GLuint
  BANQUE_TEXTURE::trouve_texture (BDD * bdd, BUFFER_NOEUD * BF,
				  buffer_noeud * bn, bool & blend)
{
  DESCRIPTEUR_TEXTURE desc (BF, bn);
  blend = (desc.blend_type != 0);
  return trouve_texture (&desc, bdd);
};

bool
BANQUE_TEXTURE::texture_existe (DESCRIPTEUR_TEXTURE * desc, BDD * bdd)
{

}

void
BANQUE_TEXTURE::recharge ()
{
  nettoyage ();
}

/**********************************************************
 *
 *		ETAT_TEXTURE
 *
 **********************************************************/

ETAT_MULTITEXTURE::ETAT_MULTITEXTURE ()
{
  animation = 0;
  texture = 0;
  reflechie = false;
  actif = true;
  additif = false;
};

ETAT_MULTITEXTURE::~ETAT_MULTITEXTURE ()
{
};

ETAT_TEXTURE::ETAT_TEXTURE ()
{
  CST_OPENGL[0] = GL_TEXTURE0_ARB;
  CST_OPENGL[1] = GL_TEXTURE1_ARB;
  CST_OPENGL[2] = GL_TEXTURE2_ARB;
  CST_OPENGL[3] = GL_TEXTURE3_ARB;
  additif = false;
  ARB_actif = 0;
};

ETAT_TEXTURE::~ETAT_TEXTURE ()
{
};

void
ETAT_TEXTURE::init_etat_basique ()
{
  ETAT_MULTITEXTURE etat_actif;
  ETAT_MULTITEXTURE etat_inactif;
  etat_actif.actif = true;
  etat_actif.texture = 0;
  etat_actif.animation = 0;
  etat_actif.reflechie = false;
  etat_actif.additif = false;

  etat_inactif.actif = false;
  etat_inactif.texture = 0;
  etat_inactif.animation = 0;
  etat_inactif.reflechie = false;
  etat_inactif.additif = false;

  glActiveTextureARB_local (GL_TEXTURE0_ARB);
  glEnable (GL_TEXTURE_2D);
  glMatrixMode (GL_TEXTURE);
  glLoadIdentity ();
  glMatrixMode (GL_MODELVIEW);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		   GL_LINEAR_MIPMAP_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		   GL_LINEAR_MIPMAP_LINEAR);
  glDisable (GL_TEXTURE_GEN_S);
  glDisable (GL_TEXTURE_GEN_T);
  glTexEnvf (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);
  glBindTexture (GL_TEXTURE_2D, 0);

  glActiveTextureARB_local (GL_TEXTURE1_ARB);
  glEnable (GL_TEXTURE_2D);
  glMatrixMode (GL_TEXTURE);
  glLoadIdentity ();
  glMatrixMode (GL_MODELVIEW);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		   GL_LINEAR_MIPMAP_LINEAR);
  glTexParameteri (GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
		   GL_LINEAR_MIPMAP_LINEAR);
  glDisable (GL_TEXTURE_GEN_S);
  glDisable (GL_TEXTURE_GEN_T);
  glTexEnvf (GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glBindTexture (GL_TEXTURE_2D, 0);
  glDisable (GL_TEXTURE_2D);

  etat_multitexture[0] = etat_actif;
  etat_multitexture[1] = etat_inactif;

  glActiveTextureARB_local (GL_TEXTURE1_ARB);

  // BANQUES 2 ET 3 UNIQUEMENT SUR CARTES 3D HAUT-DE-GAMME.
  //active_etat(2,etat_inactif);
  //active_etat(3,etat_inactif);
};

void
ETAT_TEXTURE::active_etat (int numero, ETAT_MULTITEXTURE em)
{
  // C'est l que tout se joue.
  // L'essentiel est de minimiser le nombres de commandes OpenGL.
  // On vrifie donc l'tat actuel, puis on modifie en fonction de ce qui est demand.
//#define VERIF_NOMME if (nomme!=numero) {glActiveTextureARB(CST_OPENGL[numero]); nomme=numero;}
#define VERIF_NOMME {glActiveTextureARB_local(CST_OPENGL[numero]); nomme=numero;}
  int &nomme = ARB_actif;
  ETAT_MULTITEXTURE & etat = etat_multitexture[numero];
  if (em.actif)
    {
      if (!etat.actif)
	{
	  VERIF_NOMME;
	  glEnable (GL_TEXTURE_2D);
	  etat.actif = true;
	}
      // Si il y a  la fois Texture et Animation, on privilgie texture.
      if (em.texture)
	{
	  //printf("Texture %i %i\n",em.texture,etat.texture);
	  if (etat.animation)
	    {
	      VERIF_NOMME;
	      glMatrixMode (GL_TEXTURE);
	      glLoadIdentity ();
	      glMatrixMode (GL_MODELVIEW);
	      glBindTexture (GL_TEXTURE_2D, em.texture);
	    }
	  else if (etat.texture != em.texture)
	    {
	      VERIF_NOMME;
	      glBindTexture (GL_TEXTURE_2D, em.texture);
	    }
	  etat.texture = em.texture;
	  etat.animation = 0;
	}
      else
	{
	  // Si texture est absent, on suppose qu'il y a animation, sinon on ne fait rien.
	  if (em.animation)
	    {
	      VERIF_NOMME;
	      glCallList (em.animation);
	      etat.animation = em.animation;
	      etat.texture = 0;
	    };
	}
      // Vrification de texture rflchie.
      if ((em.reflechie) && (!etat.reflechie))
	{
	  VERIF_NOMME;
	  glEnable (GL_TEXTURE_GEN_S);
	  glEnable (GL_TEXTURE_GEN_T);
	  glTexGeni (GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	  glTexGeni (GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	  etat.reflechie = true;
	};
      if ((!em.reflechie) && (etat.reflechie))
	{
	  VERIF_NOMME;
	  glDisable (GL_TEXTURE_GEN_S);
	  glDisable (GL_TEXTURE_GEN_T);
	  etat.reflechie = false;
	};
      // Paramtre global
      if (additif && (em.additif))
	{
	  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	  additif = false;
	};
      if ((!additif) && (em.additif == 2))
	{
	  glBlendFunc (GL_ONE, GL_ONE);
	  additif = true;
	};
    }
  else
    {
      // Vrifier si il faut dsactiver.
      if (etat.actif)
	{
	  VERIF_NOMME;
	  glDisable (GL_TEXTURE_2D);
	  etat.actif = false;
	}
    };
#undef VERIF_NOMME
};

void
ETAT_TEXTURE::set_color (int numero, VALEUR_LUMIERE coul)
{
  glActiveTextureARB_local (CST_OPENGL[numero]);
  ARB_actif = numero;
  glColor4f (coul.R, coul.G, coul.B, 1.0 - coul.A);
};
